//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.1433
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Dss.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using W3C.Soap;
using compression = System.IO.Compression;
using constructor = Microsoft.Dss.Services.Constructor;
using contractmanager = Microsoft.Dss.Services.ContractManager;
using contractmodel = Microsoft.Dss.Services.ContractModel;
using drawing = System.Drawing;
using dssphttp = Microsoft.Dss.Core.DsspHttp;
using io = System.IO;
using pxrobocupgui = Microsoft.Robotics.Services.RoboCupGUI.Proxy;
using reflection = System.Reflection;


namespace Microsoft.Robotics.Services.RoboCupGUI.Proxy
{
    
    
    /// <summary>
    /// RoboCupGUI Contract
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public sealed class Contract
    {
        
        /// The Unique Contract Identifier for the RoboCupGUI service
        public const String Identifier = "http://schemas.microsoft.com/robotics/2008/01/robocupgui.html";
        
        /// The Dss Service dssModel Contract(s)
        public static List<contractmodel.ServiceSummary> ServiceModel()
        {
            contractmanager.ServiceSummaryLoader loader = new contractmanager.ServiceSummaryLoader();
            return loader.GetServiceSummaries(typeof(Contract).Assembly);

        }
        
        /// <summary>
        /// Creates an instance of the service associated with this contract
        /// </summary>
        /// <param name="contructorServicePort">Contractor Service that will create the instance</param>
        /// <param name="partners">Optional list of service partners for new service instance</param>
        /// <returns>Result PortSet for retrieving service creation response</returns>
        public static DsspResponsePort<CreateResponse> CreateService(constructor.ConstructorPort contructorServicePort, params PartnerType[] partners)
        {
            DsspResponsePort<CreateResponse> result = new DsspResponsePort<CreateResponse>();
            ServiceInfoType si = new ServiceInfoType(Contract.Identifier, null);
            if (partners != null)
            {
                si.PartnerList = new List<PartnerType>(partners);
            }
            Microsoft.Dss.Services.Constructor.Create create =
                new Microsoft.Dss.Services.Constructor.Create(si, result);
            contructorServicePort.Post(create);
            return result;

        }
        
        /// <summary>
        /// Creates an instance of the service associated with this contract
        /// </summary>
        /// <param name="contructorServicePort">Contractor Service that will create the instance</param>
        /// <returns>Result PortSet for retrieving service creation response</returns>
        public static DsspResponsePort<CreateResponse> CreateService(constructor.ConstructorPort contructorServicePort)
        {
            return Contract.CreateService(contructorServicePort, null);
        }
    }
    
    /// <summary>
    /// Robo CupGUI State
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("RoboCupGUIState", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class RoboCupGUIState : ICloneable, IDssSerializable
    {
        
        private Single _timeStamp;
        
        private Single _xPos;
        
        private Single _yPos;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        public Single TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// X Pos
        /// </summary>
        [DataMember()]
        public Single xPos
        {
            get
            {
                return this._xPos;
            }
            set
            {
                this._xPos = value;
            }
        }
        
        /// <summary>
        /// Y Pos
        /// </summary>
        [DataMember()]
        public Single yPos
        {
            get
            {
                return this._yPos;
            }
            set
            {
                this._yPos = value;
            }
        }
        
        /// <summary>
        /// Copy To Robo CupGUI State
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            RoboCupGUIState typedTarget = target as RoboCupGUIState;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.xPos = this.xPos;
            typedTarget.yPos = this.yPos;
        }
        
        /// <summary>
        /// Clone Robo CupGUI State
        /// </summary>
        public virtual object Clone()
        {
            RoboCupGUIState target = new RoboCupGUIState();

            target.TimeStamp = this.TimeStamp;
            target.xPos = this.xPos;
            target.yPos = this.yPos;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(TimeStamp);

            writer.Write(xPos);

            writer.Write(yPos);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = reader.ReadSingle();

            xPos = reader.ReadSingle();

            yPos = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// ConnectCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("ConnectCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class ConnectCMDRequest : ICloneable, IDssSerializable
    {
        
        private String _iP;
        
        private Int32 _gameBotPort;
        
        private Int32 _imgSvrPort;
        
        private Int32 _wssPort;
        
        /// <summary>
        /// IP
        /// </summary>
        [DataMember()]
        public String IP
        {
            get
            {
                return this._iP;
            }
            set
            {
                this._iP = value;
            }
        }
        
        /// <summary>
        /// Game Bot Port
        /// </summary>
        [DataMember()]
        public Int32 gameBotPort
        {
            get
            {
                return this._gameBotPort;
            }
            set
            {
                this._gameBotPort = value;
            }
        }
        
        /// <summary>
        /// Img Svr Port
        /// </summary>
        [DataMember()]
        public Int32 imgSvrPort
        {
            get
            {
                return this._imgSvrPort;
            }
            set
            {
                this._imgSvrPort = value;
            }
        }
        
        /// <summary>
        /// Wss Port
        /// </summary>
        [DataMember()]
        public Int32 wssPort
        {
            get
            {
                return this._wssPort;
            }
            set
            {
                this._wssPort = value;
            }
        }
        
        /// <summary>
        /// Copy To ConnectCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            ConnectCMDRequest typedTarget = target as ConnectCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.IP = this.IP;
            typedTarget.gameBotPort = this.gameBotPort;
            typedTarget.imgSvrPort = this.imgSvrPort;
            typedTarget.wssPort = this.wssPort;
        }
        
        /// <summary>
        /// Clone ConnectCMD Request
        /// </summary>
        public virtual object Clone()
        {
            ConnectCMDRequest target = new ConnectCMDRequest();

            target.IP = this.IP;
            target.gameBotPort = this.gameBotPort;
            target.imgSvrPort = this.imgSvrPort;
            target.wssPort = this.wssPort;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (IP == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(IP);
            }

            writer.Write(gameBotPort);

            writer.Write(imgSvrPort);

            writer.Write(wssPort);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                IP = reader.ReadString();
            } //nullable

            gameBotPort = reader.ReadInt32();

            imgSvrPort = reader.ReadInt32();

            wssPort = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// DisconnectCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("DisconnectCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class DisconnectCMDRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To DisconnectCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            DisconnectCMDRequest typedTarget = target as DisconnectCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone DisconnectCMD Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// Get PosesCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("GetPosesCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class GetPosesCMDRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To Get PosesCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            GetPosesCMDRequest typedTarget = target as GetPosesCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone Get PosesCMD Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// InitCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("InitCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class InitCMDRequest : ICloneable, IDssSerializable
    {
        
        private String _robot;
        
        private String _name;
        
        private String _location;
        
        private String _rotation;
        
        /// <summary>
        /// Robot
        /// </summary>
        [DataMember()]
        public String Robot
        {
            get
            {
                return this._robot;
            }
            set
            {
                this._robot = value;
            }
        }
        
        /// <summary>
        /// Name
        /// </summary>
        [DataMember()]
        public String Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        /// <summary>
        /// Location
        /// </summary>
        [DataMember()]
        public String Location
        {
            get
            {
                return this._location;
            }
            set
            {
                this._location = value;
            }
        }
        
        /// <summary>
        /// Rotation
        /// </summary>
        [DataMember()]
        public String Rotation
        {
            get
            {
                return this._rotation;
            }
            set
            {
                this._rotation = value;
            }
        }
        
        /// <summary>
        /// Copy To InitCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            InitCMDRequest typedTarget = target as InitCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Robot = this.Robot;
            typedTarget.Name = this.Name;
            typedTarget.Location = this.Location;
            typedTarget.Rotation = this.Rotation;
        }
        
        /// <summary>
        /// Clone InitCMD Request
        /// </summary>
        public virtual object Clone()
        {
            InitCMDRequest target = new InitCMDRequest();

            target.Robot = this.Robot;
            target.Name = this.Name;
            target.Location = this.Location;
            target.Rotation = this.Rotation;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Robot == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Robot);
            }

            if (Name == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Name);
            }

            if (Location == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Location);
            }

            if (Rotation == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Rotation);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                Robot = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Name = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Location = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Rotation = reader.ReadString();
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Drive AerialCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("DriveAerialCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class DriveAerialCMDRequest : ICloneable, IDssSerializable
    {
        
        private String _altitudeVelocity;
        
        private String _linearVelocity;
        
        private String _lateralVelocity;
        
        private String _rotationalVelocity;
        
        private Boolean _normalized;
        
        /// <summary>
        /// Altitude Velocity
        /// </summary>
        [DataMember()]
        public String AltitudeVelocity
        {
            get
            {
                return this._altitudeVelocity;
            }
            set
            {
                this._altitudeVelocity = value;
            }
        }
        
        /// <summary>
        /// Linear Velocity
        /// </summary>
        [DataMember()]
        public String LinearVelocity
        {
            get
            {
                return this._linearVelocity;
            }
            set
            {
                this._linearVelocity = value;
            }
        }
        
        /// <summary>
        /// Lateral Velocity
        /// </summary>
        [DataMember()]
        public String LateralVelocity
        {
            get
            {
                return this._lateralVelocity;
            }
            set
            {
                this._lateralVelocity = value;
            }
        }
        
        /// <summary>
        /// Rotational Velocity
        /// </summary>
        [DataMember()]
        public String RotationalVelocity
        {
            get
            {
                return this._rotationalVelocity;
            }
            set
            {
                this._rotationalVelocity = value;
            }
        }
        
        /// <summary>
        /// Normalized
        /// </summary>
        [DataMember()]
        public Boolean Normalized
        {
            get
            {
                return this._normalized;
            }
            set
            {
                this._normalized = value;
            }
        }
        
        /// <summary>
        /// Copy To Drive AerialCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            DriveAerialCMDRequest typedTarget = target as DriveAerialCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.AltitudeVelocity = this.AltitudeVelocity;
            typedTarget.LinearVelocity = this.LinearVelocity;
            typedTarget.LateralVelocity = this.LateralVelocity;
            typedTarget.RotationalVelocity = this.RotationalVelocity;
            typedTarget.Normalized = this.Normalized;
        }
        
        /// <summary>
        /// Clone Drive AerialCMD Request
        /// </summary>
        public virtual object Clone()
        {
            DriveAerialCMDRequest target = new DriveAerialCMDRequest();

            target.AltitudeVelocity = this.AltitudeVelocity;
            target.LinearVelocity = this.LinearVelocity;
            target.LateralVelocity = this.LateralVelocity;
            target.RotationalVelocity = this.RotationalVelocity;
            target.Normalized = this.Normalized;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (AltitudeVelocity == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(AltitudeVelocity);
            }

            if (LinearVelocity == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(LinearVelocity);
            }

            if (LateralVelocity == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(LateralVelocity);
            }

            if (RotationalVelocity == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(RotationalVelocity);
            }

            writer.Write(Normalized);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                AltitudeVelocity = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                LinearVelocity = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                LateralVelocity = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                RotationalVelocity = reader.ReadString();
            } //nullable

            Normalized = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// Mis PkgCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("MisPkgCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class MisPkgCMDRequest : ICloneable, IDssSerializable
    {
        
        private String _name;
        
        private List<LinkProperty> _link;
        
        /// <summary>
        /// Name
        /// </summary>
        [DataMember()]
        public String Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        /// <summary>
        /// Link
        /// </summary>
        [DataMember()]
        public List<LinkProperty> Link
        {
            get
            {
                return this._link;
            }
            set
            {
                this._link = value;
            }
        }
        
        /// <summary>
        /// Copy To Mis PkgCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            MisPkgCMDRequest typedTarget = target as MisPkgCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Name = this.Name;

            // copy IEnumerable System.Collections.Generic.List<LinkProperty> Link
            if (this.Link != null)
            {
                typedTarget.Link = new System.Collections.Generic.List<LinkProperty>();
                foreach(LinkProperty elem in Link)
                {
                    typedTarget.Link.Add((elem == null) ? null : (LinkProperty)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
        }
        
        /// <summary>
        /// Clone Mis PkgCMD Request
        /// </summary>
        public virtual object Clone()
        {
            MisPkgCMDRequest target = new MisPkgCMDRequest();

            target.Name = this.Name;

            // copy IEnumerable System.Collections.Generic.List<LinkProperty> Link
            if (this.Link != null)
            {
                target.Link = new System.Collections.Generic.List<LinkProperty>();
                foreach(LinkProperty elem in Link)
                {
                    target.Link.Add((elem == null) ? null : (LinkProperty)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Name == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Name);
            }

            if (Link == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(this.Link.Count);
                for(int index408850744 = 0; index408850744 < this.Link.Count; index408850744++)
                {
                    if (Link[index408850744] == null) writer.Write((byte)0);
                    else
                    {
                        // null flag
                        writer.Write((byte)1);

                        ((Microsoft.Dss.Core.IDssSerializable)Link[index408850744]).Serialize(writer);
                    }
                }
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                Name = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                int count408850744 = reader.ReadInt32();
                Link = new System.Collections.Generic.List<LinkProperty>();
                for(int index408850744 = 0; index408850744< count408850744; index408850744++)
                {
                    Link.Add(null);
                    if (reader.ReadByte() == 0) {}
                    else
                    {
                        Link[index408850744] = (LinkProperty)((Microsoft.Dss.Core.IDssSerializable)new LinkProperty()).Deserialize(reader);
                    } //nullable
                }
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Img Svr CamCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("ImgSvrCamCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class ImgSvrCamCMDRequest : ICloneable, IDssSerializable
    {
        
        private String _robotName;
        
        private String _camName;
        
        private String _iP;
        
        /// <summary>
        /// Robot Name
        /// </summary>
        [DataMember()]
        public String RobotName
        {
            get
            {
                return this._robotName;
            }
            set
            {
                this._robotName = value;
            }
        }
        
        /// <summary>
        /// Cam Name
        /// </summary>
        [DataMember()]
        public String CamName
        {
            get
            {
                return this._camName;
            }
            set
            {
                this._camName = value;
            }
        }
        
        /// <summary>
        /// IP
        /// </summary>
        [DataMember()]
        public String IP
        {
            get
            {
                return this._iP;
            }
            set
            {
                this._iP = value;
            }
        }
        
        /// <summary>
        /// Copy To Img Svr CamCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            ImgSvrCamCMDRequest typedTarget = target as ImgSvrCamCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.RobotName = this.RobotName;
            typedTarget.CamName = this.CamName;
            typedTarget.IP = this.IP;
        }
        
        /// <summary>
        /// Clone Img Svr CamCMD Request
        /// </summary>
        public virtual object Clone()
        {
            ImgSvrCamCMDRequest target = new ImgSvrCamCMDRequest();

            target.RobotName = this.RobotName;
            target.CamName = this.CamName;
            target.IP = this.IP;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (RobotName == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(RobotName);
            }

            if (CamName == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(CamName);
            }

            if (IP == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(IP);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                RobotName = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                CamName = reader.ReadString();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                IP = reader.ReadString();
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Img SvrOKCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("ImgSvrOKCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class ImgSvrOKCMDRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To Img SvrOKCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            ImgSvrOKCMDRequest typedTarget = target as ImgSvrOKCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone Img SvrOKCMD Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// WaypointCMD Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("WaypointCMDRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class WaypointCMDRequest : ICloneable, IDssSerializable
    {
        
        private RoboCupGUIState _gPS;
        
        /// <summary>
        /// GPS
        /// </summary>
        [DataMember()]
        public RoboCupGUIState GPS
        {
            get
            {
                return this._gPS;
            }
            set
            {
                this._gPS = value;
            }
        }
        
        /// <summary>
        /// Copy To WaypointCMD Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            WaypointCMDRequest typedTarget = target as WaypointCMDRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.GPS = (this.GPS == null) ? null : (RoboCupGUIState)((Microsoft.Dss.Core.IDssSerializable)this.GPS).Clone();
        }
        
        /// <summary>
        /// Clone WaypointCMD Request
        /// </summary>
        public virtual object Clone()
        {
            WaypointCMDRequest target = new WaypointCMDRequest();

            target.GPS = (this.GPS == null) ? null : (RoboCupGUIState)((Microsoft.Dss.Core.IDssSerializable)this.GPS).Clone();
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (GPS == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)GPS).Serialize(writer);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                GPS = (RoboCupGUIState)((Microsoft.Dss.Core.IDssSerializable)new RoboCupGUIState()).Deserialize(reader);
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// ConnectedMSG Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("ConnectedMSGRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class ConnectedMSGRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To ConnectedMSG Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            ConnectedMSGRequest typedTarget = target as ConnectedMSGRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone ConnectedMSG Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// Start PosesMSG Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("StartPosesMSGRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class StartPosesMSGRequest : ICloneable, IDssSerializable
    {
        
        private List<StartPoses> _startPoses;
        
        /// <summary>
        /// Start Poses
        /// </summary>
        [DataMember()]
        public List<StartPoses> startPoses
        {
            get
            {
                return this._startPoses;
            }
            set
            {
                this._startPoses = value;
            }
        }
        
        /// <summary>
        /// Copy To Start PosesMSG Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            StartPosesMSGRequest typedTarget = target as StartPosesMSGRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);

            // copy IEnumerable System.Collections.Generic.List<StartPoses> startPoses
            if (this.startPoses != null)
            {
                typedTarget.startPoses = new System.Collections.Generic.List<StartPoses>();
                foreach(StartPoses elem in startPoses)
                {
                    typedTarget.startPoses.Add((elem == null) ? null : (StartPoses)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
        }
        
        /// <summary>
        /// Clone Start PosesMSG Request
        /// </summary>
        public virtual object Clone()
        {
            StartPosesMSGRequest target = new StartPosesMSGRequest();


            // copy IEnumerable System.Collections.Generic.List<StartPoses> startPoses
            if (this.startPoses != null)
            {
                target.startPoses = new System.Collections.Generic.List<StartPoses>();
                foreach(StartPoses elem in startPoses)
                {
                    target.startPoses.Add((elem == null) ? null : (StartPoses)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (startPoses == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(this.startPoses.Count);
                for(int index1982740200 = 0; index1982740200 < this.startPoses.Count; index1982740200++)
                {
                    if (startPoses[index1982740200] == null) writer.Write((byte)0);
                    else
                    {
                        // null flag
                        writer.Write((byte)1);

                        ((Microsoft.Dss.Core.IDssSerializable)startPoses[index1982740200]).Serialize(writer);
                    }
                }
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                int count1982740200 = reader.ReadInt32();
                startPoses = new System.Collections.Generic.List<StartPoses>();
                for(int index1982740200 = 0; index1982740200< count1982740200; index1982740200++)
                {
                    startPoses.Add(null);
                    if (reader.ReadByte() == 0) {}
                    else
                    {
                        startPoses[index1982740200] = (StartPoses)((Microsoft.Dss.Core.IDssSerializable)new StartPoses()).Deserialize(reader);
                    } //nullable
                }
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// InitializedMSG Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("InitializedMSGRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class InitializedMSGRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To InitializedMSG Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            InitializedMSGRequest typedTarget = target as InitializedMSGRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone InitializedMSG Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// StaMSG Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("StaMSGRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class StaMSGRequest : ICloneable, IDssSerializable
    {
        
        private BotStatus _botStatus;
        
        /// <summary>
        /// Bot Status
        /// </summary>
        [DataMember()]
        public BotStatus botStatus
        {
            get
            {
                return this._botStatus;
            }
            set
            {
                this._botStatus = value;
            }
        }
        
        /// <summary>
        /// Copy To StaMSG Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            StaMSGRequest typedTarget = target as StaMSGRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.botStatus = (this.botStatus == null) ? null : (BotStatus)((Microsoft.Dss.Core.IDssSerializable)this.botStatus).Clone();
        }
        
        /// <summary>
        /// Clone StaMSG Request
        /// </summary>
        public virtual object Clone()
        {
            StaMSGRequest target = new StaMSGRequest();

            target.botStatus = (this.botStatus == null) ? null : (BotStatus)((Microsoft.Dss.Core.IDssSerializable)this.botStatus).Clone();
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (botStatus == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)botStatus).Serialize(writer);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                botStatus = (BotStatus)((Microsoft.Dss.Core.IDssSerializable)new BotStatus()).Deserialize(reader);
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// GPSMSG Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("GPSMSGRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class GPSMSGRequest : ICloneable, IDssSerializable
    {
        
        private GPS _gps;
        
        /// <summary>
        /// Gps
        /// </summary>
        [DataMember()]
        public GPS gps
        {
            get
            {
                return this._gps;
            }
            set
            {
                this._gps = value;
            }
        }
        
        /// <summary>
        /// Copy To GPSMSG Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            GPSMSGRequest typedTarget = target as GPSMSGRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.gps = (this.gps == null) ? null : (GPS)((Microsoft.Dss.Core.IDssSerializable)this.gps).Clone();
        }
        
        /// <summary>
        /// Clone GPSMSG Request
        /// </summary>
        public virtual object Clone()
        {
            GPSMSGRequest target = new GPSMSGRequest();

            target.gps = (this.gps == null) ? null : (GPS)((Microsoft.Dss.Core.IDssSerializable)this.gps).Clone();
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (gps == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)gps).Serialize(writer);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                gps = (GPS)((Microsoft.Dss.Core.IDssSerializable)new GPS()).Deserialize(reader);
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// ImageMSG Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("ImageMSGRequest", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class ImageMSGRequest : ICloneable, IDssSerializable
    {
        
        private drawing.Image _jPEG;
        
        private Boolean _valid;
        
        /// <summary>
        /// JPEG
        /// </summary>
        [DataMember()]
        public drawing.Image JPEG
        {
            get
            {
                return this._jPEG;
            }
            set
            {
                this._jPEG = value;
            }
        }
        
        /// <summary>
        /// Valid
        /// </summary>
        [DataMember()]
        public Boolean Valid
        {
            get
            {
                return this._valid;
            }
            set
            {
                this._valid = value;
            }
        }
        
        /// <summary>
        /// Copy To ImageMSG Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            ImageMSGRequest typedTarget = target as ImageMSGRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.JPEG = (this.JPEG == null) ? null : (System.Drawing.Image)((System.ICloneable)this.JPEG).Clone();
            typedTarget.Valid = this.Valid;
        }
        
        /// <summary>
        /// Clone ImageMSG Request
        /// </summary>
        public virtual object Clone()
        {
            ImageMSGRequest target = new ImageMSGRequest();

            target.JPEG = (this.JPEG == null) ? null : (System.Drawing.Image)((System.ICloneable)this.JPEG).Clone();
            target.Valid = this.Valid;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (JPEG == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeAsXml(writer,JPEG);
            }

            writer.Write(Valid);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                JPEG = (System.Drawing.Image)Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeXml(reader,typeof(System.Drawing.Image));
            } //nullable

            Valid = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// GPS
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("GPS", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class GPS : ICloneable, IDssSerializable
    {
        
        private Single _timeStamp;
        
        private String _name;
        
        private Int32 _latitudeDegrees;
        
        private Single _latitudeMinutes;
        
        private Char _latitudeCardinal;
        
        private Int32 _longitudeDegrees;
        
        private Single _longitudeMinutes;
        
        private Char _longitudeCardinal;
        
        private Int32 _fix;
        
        private Int32 _satellites;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        public Single TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Name
        /// </summary>
        [DataMember()]
        public String Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        /// <summary>
        /// Latitude Degrees
        /// </summary>
        [DataMember()]
        public Int32 LatitudeDegrees
        {
            get
            {
                return this._latitudeDegrees;
            }
            set
            {
                this._latitudeDegrees = value;
            }
        }
        
        /// <summary>
        /// Latitude Minutes
        /// </summary>
        [DataMember()]
        public Single LatitudeMinutes
        {
            get
            {
                return this._latitudeMinutes;
            }
            set
            {
                this._latitudeMinutes = value;
            }
        }
        
        /// <summary>
        /// Latitude Cardinal
        /// </summary>
        [DataMember()]
        public Char LatitudeCardinal
        {
            get
            {
                return this._latitudeCardinal;
            }
            set
            {
                this._latitudeCardinal = value;
            }
        }
        
        /// <summary>
        /// Longitude Degrees
        /// </summary>
        [DataMember()]
        public Int32 LongitudeDegrees
        {
            get
            {
                return this._longitudeDegrees;
            }
            set
            {
                this._longitudeDegrees = value;
            }
        }
        
        /// <summary>
        /// Longitude Minutes
        /// </summary>
        [DataMember()]
        public Single LongitudeMinutes
        {
            get
            {
                return this._longitudeMinutes;
            }
            set
            {
                this._longitudeMinutes = value;
            }
        }
        
        /// <summary>
        /// Longitude Cardinal
        /// </summary>
        [DataMember()]
        public Char LongitudeCardinal
        {
            get
            {
                return this._longitudeCardinal;
            }
            set
            {
                this._longitudeCardinal = value;
            }
        }
        
        /// <summary>
        /// Fix
        /// </summary>
        [DataMember()]
        public Int32 Fix
        {
            get
            {
                return this._fix;
            }
            set
            {
                this._fix = value;
            }
        }
        
        /// <summary>
        /// Satellites
        /// </summary>
        [DataMember()]
        public Int32 Satellites
        {
            get
            {
                return this._satellites;
            }
            set
            {
                this._satellites = value;
            }
        }
        
        /// <summary>
        /// Copy To GPS
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            GPS typedTarget = target as GPS;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.Name = this.Name;
            typedTarget.LatitudeDegrees = this.LatitudeDegrees;
            typedTarget.LatitudeMinutes = this.LatitudeMinutes;
            typedTarget.LatitudeCardinal = this.LatitudeCardinal;
            typedTarget.LongitudeDegrees = this.LongitudeDegrees;
            typedTarget.LongitudeMinutes = this.LongitudeMinutes;
            typedTarget.LongitudeCardinal = this.LongitudeCardinal;
            typedTarget.Fix = this.Fix;
            typedTarget.Satellites = this.Satellites;
        }
        
        /// <summary>
        /// Clone GPS
        /// </summary>
        public virtual object Clone()
        {
            GPS target = new GPS();

            target.TimeStamp = this.TimeStamp;
            target.Name = this.Name;
            target.LatitudeDegrees = this.LatitudeDegrees;
            target.LatitudeMinutes = this.LatitudeMinutes;
            target.LatitudeCardinal = this.LatitudeCardinal;
            target.LongitudeDegrees = this.LongitudeDegrees;
            target.LongitudeMinutes = this.LongitudeMinutes;
            target.LongitudeCardinal = this.LongitudeCardinal;
            target.Fix = this.Fix;
            target.Satellites = this.Satellites;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(TimeStamp);

            if (Name == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Name);
            }

            writer.Write(LatitudeDegrees);

            writer.Write(LatitudeMinutes);

            writer.Write(LatitudeCardinal);

            writer.Write(LongitudeDegrees);

            writer.Write(LongitudeMinutes);

            writer.Write(LongitudeCardinal);

            writer.Write(Fix);

            writer.Write(Satellites);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = reader.ReadSingle();

            if (reader.ReadByte() == 0) {}
            else
            {
                Name = reader.ReadString();
            } //nullable

            LatitudeDegrees = reader.ReadInt32();

            LatitudeMinutes = reader.ReadSingle();

            LatitudeCardinal = reader.ReadChar();

            LongitudeDegrees = reader.ReadInt32();

            LongitudeMinutes = reader.ReadSingle();

            LongitudeCardinal = reader.ReadChar();

            Fix = reader.ReadInt32();

            Satellites = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// Ground Truth
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("GroundTruth", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class GroundTruth : ICloneable, IDssSerializable
    {
        
        private Single _timeStamp;
        
        private String _name;
        
        private Single _xPos;
        
        private Single _yPos;
        
        private Single _zPos;
        
        private Single _xRot;
        
        private Single _yRot;
        
        private Single _zRot;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        public Single TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Name
        /// </summary>
        [DataMember()]
        public String Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        /// <summary>
        /// X Pos
        /// </summary>
        [DataMember()]
        public Single xPos
        {
            get
            {
                return this._xPos;
            }
            set
            {
                this._xPos = value;
            }
        }
        
        /// <summary>
        /// Y Pos
        /// </summary>
        [DataMember()]
        public Single yPos
        {
            get
            {
                return this._yPos;
            }
            set
            {
                this._yPos = value;
            }
        }
        
        /// <summary>
        /// Z Pos
        /// </summary>
        [DataMember()]
        public Single zPos
        {
            get
            {
                return this._zPos;
            }
            set
            {
                this._zPos = value;
            }
        }
        
        /// <summary>
        /// X Rot
        /// </summary>
        [DataMember()]
        public Single xRot
        {
            get
            {
                return this._xRot;
            }
            set
            {
                this._xRot = value;
            }
        }
        
        /// <summary>
        /// Y Rot
        /// </summary>
        [DataMember()]
        public Single yRot
        {
            get
            {
                return this._yRot;
            }
            set
            {
                this._yRot = value;
            }
        }
        
        /// <summary>
        /// Z Rot
        /// </summary>
        [DataMember()]
        public Single zRot
        {
            get
            {
                return this._zRot;
            }
            set
            {
                this._zRot = value;
            }
        }
        
        /// <summary>
        /// Copy To Ground Truth
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            GroundTruth typedTarget = target as GroundTruth;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.Name = this.Name;
            typedTarget.xPos = this.xPos;
            typedTarget.yPos = this.yPos;
            typedTarget.zPos = this.zPos;
            typedTarget.xRot = this.xRot;
            typedTarget.yRot = this.yRot;
            typedTarget.zRot = this.zRot;
        }
        
        /// <summary>
        /// Clone Ground Truth
        /// </summary>
        public virtual object Clone()
        {
            GroundTruth target = new GroundTruth();

            target.TimeStamp = this.TimeStamp;
            target.Name = this.Name;
            target.xPos = this.xPos;
            target.yPos = this.yPos;
            target.zPos = this.zPos;
            target.xRot = this.xRot;
            target.yRot = this.yRot;
            target.zRot = this.zRot;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(TimeStamp);

            if (Name == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Name);
            }

            writer.Write(xPos);

            writer.Write(yPos);

            writer.Write(zPos);

            writer.Write(xRot);

            writer.Write(yRot);

            writer.Write(zRot);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = reader.ReadSingle();

            if (reader.ReadByte() == 0) {}
            else
            {
                Name = reader.ReadString();
            } //nullable

            xPos = reader.ReadSingle();

            yPos = reader.ReadSingle();

            zPos = reader.ReadSingle();

            xRot = reader.ReadSingle();

            yRot = reader.ReadSingle();

            zRot = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Link Property
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("LinkProperty", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class LinkProperty : ICloneable, IDssSerializable
    {
        
        private Int32 _iD;
        
        private String _type;
        
        private Single _maxSpeed;
        
        private Single _maxTorque;
        
        private Single _minRange;
        
        private Single _maxRange;
        
        private Single _currVal;
        
        private Single _currTorque;
        
        private Single _desiredVal;
        
        private Int32 _desiredOrder;
        
        /// <summary>
        /// ID
        /// </summary>
        [DataMember()]
        public Int32 ID
        {
            get
            {
                return this._iD;
            }
            set
            {
                this._iD = value;
            }
        }
        
        /// <summary>
        /// Type
        /// </summary>
        [DataMember()]
        public String Type
        {
            get
            {
                return this._type;
            }
            set
            {
                this._type = value;
            }
        }
        
        /// <summary>
        /// Max Speed
        /// </summary>
        [DataMember()]
        public Single MaxSpeed
        {
            get
            {
                return this._maxSpeed;
            }
            set
            {
                this._maxSpeed = value;
            }
        }
        
        /// <summary>
        /// Max Torque
        /// </summary>
        [DataMember()]
        public Single MaxTorque
        {
            get
            {
                return this._maxTorque;
            }
            set
            {
                this._maxTorque = value;
            }
        }
        
        /// <summary>
        /// Min Range
        /// </summary>
        [DataMember()]
        public Single MinRange
        {
            get
            {
                return this._minRange;
            }
            set
            {
                this._minRange = value;
            }
        }
        
        /// <summary>
        /// Max Range
        /// </summary>
        [DataMember()]
        public Single MaxRange
        {
            get
            {
                return this._maxRange;
            }
            set
            {
                this._maxRange = value;
            }
        }
        
        /// <summary>
        /// Curr Val
        /// </summary>
        [DataMember()]
        public Single CurrVal
        {
            get
            {
                return this._currVal;
            }
            set
            {
                this._currVal = value;
            }
        }
        
        /// <summary>
        /// Curr Torque
        /// </summary>
        [DataMember()]
        public Single CurrTorque
        {
            get
            {
                return this._currTorque;
            }
            set
            {
                this._currTorque = value;
            }
        }
        
        /// <summary>
        /// Desired Val
        /// </summary>
        [DataMember()]
        public Single DesiredVal
        {
            get
            {
                return this._desiredVal;
            }
            set
            {
                this._desiredVal = value;
            }
        }
        
        /// <summary>
        /// Desired Order
        /// </summary>
        [DataMember()]
        public Int32 DesiredOrder
        {
            get
            {
                return this._desiredOrder;
            }
            set
            {
                this._desiredOrder = value;
            }
        }
        
        /// <summary>
        /// Copy To Link Property
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            LinkProperty typedTarget = target as LinkProperty;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.ID = this.ID;
            typedTarget.Type = this.Type;
            typedTarget.MaxSpeed = this.MaxSpeed;
            typedTarget.MaxTorque = this.MaxTorque;
            typedTarget.MinRange = this.MinRange;
            typedTarget.MaxRange = this.MaxRange;
            typedTarget.CurrVal = this.CurrVal;
            typedTarget.CurrTorque = this.CurrTorque;
            typedTarget.DesiredVal = this.DesiredVal;
            typedTarget.DesiredOrder = this.DesiredOrder;
        }
        
        /// <summary>
        /// Clone Link Property
        /// </summary>
        public virtual object Clone()
        {
            LinkProperty target = new LinkProperty();

            target.ID = this.ID;
            target.Type = this.Type;
            target.MaxSpeed = this.MaxSpeed;
            target.MaxTorque = this.MaxTorque;
            target.MinRange = this.MinRange;
            target.MaxRange = this.MaxRange;
            target.CurrVal = this.CurrVal;
            target.CurrTorque = this.CurrTorque;
            target.DesiredVal = this.DesiredVal;
            target.DesiredOrder = this.DesiredOrder;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(ID);

            if (Type == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Type);
            }

            writer.Write(MaxSpeed);

            writer.Write(MaxTorque);

            writer.Write(MinRange);

            writer.Write(MaxRange);

            writer.Write(CurrVal);

            writer.Write(CurrTorque);

            writer.Write(DesiredVal);

            writer.Write(DesiredOrder);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            ID = reader.ReadInt32();

            if (reader.ReadByte() == 0) {}
            else
            {
                Type = reader.ReadString();
            } //nullable

            MaxSpeed = reader.ReadSingle();

            MaxTorque = reader.ReadSingle();

            MinRange = reader.ReadSingle();

            MaxRange = reader.ReadSingle();

            CurrVal = reader.ReadSingle();

            CurrTorque = reader.ReadSingle();

            DesiredVal = reader.ReadSingle();

            DesiredOrder = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// Mis Status
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("MisStatus", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class MisStatus : ICloneable, IDssSerializable
    {
        
        private String _name;
        
        private Single _timeStamp;
        
        private List<LinkProperty> _link;
        
        /// <summary>
        /// Name
        /// </summary>
        [DataMember()]
        public String Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        public Single TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Link
        /// </summary>
        [DataMember()]
        public List<LinkProperty> Link
        {
            get
            {
                return this._link;
            }
            set
            {
                this._link = value;
            }
        }
        
        /// <summary>
        /// Copy To Mis Status
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            MisStatus typedTarget = target as MisStatus;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Name = this.Name;
            typedTarget.TimeStamp = this.TimeStamp;

            // copy IEnumerable System.Collections.Generic.List<LinkProperty> Link
            if (this.Link != null)
            {
                typedTarget.Link = new System.Collections.Generic.List<LinkProperty>();
                foreach(LinkProperty elem in Link)
                {
                    typedTarget.Link.Add((elem == null) ? null : (LinkProperty)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
        }
        
        /// <summary>
        /// Clone Mis Status
        /// </summary>
        public virtual object Clone()
        {
            MisStatus target = new MisStatus();

            target.Name = this.Name;
            target.TimeStamp = this.TimeStamp;

            // copy IEnumerable System.Collections.Generic.List<LinkProperty> Link
            if (this.Link != null)
            {
                target.Link = new System.Collections.Generic.List<LinkProperty>();
                foreach(LinkProperty elem in Link)
                {
                    target.Link.Add((elem == null) ? null : (LinkProperty)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Name == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Name);
            }

            writer.Write(TimeStamp);

            if (Link == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(this.Link.Count);
                for(int index408850744 = 0; index408850744 < this.Link.Count; index408850744++)
                {
                    if (Link[index408850744] == null) writer.Write((byte)0);
                    else
                    {
                        // null flag
                        writer.Write((byte)1);

                        ((Microsoft.Dss.Core.IDssSerializable)Link[index408850744]).Serialize(writer);
                    }
                }
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                Name = reader.ReadString();
            } //nullable

            TimeStamp = reader.ReadSingle();

            if (reader.ReadByte() == 0) {}
            else
            {
                int count408850744 = reader.ReadInt32();
                Link = new System.Collections.Generic.List<LinkProperty>();
                for(int index408850744 = 0; index408850744< count408850744; index408850744++)
                {
                    Link.Add(null);
                    if (reader.ReadByte() == 0) {}
                    else
                    {
                        Link[index408850744] = (LinkProperty)((Microsoft.Dss.Core.IDssSerializable)new LinkProperty()).Deserialize(reader);
                    } //nullable
                }
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Start Poses
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("StartPoses", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class StartPoses : ICloneable, IDssSerializable
    {
        
        private String _name;
        
        private Single _xPos;
        
        private Single _yPos;
        
        private Single _zPos;
        
        private Single _xRot;
        
        private Single _yRot;
        
        private Single _zRot;
        
        /// <summary>
        /// Name
        /// </summary>
        [DataMember()]
        public String Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        /// <summary>
        /// X Pos
        /// </summary>
        [DataMember()]
        public Single xPos
        {
            get
            {
                return this._xPos;
            }
            set
            {
                this._xPos = value;
            }
        }
        
        /// <summary>
        /// Y Pos
        /// </summary>
        [DataMember()]
        public Single yPos
        {
            get
            {
                return this._yPos;
            }
            set
            {
                this._yPos = value;
            }
        }
        
        /// <summary>
        /// Z Pos
        /// </summary>
        [DataMember()]
        public Single zPos
        {
            get
            {
                return this._zPos;
            }
            set
            {
                this._zPos = value;
            }
        }
        
        /// <summary>
        /// X Rot
        /// </summary>
        [DataMember()]
        public Single xRot
        {
            get
            {
                return this._xRot;
            }
            set
            {
                this._xRot = value;
            }
        }
        
        /// <summary>
        /// Y Rot
        /// </summary>
        [DataMember()]
        public Single yRot
        {
            get
            {
                return this._yRot;
            }
            set
            {
                this._yRot = value;
            }
        }
        
        /// <summary>
        /// Z Rot
        /// </summary>
        [DataMember()]
        public Single zRot
        {
            get
            {
                return this._zRot;
            }
            set
            {
                this._zRot = value;
            }
        }
        
        /// <summary>
        /// Copy To Start Poses
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            StartPoses typedTarget = target as StartPoses;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Name = this.Name;
            typedTarget.xPos = this.xPos;
            typedTarget.yPos = this.yPos;
            typedTarget.zPos = this.zPos;
            typedTarget.xRot = this.xRot;
            typedTarget.yRot = this.yRot;
            typedTarget.zRot = this.zRot;
        }
        
        /// <summary>
        /// Clone Start Poses
        /// </summary>
        public virtual object Clone()
        {
            StartPoses target = new StartPoses();

            target.Name = this.Name;
            target.xPos = this.xPos;
            target.yPos = this.yPos;
            target.zPos = this.zPos;
            target.xRot = this.xRot;
            target.yRot = this.yRot;
            target.zRot = this.zRot;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Name == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Name);
            }

            writer.Write(xPos);

            writer.Write(yPos);

            writer.Write(zPos);

            writer.Write(xRot);

            writer.Write(yRot);

            writer.Write(zRot);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                Name = reader.ReadString();
            } //nullable

            xPos = reader.ReadSingle();

            yPos = reader.ReadSingle();

            zPos = reader.ReadSingle();

            xRot = reader.ReadSingle();

            yRot = reader.ReadSingle();

            zRot = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Bot Status
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("BotStatus", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class BotStatus : ICloneable, IDssSerializable
    {
        
        private String _type;
        
        private Single _timeStamp;
        
        private Boolean _lightOn;
        
        private Single _lightIntensity;
        
        private Int32 _battery;
        
        private Int32 _viewNum;
        
        /// <summary>
        /// Type
        /// </summary>
        [DataMember()]
        public String Type
        {
            get
            {
                return this._type;
            }
            set
            {
                this._type = value;
            }
        }
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        public Single TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Light On
        /// </summary>
        [DataMember()]
        public Boolean LightOn
        {
            get
            {
                return this._lightOn;
            }
            set
            {
                this._lightOn = value;
            }
        }
        
        /// <summary>
        /// Light Intensity
        /// </summary>
        [DataMember()]
        public Single LightIntensity
        {
            get
            {
                return this._lightIntensity;
            }
            set
            {
                this._lightIntensity = value;
            }
        }
        
        /// <summary>
        /// Battery
        /// </summary>
        [DataMember()]
        public Int32 Battery
        {
            get
            {
                return this._battery;
            }
            set
            {
                this._battery = value;
            }
        }
        
        /// <summary>
        /// View Num
        /// </summary>
        [DataMember()]
        public Int32 ViewNum
        {
            get
            {
                return this._viewNum;
            }
            set
            {
                this._viewNum = value;
            }
        }
        
        /// <summary>
        /// Copy To Bot Status
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            BotStatus typedTarget = target as BotStatus;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Type = this.Type;
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.LightOn = this.LightOn;
            typedTarget.LightIntensity = this.LightIntensity;
            typedTarget.Battery = this.Battery;
            typedTarget.ViewNum = this.ViewNum;
        }
        
        /// <summary>
        /// Clone Bot Status
        /// </summary>
        public virtual object Clone()
        {
            BotStatus target = new BotStatus();

            target.Type = this.Type;
            target.TimeStamp = this.TimeStamp;
            target.LightOn = this.LightOn;
            target.LightIntensity = this.LightIntensity;
            target.Battery = this.Battery;
            target.ViewNum = this.ViewNum;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Type == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(Type);
            }

            writer.Write(TimeStamp);

            writer.Write(LightOn);

            writer.Write(LightIntensity);

            writer.Write(Battery);

            writer.Write(ViewNum);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                Type = reader.ReadString();
            } //nullable

            TimeStamp = reader.ReadSingle();

            LightOn = reader.ReadBoolean();

            LightIntensity = reader.ReadSingle();

            Battery = reader.ReadInt32();

            ViewNum = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// Victim Loc
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("VictimLoc", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class VictimLoc : ICloneable, IDssSerializable
    {
        
        private Int32 _row;
        
        private Int32 _col;
        
        private Single _xPos;
        
        private Single _yPos;
        
        /// <summary>
        /// Row
        /// </summary>
        [DataMember()]
        public Int32 Row
        {
            get
            {
                return this._row;
            }
            set
            {
                this._row = value;
            }
        }
        
        /// <summary>
        /// Col
        /// </summary>
        [DataMember()]
        public Int32 Col
        {
            get
            {
                return this._col;
            }
            set
            {
                this._col = value;
            }
        }
        
        /// <summary>
        /// X Pos
        /// </summary>
        [DataMember()]
        public Single xPos
        {
            get
            {
                return this._xPos;
            }
            set
            {
                this._xPos = value;
            }
        }
        
        /// <summary>
        /// Y Pos
        /// </summary>
        [DataMember()]
        public Single yPos
        {
            get
            {
                return this._yPos;
            }
            set
            {
                this._yPos = value;
            }
        }
        
        /// <summary>
        /// Copy To Victim Loc
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            VictimLoc typedTarget = target as VictimLoc;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Row = this.Row;
            typedTarget.Col = this.Col;
            typedTarget.xPos = this.xPos;
            typedTarget.yPos = this.yPos;
        }
        
        /// <summary>
        /// Clone Victim Loc
        /// </summary>
        public virtual object Clone()
        {
            VictimLoc target = new VictimLoc();

            target.Row = this.Row;
            target.Col = this.Col;
            target.xPos = this.xPos;
            target.yPos = this.yPos;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(Row);

            writer.Write(Col);

            writer.Write(xPos);

            writer.Write(yPos);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            Row = reader.ReadInt32();

            Col = reader.ReadInt32();

            xPos = reader.ReadSingle();

            yPos = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Point
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("Point", Namespace="http://schemas.microsoft.com/robotics/2008/01/robocupgui.html")]
    public class Point : ICloneable, IDssSerializable
    {
        
        private Single _x;
        
        private Single _y;
        
        /// <summary>
        /// X
        /// </summary>
        [DataMember()]
        public Single X
        {
            get
            {
                return this._x;
            }
            set
            {
                this._x = value;
            }
        }
        
        /// <summary>
        /// Y
        /// </summary>
        [DataMember()]
        public Single Y
        {
            get
            {
                return this._y;
            }
            set
            {
                this._y = value;
            }
        }
        
        /// <summary>
        /// Copy To Point
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Point typedTarget = target as Point;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.X = this.X;
            typedTarget.Y = this.Y;
        }
        
        /// <summary>
        /// Clone Point
        /// </summary>
        public virtual object Clone()
        {
            Point target = new Point();

            target.X = this.X;
            target.Y = this.Y;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(X);

            writer.Write(Y);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            X = reader.ReadSingle();

            Y = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Robo CupGUI Operations
    /// </summary>
    [ServicePort()]
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class RoboCupGUIOperations : PortSet<Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup, Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop, Get, dssphttp.HttpGet, Subscribe, CONNECT_CMD, DISCONNECT_CMD, GET_POSES_CMD, INIT_CMD, DRIVE_AERIAL_CMD, MIS_PKG_CMD, IMG_SVR_CAM_CMD, IMG_SVR_OK_CMD, WAYPOINT_CMD, CONNECTED_MSG, START_POSES_MSG, INITIALIZED_MSG, STA_MSG, GPS_MSG, IMAGE_MSG>
    {
        
        /// <summary>
        /// Required Lookup request body type
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.LookupResponse,Fault> DsspDefaultLookup()
        {
            Microsoft.Dss.ServiceModel.Dssp.LookupRequestType body = new Microsoft.Dss.ServiceModel.Dssp.LookupRequestType();
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Dssp Default Lookup and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.LookupResponse,Fault> DsspDefaultLookup(Microsoft.Dss.ServiceModel.Dssp.LookupRequestType body)
        {
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.LookupRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// A request to drop the service.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultDropResponseType,Fault> DsspDefaultDrop()
        {
            Microsoft.Dss.ServiceModel.Dssp.DropRequestType body = new Microsoft.Dss.ServiceModel.Dssp.DropRequestType();
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Dssp Default Drop and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultDropResponseType,Fault> DsspDefaultDrop(Microsoft.Dss.ServiceModel.Dssp.DropRequestType body)
        {
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.DropRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Required Get body type
        /// </summary>
        public virtual PortSet<RoboCupGUIState,Fault> Get()
        {
            Microsoft.Dss.ServiceModel.Dssp.GetRequestType body = new Microsoft.Dss.ServiceModel.Dssp.GetRequestType();
            Get op = new Get(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Get and return the response port.
        /// </summary>
        public virtual PortSet<RoboCupGUIState,Fault> Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body)
        {
            Get op = new Get();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.GetRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// DsspHttp Get request body
        /// </summary>
        public virtual PortSet<dssphttp.HttpResponseType,Fault> HttpGet()
        {
            dssphttp.HttpGetRequestType body = new dssphttp.HttpGetRequestType();
            dssphttp.HttpGet op = new dssphttp.HttpGet(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Http Get and return the response port.
        /// </summary>
        public virtual PortSet<dssphttp.HttpResponseType,Fault> HttpGet(dssphttp.HttpGetRequestType body)
        {
            dssphttp.HttpGet op = new dssphttp.HttpGet();
            op.Body = body ?? new dssphttp.HttpGetRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Subscribe and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,Fault> Subscribe(IPort notificationPort)
        {
            Subscribe op = new Subscribe();
            op.Body = new Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType();
            op.NotificationPort = notificationPort;
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Subscribe and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,Fault> Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body, IPort notificationPort)
        {
            Subscribe op = new Subscribe();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType();
            op.NotificationPort = notificationPort;
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// ConnectCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> CONNECT_CMD()
        {
            ConnectCMDRequest body = new ConnectCMDRequest();
            CONNECT_CMD op = new CONNECT_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post CONNECT_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> CONNECT_CMD(ConnectCMDRequest body)
        {
            CONNECT_CMD op = new CONNECT_CMD();
            op.Body = body ?? new ConnectCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// DisconnectCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> DISCONNECT_CMD()
        {
            DisconnectCMDRequest body = new DisconnectCMDRequest();
            DISCONNECT_CMD op = new DISCONNECT_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post DISCONNECT_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> DISCONNECT_CMD(DisconnectCMDRequest body)
        {
            DISCONNECT_CMD op = new DISCONNECT_CMD();
            op.Body = body ?? new DisconnectCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Get PosesCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> GET_POSES_CMD()
        {
            GetPosesCMDRequest body = new GetPosesCMDRequest();
            GET_POSES_CMD op = new GET_POSES_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post GET_POSES_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> GET_POSES_CMD(GetPosesCMDRequest body)
        {
            GET_POSES_CMD op = new GET_POSES_CMD();
            op.Body = body ?? new GetPosesCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// InitCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> INIT_CMD()
        {
            InitCMDRequest body = new InitCMDRequest();
            INIT_CMD op = new INIT_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post INIT_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> INIT_CMD(InitCMDRequest body)
        {
            INIT_CMD op = new INIT_CMD();
            op.Body = body ?? new InitCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Drive AerialCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> DRIVE_AERIAL_CMD()
        {
            DriveAerialCMDRequest body = new DriveAerialCMDRequest();
            DRIVE_AERIAL_CMD op = new DRIVE_AERIAL_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post DRIVE_AERIAL_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> DRIVE_AERIAL_CMD(DriveAerialCMDRequest body)
        {
            DRIVE_AERIAL_CMD op = new DRIVE_AERIAL_CMD();
            op.Body = body ?? new DriveAerialCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Mis PkgCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> MIS_PKG_CMD()
        {
            MisPkgCMDRequest body = new MisPkgCMDRequest();
            MIS_PKG_CMD op = new MIS_PKG_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post MIS_PKG_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> MIS_PKG_CMD(MisPkgCMDRequest body)
        {
            MIS_PKG_CMD op = new MIS_PKG_CMD();
            op.Body = body ?? new MisPkgCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Img Svr CamCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> IMG_SVR_CAM_CMD()
        {
            ImgSvrCamCMDRequest body = new ImgSvrCamCMDRequest();
            IMG_SVR_CAM_CMD op = new IMG_SVR_CAM_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post IMG_SVR_CAM_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> IMG_SVR_CAM_CMD(ImgSvrCamCMDRequest body)
        {
            IMG_SVR_CAM_CMD op = new IMG_SVR_CAM_CMD();
            op.Body = body ?? new ImgSvrCamCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Img SvrOKCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> IMG_SVR_OK_CMD()
        {
            ImgSvrOKCMDRequest body = new ImgSvrOKCMDRequest();
            IMG_SVR_OK_CMD op = new IMG_SVR_OK_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post IMG_SVR_OK_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> IMG_SVR_OK_CMD(ImgSvrOKCMDRequest body)
        {
            IMG_SVR_OK_CMD op = new IMG_SVR_OK_CMD();
            op.Body = body ?? new ImgSvrOKCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// WaypointCMD Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> WAYPOINT_CMD()
        {
            WaypointCMDRequest body = new WaypointCMDRequest();
            WAYPOINT_CMD op = new WAYPOINT_CMD(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post WAYPOINT_CMD and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> WAYPOINT_CMD(WaypointCMDRequest body)
        {
            WAYPOINT_CMD op = new WAYPOINT_CMD();
            op.Body = body ?? new WaypointCMDRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// ConnectedMSG Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> CONNECTED_MSG()
        {
            ConnectedMSGRequest body = new ConnectedMSGRequest();
            CONNECTED_MSG op = new CONNECTED_MSG(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post CONNECTED_MSG and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> CONNECTED_MSG(ConnectedMSGRequest body)
        {
            CONNECTED_MSG op = new CONNECTED_MSG();
            op.Body = body ?? new ConnectedMSGRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Start PosesMSG Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> START_POSES_MSG()
        {
            StartPosesMSGRequest body = new StartPosesMSGRequest();
            START_POSES_MSG op = new START_POSES_MSG(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post START_POSES_MSG and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> START_POSES_MSG(StartPosesMSGRequest body)
        {
            START_POSES_MSG op = new START_POSES_MSG();
            op.Body = body ?? new StartPosesMSGRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// InitializedMSG Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> INITIALIZED_MSG()
        {
            InitializedMSGRequest body = new InitializedMSGRequest();
            INITIALIZED_MSG op = new INITIALIZED_MSG(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post INITIALIZED_MSG and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> INITIALIZED_MSG(InitializedMSGRequest body)
        {
            INITIALIZED_MSG op = new INITIALIZED_MSG();
            op.Body = body ?? new InitializedMSGRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// StaMSG Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> STA_MSG()
        {
            StaMSGRequest body = new StaMSGRequest();
            STA_MSG op = new STA_MSG(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post STA_MSG and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> STA_MSG(StaMSGRequest body)
        {
            STA_MSG op = new STA_MSG();
            op.Body = body ?? new StaMSGRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// GPSMSG Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> GPS_MSG()
        {
            GPSMSGRequest body = new GPSMSGRequest();
            GPS_MSG op = new GPS_MSG(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post GPS_MSG and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> GPS_MSG(GPSMSGRequest body)
        {
            GPS_MSG op = new GPS_MSG();
            op.Body = body ?? new GPSMSGRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// ImageMSG Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> IMAGE_MSG()
        {
            ImageMSGRequest body = new ImageMSGRequest();
            IMAGE_MSG op = new IMAGE_MSG(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post IMAGE_MSG and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> IMAGE_MSG(ImageMSGRequest body)
        {
            IMAGE_MSG op = new IMAGE_MSG();
            op.Body = body ?? new ImageMSGRequest();
            this.Post(op);
            return op.ResponsePort;

        }
    }
    
    /// <summary>
    /// Get
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class Get : Microsoft.Dss.ServiceModel.Dssp.Get<Microsoft.Dss.ServiceModel.Dssp.GetRequestType, PortSet<RoboCupGUIState, Fault>>
    {
        
        /// <summary>
        /// Get
        /// </summary>
        public Get()
        {
        }
        
        /// <summary>
        /// Get
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Get
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body, Microsoft.Ccr.Core.PortSet<RoboCupGUIState,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Subscribe
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class Subscribe : Microsoft.Dss.ServiceModel.Dssp.Subscribe<Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType, PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType, Fault>>
    {
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe()
        {
        }
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// CONNECT_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class CONNECT_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<ConnectCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// CONNECT_CMD
        /// </summary>
        public CONNECT_CMD()
        {
        }
        
        /// <summary>
        /// CONNECT_CMD
        /// </summary>
        public CONNECT_CMD(ConnectCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// CONNECT_CMD
        /// </summary>
        public CONNECT_CMD(ConnectCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// DISCONNECT_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class DISCONNECT_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<DisconnectCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// DISCONNECT_CMD
        /// </summary>
        public DISCONNECT_CMD()
        {
        }
        
        /// <summary>
        /// DISCONNECT_CMD
        /// </summary>
        public DISCONNECT_CMD(DisconnectCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// DISCONNECT_CMD
        /// </summary>
        public DISCONNECT_CMD(DisconnectCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// GET_POSES_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class GET_POSES_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<GetPosesCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// GET_POSES_CMD
        /// </summary>
        public GET_POSES_CMD()
        {
        }
        
        /// <summary>
        /// GET_POSES_CMD
        /// </summary>
        public GET_POSES_CMD(GetPosesCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// GET_POSES_CMD
        /// </summary>
        public GET_POSES_CMD(GetPosesCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// INIT_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class INIT_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<InitCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// INIT_CMD
        /// </summary>
        public INIT_CMD()
        {
        }
        
        /// <summary>
        /// INIT_CMD
        /// </summary>
        public INIT_CMD(InitCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// INIT_CMD
        /// </summary>
        public INIT_CMD(InitCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// DRIVE_AERIAL_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class DRIVE_AERIAL_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<DriveAerialCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// DRIVE_AERIAL_CMD
        /// </summary>
        public DRIVE_AERIAL_CMD()
        {
        }
        
        /// <summary>
        /// DRIVE_AERIAL_CMD
        /// </summary>
        public DRIVE_AERIAL_CMD(DriveAerialCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// DRIVE_AERIAL_CMD
        /// </summary>
        public DRIVE_AERIAL_CMD(DriveAerialCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// MIS_PKG_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class MIS_PKG_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<MisPkgCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// MIS_PKG_CMD
        /// </summary>
        public MIS_PKG_CMD()
        {
        }
        
        /// <summary>
        /// MIS_PKG_CMD
        /// </summary>
        public MIS_PKG_CMD(MisPkgCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// MIS_PKG_CMD
        /// </summary>
        public MIS_PKG_CMD(MisPkgCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// IMG_SVR_CAM_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class IMG_SVR_CAM_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<ImgSvrCamCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// IMG_SVR_CAM_CMD
        /// </summary>
        public IMG_SVR_CAM_CMD()
        {
        }
        
        /// <summary>
        /// IMG_SVR_CAM_CMD
        /// </summary>
        public IMG_SVR_CAM_CMD(ImgSvrCamCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// IMG_SVR_CAM_CMD
        /// </summary>
        public IMG_SVR_CAM_CMD(ImgSvrCamCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// IMG_SVR_OK_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class IMG_SVR_OK_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<ImgSvrOKCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// IMG_SVR_OK_CMD
        /// </summary>
        public IMG_SVR_OK_CMD()
        {
        }
        
        /// <summary>
        /// IMG_SVR_OK_CMD
        /// </summary>
        public IMG_SVR_OK_CMD(ImgSvrOKCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// IMG_SVR_OK_CMD
        /// </summary>
        public IMG_SVR_OK_CMD(ImgSvrOKCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// WAYPOINT_CMD
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class WAYPOINT_CMD : Microsoft.Dss.ServiceModel.Dssp.Update<WaypointCMDRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// WAYPOINT_CMD
        /// </summary>
        public WAYPOINT_CMD()
        {
        }
        
        /// <summary>
        /// WAYPOINT_CMD
        /// </summary>
        public WAYPOINT_CMD(WaypointCMDRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// WAYPOINT_CMD
        /// </summary>
        public WAYPOINT_CMD(WaypointCMDRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// CONNECTED_MSG
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class CONNECTED_MSG : Microsoft.Dss.ServiceModel.Dssp.Update<ConnectedMSGRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// CONNECTED_MSG
        /// </summary>
        public CONNECTED_MSG()
        {
        }
        
        /// <summary>
        /// CONNECTED_MSG
        /// </summary>
        public CONNECTED_MSG(ConnectedMSGRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// CONNECTED_MSG
        /// </summary>
        public CONNECTED_MSG(ConnectedMSGRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// START_POSES_MSG
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class START_POSES_MSG : Microsoft.Dss.ServiceModel.Dssp.Update<StartPosesMSGRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// START_POSES_MSG
        /// </summary>
        public START_POSES_MSG()
        {
        }
        
        /// <summary>
        /// START_POSES_MSG
        /// </summary>
        public START_POSES_MSG(StartPosesMSGRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// START_POSES_MSG
        /// </summary>
        public START_POSES_MSG(StartPosesMSGRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// INITIALIZED_MSG
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class INITIALIZED_MSG : Microsoft.Dss.ServiceModel.Dssp.Update<InitializedMSGRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// INITIALIZED_MSG
        /// </summary>
        public INITIALIZED_MSG()
        {
        }
        
        /// <summary>
        /// INITIALIZED_MSG
        /// </summary>
        public INITIALIZED_MSG(InitializedMSGRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// INITIALIZED_MSG
        /// </summary>
        public INITIALIZED_MSG(InitializedMSGRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// STA_MSG
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class STA_MSG : Microsoft.Dss.ServiceModel.Dssp.Update<StaMSGRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// STA_MSG
        /// </summary>
        public STA_MSG()
        {
        }
        
        /// <summary>
        /// STA_MSG
        /// </summary>
        public STA_MSG(StaMSGRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// STA_MSG
        /// </summary>
        public STA_MSG(StaMSGRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// GPS_MSG
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class GPS_MSG : Microsoft.Dss.ServiceModel.Dssp.Update<GPSMSGRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// GPS_MSG
        /// </summary>
        public GPS_MSG()
        {
        }
        
        /// <summary>
        /// GPS_MSG
        /// </summary>
        public GPS_MSG(GPSMSGRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// GPS_MSG
        /// </summary>
        public GPS_MSG(GPSMSGRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// IMAGE_MSG
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class IMAGE_MSG : Microsoft.Dss.ServiceModel.Dssp.Update<ImageMSGRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// IMAGE_MSG
        /// </summary>
        public IMAGE_MSG()
        {
        }
        
        /// <summary>
        /// IMAGE_MSG
        /// </summary>
        public IMAGE_MSG(ImageMSGRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// IMAGE_MSG
        /// </summary>
        public IMAGE_MSG(ImageMSGRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
}
