//-----------------------------------------------------------------------
//  This file is part of the UC Merced Microsoft Robotics Developer Studio 
// Project Code Base.
//
//  Created by Benjamin Balaguer under the supervision of Stefano Carpin.
//  Based on SimpleDashboardTypes.cs from UX\SimpleDashboard.
//
//  $File: GroupingGUITypes.cs $
//-----------------------------------------------------------------------

using System;
using System.Collections.Generic;
using Microsoft.Ccr.Core;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.Core.Attributes;
using dssp = Microsoft.Dss.ServiceModel.Dssp;
using W3C.Soap;
using Microsoft.Dss.Core.DsspHttp;
using System.Drawing;

namespace Microsoft.Robotics.Services.GroupingGUI
{

    /// <summary>
    /// DSS Contract for GroupingGUI
    /// </summary>
    static class Contract
    {
        /// <summary>
        /// The DSS Namespace for GroupingGUI
        /// </summary>
        public const string Identifier = "http://schemas.microsoft.com/robotics/2008/01/groupinggui.html";
    }

    /// <summary>
    /// The GroupingGUI Operations Port
    /// </summary>
    class GroupingGUIOperations : PortSet<
        DsspDefaultLookup, 
        DsspDefaultDrop, 
        Get, 
        HttpGet>
    {
    }

    /// <summary>
    /// DSS Get Definition for GroupingGUI 
    /// </summary>
    class Get : Get<dssp.GetRequestType, PortSet<GroupingGUIState, W3C.Soap.Fault>>
    {
        /// <summary>
        /// Default DSS Get Constructor
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// DSS GetRequestType Constructor
        /// </summary>
        /// <param name="body"></param>
        public Get(dssp.GetRequestType body)
            : base(body)
        {
        }

    }
}
