#!/bin/sh

if test "x${DEBUG}" = "x1" ; then
    echo "Running $0 $* from : "  `pwd`;
    set -x;
fi

echo "Killing moast/player processes and cleaning up"
echo "see killWpsForceAll.log for details."

((
set -x;

date
ps -ae
ipcs
netstat -napee

killall -INT amMobMain
killall -INT amMisMain
killall -INT amSpMain
killall -INT primMobMain
killall -INT primMisMain
killall -INT primSpMain
killall -INT slamStub
killall -INT simWare
killall -INT vehShell
killall -INT amShell
killall -INT primShell
killall -INT servoShell
killall -INT moastNmlSvr
killall -INT moastNmlWpsSvr
killall -INT playerv
killall -INT player

sleep 5

killall -KILL amMobMain
killall -KILL amMisMain
killall -KILL amSpMain
killall -KILL primMobMain
killall -KILL primMisMain
killall -KILL primSpMain
killall -KILL slamStub
killall -KILL simWare
killall -KILL vehShell
killall -KILL amShell
killall -KILL primShell
killall -KILL servoShell
killall -KILL moastNmlWpsSvr
killall -KILL moastNmlSvr
killall -KILL playerv
killall -KILL player
killall -KILL gdb
killall -KILL run_cmd_and_wait.sh
killall -KILL screen

if test "x${RCSLIB_DIR}" = "x" ; then
    RCSLIB_DIR=`grep RCSLIB_DIR ../Makefile | awk '{print $3}'`
fi

if test "x${CONFIG_INI}" = "x" ; then
    CONFIG_INI=../etc/moast.ini;
fi

if test -x ~/c-crada_repos/bin/clean_run ; then
    . ~/c-crada_repos/bin/clean_run;
fi

"${RCSLIB_DIR}/bin/nmlclean" "${CONFIG_NML}";

if test "x${CONFIG_NML}" = "x" ; then
    for CONFIG_NML in ../etc/*.nml ; do 
	"${RCSLIB_DIR}/bin/nmlclean" "${CONFIG_NML}";
    done;
    "${RCSLIB_DIR}/bin/ipc-clear.sh"
else
    "${RCSLIB_DIR}/bin/nmlclean" "${CONFIG_NML}";
fi


screen -wipe

ps -ae 
ipcs
netstat -napee


) 2>&1 ) >> killWpsForceAll.log;

echo "Finished $0 $*"
echo ""
