/*!
  \file getopt.h

  \brief A replacement for missing Unix header, if needed.
*/

#ifndef GETOPT_H
#define GETOPT_H

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

struct option
{
  const char *name;
  /* has_arg can't be an enum because some compilers complain about
     type mismatches in all the code that assumes it is an int.  */
  int has_arg;
  int *flag;
  int val;
};

/* Names for the values of the `has_arg' field of `struct option'.  */

# define no_argument		0
# define required_argument	1
# define optional_argument	2

extern int	opterr;
extern int	optind;
extern int	optopt;
extern char    *optarg;
extern int	optreset;

extern int getopt(int nargc, char * const *nargv, const char *options);

extern int getopt_long(int nargc, char * const * nargv, const char * options, const struct option * long_options, int * idx);

#ifdef __cplusplus
#if 0
{
#endif
}
#endif

#endif /* GETOPT_H */
