#include <FreeImagePlus.h>
#include <string>
#include <fstream>
#include <iostream>
using namespace std;
class RobocupMap
{

public:
  // mapGrid will hold int values for each pixel of the loaded
  // map file.  A negative number indicates that that pixel is
  // impassable.

  static const int WALL = -1;

  int **mapGrid;
  int mapWidth;
  int mapHeight;

  //tfw information
  float xScale;
  float xShift;
  float yScale;
  float yShift;
  float rot1;
  float rot2;
  
  // Function Declarations
  bool readMapFromTIFF(string path,string tfwPath);

  //converts between coordinate systems
  //p stands for PIXEL
  //x/y stand for their axis
  //m stands for meters
  float px2m(int x); //pixel x coord to meter coord
  float py2m(int y); //pixel y coord to meter coord
  int mx2p(float x); //meter x coord to pixel coord
  int my2p(float y); //meter y coord to pixel coord
};
  
