#ifndef XML_ROBOT_INFO_H
#define XML_ROBOT_INFO_H

#include "rcs.hh"

#define A_TYPE 10001
#define GROUND_ROBOT_INFO_TYPE 10002

#define DO_NOT_ADD_INDEXES_TO_ARRAY_NAMES 1

class A : public NMLmsg
{
public:
  A();
  void update(CMS *);

  DECLARE_NML_UNBOUNDED_ARRAY(char,pos); //attribute,default=http://www.nist.gov
  float val;
};

class GROUND_ROBOT_INFO : public NMLmsg
{
public:
  GROUND_ROBOT_INFO();
  void update(CMS *);

  float XPosition;
  float YPosition;
  float ZPosition; 
  float xLow;
  float yLow;
  float resolution;
  DECLARE_NML_DYNAMIC_LENGTH_ARRAY(A, map, 25000);

};

int xml_robot_info_format(NMLTYPE , void *, CMS *);

#endif
