/*
*	New C++ File starts here.
*	This file should be named amMisJA.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "amMisJA.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/amMisJA_n_codegen_protos.hh"



#ifndef AMMISJA_NAME_LIST_LENGTH
#define AMMISJA_NAME_LIST_LENGTH 9
#endif

const NMLTYPE amMisJA_id_list[AMMISJA_NAME_LIST_LENGTH]= {
	AM_MIS_JA_CFG_CYCLE_TIME_TYPE, /* 0,10201 */
	AM_MIS_JA_CFG_DEBUG_TYPE, /* 1,10202 */
	AM_MIS_JA_CMD_ABORT_TYPE, /* 2,10002 */
	AM_MIS_JA_CMD_HALT_TYPE, /* 3,10003 */
	AM_MIS_JA_CMD_INIT_TYPE, /* 4,10001 */
	AM_MIS_JA_CMD_SHUTDOWN_TYPE, /* 5,10004 */
	AM_MIS_JA_SET_TYPE, /* 6,10301 */
	AM_MIS_JA_STAT_TYPE, /* 7,10101 */
	-1};
const size_t amMisJA_size_list[AMMISJA_NAME_LIST_LENGTH]= {
	sizeof(AmMisJACfgCycleTime),
	sizeof(AmMisJACfgDebug),
	sizeof(AmMisJACmdAbort),
	sizeof(AmMisJACmdHalt),
	sizeof(AmMisJACmdInit),
	sizeof(AmMisJACmdShutdown),
	sizeof(AmMisJASet),
	sizeof(AmMisJAStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	AmMisJACfgCycleTime	32
Estimated_size	AmMisJACfgDebug	32
Estimated_size	AmMisJACmdAbort	24
Estimated_size	AmMisJACmdHalt	24
Estimated_size	AmMisJACmdInit	24
Estimated_size	AmMisJACmdShutdown	24
Estimated_size	AmMisJASet	144
Estimated_size	AmMisJAStat	136
Estimated_size	MAXIMUM	144
*/
/*
*	NML/CMS Format function : amMisJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
int amMisJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"amMisJA",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		amMisJA_id_list,amMisJA_size_list,
		AMMISJA_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case AM_MIS_JA_CFG_CYCLE_TIME_TYPE:
		((AmMisJACfgCycleTime *) buffer)->update(cms);
		break;
	case AM_MIS_JA_CFG_DEBUG_TYPE:
		((AmMisJACfgDebug *) buffer)->update(cms);
		break;
	case AM_MIS_JA_CMD_ABORT_TYPE:
		((AmMisJACmdAbort *) buffer)->update(cms);
		break;
	case AM_MIS_JA_CMD_HALT_TYPE:
		((AmMisJACmdHalt *) buffer)->update(cms);
		break;
	case AM_MIS_JA_CMD_INIT_TYPE:
		((AmMisJACmdInit *) buffer)->update(cms);
		break;
	case AM_MIS_JA_CMD_SHUTDOWN_TYPE:
		((AmMisJACmdShutdown *) buffer)->update(cms);
		break;
	case AM_MIS_JA_SET_TYPE:
		((AmMisJASet *) buffer)->update(cms);
		break;
	case AM_MIS_JA_STAT_TYPE:
		((AmMisJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for AmMisJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("AmMisJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("AmMisJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMisJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJACfgDebug::update(CMS *cms)
{

	cms->beginClass("AmMisJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("AmMisJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMisJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJACmdAbort::update(CMS *cms)
{

	cms->beginClass("AmMisJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMisJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMisJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJACmdHalt::update(CMS *cms)
{

	cms->beginClass("AmMisJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMisJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMisJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJACmdInit::update(CMS *cms)
{

	cms->beginClass("AmMisJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMisJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMisJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("AmMisJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMisJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMisJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJASet::update(CMS *cms)
{

	cms->beginClass("AmMisJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);

	cms->endClass("AmMisJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for AmMisJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMisJAStat::update(CMS *cms)
{

	cms->beginClass("AmMisJAStat","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("heartbeat",heartbeat);

	cms->endClass("AmMisJAStat","RCS_STAT_MSG");

}

