/*
*	New C++ File starts here.
*	This file should be named amSP.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "amSP.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/amSP_n_codegen_protos.hh"



#ifndef AMSP_NAME_LIST_LENGTH
#define AMSP_NAME_LIST_LENGTH 13
#endif

const NMLTYPE amSP_id_list[AMSP_NAME_LIST_LENGTH]= {
	AM_SP_CFG_CYCLE_TIME_TYPE, /* 0,9201 */
	AM_SP_CFG_DEBUG_TYPE, /* 1,9202 */
	AM_SP_CFG_DUMP_WM_TYPE, /* 2,9203 */
	AM_SP_CFG_NOP_TYPE, /* 3,9204 */
	AM_SP_CMD_ABORT_TYPE, /* 4,9002 */
	AM_SP_CMD_GO_TYPE, /* 5,9005 */
	AM_SP_CMD_HALT_TYPE, /* 6,9003 */
	AM_SP_CMD_INIT_TYPE, /* 7,9001 */
	AM_SP_CMD_NOP_TYPE, /* 8,9006 */
	AM_SP_CMD_SHUTDOWN_TYPE, /* 9,9004 */
	AM_SP_SET_TYPE, /* 10,9301 */
	AM_SP_STAT_TYPE, /* 11,9101 */
	-1};
const size_t amSP_size_list[AMSP_NAME_LIST_LENGTH]= {
	sizeof(AmSPCfgCycleTime),
	sizeof(AmSPCfgDebug),
	sizeof(AmSPCfgDumpWM),
	sizeof(AmSPCfgNop),
	sizeof(AmSPCmdAbort),
	sizeof(AmSPCmdGo),
	sizeof(AmSPCmdHalt),
	sizeof(AmSPCmdInit),
	sizeof(AmSPCmdNop),
	sizeof(AmSPCmdShutdown),
	sizeof(AmSPSet),
	sizeof(AmSPStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	AmSPCfgCycleTime	32
Estimated_size	AmSPCfgDebug	32
Estimated_size	AmSPCfgDumpWM	32
Estimated_size	AmSPCfgNop	24
Estimated_size	AmSPCmdAbort	24
Estimated_size	AmSPCmdGo	24
Estimated_size	AmSPCmdHalt	24
Estimated_size	AmSPCmdInit	24
Estimated_size	AmSPCmdNop	24
Estimated_size	AmSPCmdShutdown	24
Estimated_size	AmSPSet	152
Estimated_size	AmSPStat	296
Estimated_size	MAXIMUM	296
*/
/*
*	NML/CMS Format function : amSP_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
int amSP_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"amSP",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		amSP_id_list,amSP_size_list,
		AMSP_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case AM_SP_CFG_CYCLE_TIME_TYPE:
		((AmSPCfgCycleTime *) buffer)->update(cms);
		break;
	case AM_SP_CFG_DEBUG_TYPE:
		((AmSPCfgDebug *) buffer)->update(cms);
		break;
	case AM_SP_CFG_DUMP_WM_TYPE:
		((AmSPCfgDumpWM *) buffer)->update(cms);
		break;
	case AM_SP_CFG_NOP_TYPE:
		((AmSPCfgNop *) buffer)->update(cms);
		break;
	case AM_SP_CMD_ABORT_TYPE:
		((AmSPCmdAbort *) buffer)->update(cms);
		break;
	case AM_SP_CMD_GO_TYPE:
		((AmSPCmdGo *) buffer)->update(cms);
		break;
	case AM_SP_CMD_HALT_TYPE:
		((AmSPCmdHalt *) buffer)->update(cms);
		break;
	case AM_SP_CMD_INIT_TYPE:
		((AmSPCmdInit *) buffer)->update(cms);
		break;
	case AM_SP_CMD_NOP_TYPE:
		((AmSPCmdNop *) buffer)->update(cms);
		break;
	case AM_SP_CMD_SHUTDOWN_TYPE:
		((AmSPCmdShutdown *) buffer)->update(cms);
		break;
	case AM_SP_SET_TYPE:
		((AmSPSet *) buffer)->update(cms);
		break;
	case AM_SP_STAT_TYPE:
		((AmSPStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for AmSPCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("AmSPCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("AmSPCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCfgDebug::update(CMS *cms)
{

	cms->beginClass("AmSPCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("AmSPCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCfgDumpWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCfgDumpWM::update(CMS *cms)
{

	cms->beginClass("AmSPCfgDumpWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("level",level);

	cms->endClass("AmSPCfgDumpWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCfgNop::update(CMS *cms)
{

	cms->beginClass("AmSPCfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCmdAbort::update(CMS *cms)
{

	cms->beginClass("AmSPCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCmdGo
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCmdGo::update(CMS *cms)
{

	cms->beginClass("AmSPCmdGo","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCmdGo","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCmdHalt::update(CMS *cms)
{

	cms->beginClass("AmSPCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCmdInit::update(CMS *cms)
{

	cms->beginClass("AmSPCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCmdNop::update(CMS *cms)
{

	cms->beginClass("AmSPCmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPCmdShutdown::update(CMS *cms)
{

	cms->beginClass("AmSPCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmSPCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmSPSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPSet::update(CMS *cms)
{

	cms->beginClass("AmSPSet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("dumpLevel",dumpLevel);

	cms->endClass("AmSPSet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for AmSPStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void AmSPStat::update(CMS *cms)
{

	cms->beginClass("AmSPStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");


	cms->endClass("AmSPStat","RCS_STAT_MSG_V2");

}

