/*
*	New Java File starts here.
*	This file should be named ServoSPSet.java
*/


// Set Package Name
package moast;

// Import all NML, CMS, and RCS classes and interfaces
import rcs.*;
import rcs.nml.*;
import rcs.utils.*;
import rcs.posemath.*;

/*
*	Class definition for ServoSPSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
public class ServoSPSet extends RCS_STAT_MSG implements Cloneable
{
	public double cycleTime = 0;
	public int debug = 0;
	public int vehicleID = 0;
	public byte worldName[] = new byte[80];
	public PM_POSE startPose = new PM_POSE();
	public int sSetElem_length = 0;
	public SensorSetElem sSetElem[] = new SensorSetElem[35]; /* NML_DYNAMIC_LENGTH_ARRAY */


	// Constructor 
	public ServoSPSet()
	{
		super(2301);
		for(int i_worldName = 0; i_worldName < 80; i_worldName++ )
		{
			worldName[i_worldName]  = 0;
		}
		for(int i_sSetElem = 0; i_sSetElem < 35; i_sSetElem++ )
		{
			sSetElem[i_sSetElem] = new SensorSetElem();
		}

	}



	// Constructor that should be used by any classes that extend this class. 
	protected ServoSPSet(int _type)
	{
		super(_type);
		for(int i_worldName = 0; i_worldName < 80; i_worldName++ )
		{
			worldName[i_worldName]  = 0;
		}
		for(int i_sSetElem = 0; i_sSetElem < 35; i_sSetElem++ )
		{
			sSetElem[i_sSetElem] = new SensorSetElem();
		}

	}


	public void update(NMLFormatConverter nml_fc)
	{

		nml_fc.beginClass("ServoSPSet","RCS_STAT_MSG");

		nml_fc.beginBaseClass("RCS_STAT_MSG");

		super.update(nml_fc);

		nml_fc.endBaseClass("RCS_STAT_MSG");
		cycleTime = nml_fc.update_with_name("cycleTime",cycleTime);
		debug = nml_fc.update_with_name("debug",debug);
		vehicleID = nml_fc.update_with_name("vehicleID",vehicleID);
		nml_fc.update_with_name("worldName",worldName,80);
		nml_fc.beginClassVar("startPose");
		startPose.update(nml_fc);
		nml_fc.endClassVar("startPose");
		sSetElem_length = nml_fc.update_dla_length_with_name("sSetElem_length",sSetElem_length);
		for(int i_sSetElem = 0; i_sSetElem < sSetElem_length; i_sSetElem++ )
		{
			nml_fc.beginClassArrayElem("sSetElem",i_sSetElem);
			sSetElem[i_sSetElem].update(nml_fc);

			nml_fc.endClassArrayElem("sSetElem",i_sSetElem);
		}

		nml_fc.endClass("ServoSPSet","RCS_STAT_MSG");

	}


	public Object clone() throws CloneNotSupportedException
	{
		ServoSPSet cloned_object = (ServoSPSet) super.clone();
		if(this.worldName != null)
			cloned_object.worldName = (byte []) this.worldName.clone();
		if(this.startPose != null)
			cloned_object.startPose = (PM_POSE ) this.startPose.clone();
		if(this.sSetElem != null)
			cloned_object.sSetElem = (SensorSetElem []) this.sSetElem.clone();
		return cloned_object;

	}
}

