/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"

// Include externally supplied prototypes
#include "../../include/moastTypes_n_codegen_protos.hh"



#ifndef MOASTTYPES_NAME_LIST_LENGTH
#define MOASTTYPES_NAME_LIST_LENGTH 1
#endif

const NMLTYPE moastTypes_id_list[MOASTTYPES_NAME_LIST_LENGTH]= {
	-1};
const size_t moastTypes_size_list[MOASTTYPES_NAME_LIST_LENGTH]= {
	0};


// Enumerated Type Constants

/*
Estimated_size	ArcSegment	104
Estimated_size	Location2D	16
Estimated_size	SensorPoint	56
Estimated_size	Waypoint	41
Estimated_size	constrainedDouble	24
Estimated_size	constrainedFloat	24
Estimated_size	constrainedInt	24
Estimated_size	MAXIMUM	104
*/
/*
*	NML/CMS Format function : moastTypes_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
int moastTypes_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"moastTypes",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		moastTypes_id_list,moastTypes_size_list,
		MOASTTYPES_NAME_LIST_LENGTH,
		0);

	switch(type)
	{

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for ArcSegment
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,ArcSegment *x)
{

	cms->beginClass("ArcSegment",0);
	cms->update_with_name("center",x->center);
	cms->update_with_name("end",x->end);
	cms->update_with_name("normal",x->normal);
	cms->update_with_name("theta",x->theta);
	cms->update_with_name("annular_tol",x->annular_tol);
	cms->update_with_name("speed",x->speed);
	cms->update_with_name("isArc",x->isArc);

	cms->endClass("ArcSegment",0);

}


/*
*	NML/CMS Update function for Location2D
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,Location2D *x)
{

	cms->beginClass("Location2D",0);
	cms->update_with_name("north",x->north);
	cms->update_with_name("east",x->east);

	cms->endClass("Location2D",0);

}


/*
*	NML/CMS Update function for SensorPoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,SensorPoint *x)
{

	cms->beginClass("SensorPoint",0);
	cms->update_with_name("param1",x->param1);
	cms->update_with_name("sensorLoc",x->sensorLoc);
	cms->update_with_name("dataLoc",x->dataLoc);

	cms->endClass("SensorPoint",0);

}


/*
*	NML/CMS Update function for Waypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,Waypoint *x)
{

	cms->beginClass("Waypoint",0);
	cms->update_with_name("p",x->p);
	cms->update_with_name("neighborhood",x->neighborhood);
	cms->update_with_name("speed",x->speed);
	cms->update_with_name("quality",x->quality);

	cms->endClass("Waypoint",0);

}


/*
*	NML/CMS Update function for constrainedDouble
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,constrainedDouble *x)
{

	cms->beginClass("constrainedDouble",0);
	cms->update_with_name("data",x->data);
	cms->update_with_name("constraint",x->constraint);
	cms->update_with_name("tolerance",x->tolerance);

	cms->endClass("constrainedDouble",0);

}


/*
*	NML/CMS Update function for constrainedFloat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,constrainedFloat *x)
{

	cms->beginClass("constrainedFloat",0);
	cms->update_with_name("data",x->data);
	cms->update_with_name("constraint",x->constraint);
	cms->update_with_name("tolerance",x->tolerance);

	cms->endClass("constrainedFloat",0);

}


/*
*	NML/CMS Update function for constrainedInt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void nmlupdate(CMS *cms,constrainedInt *x)
{

	cms->beginClass("constrainedInt",0);
	cms->update_with_name("data",x->data);
	cms->update_with_name("constraint",x->constraint);
	cms->update_with_name("tolerance",x->tolerance);

	cms->endClass("constrainedInt",0);

}

/*
*	Initializer for ArcSegment
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void initialize_ArcSegment(ArcSegment* x)
{
	x->theta = (double) 0;
	x->annular_tol = (double) 0;
	x->speed = (double) 0;
	x->isArc = (int) 0;

}

/*
*	Initializer for Waypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void initialize_Waypoint(Waypoint* x)
{
	x->neighborhood = (double) 0;
	x->speed = (double) 0;
	x->quality = (unsigned char) 0;

}

/*
*	Initializer for constrainedDouble
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void initialize_constrainedDouble(constrainedDouble* x)
{
	x->data = (double) 0;
	x->constraint = (int) 0;
	x->tolerance = (double) 0;

}

/*
*	Initializer for constrainedFloat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void initialize_constrainedFloat(constrainedFloat* x)
{
	x->data = (float) 0;
	x->constraint = (int) 0;
	x->tolerance = (double) 0;

}

/*
*	Initializer for constrainedInt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:53 PDT 2008
*/
void initialize_constrainedInt(constrainedInt* x)
{
	x->data = (int) 0;
	x->constraint = (int) 0;
	x->tolerance = (double) 0;

}

