/*
*	New C++ File starts here.
*	This file should be named servoMisJA.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "servoMisJA.hh"
#include "moastNmlOffsets.hh"
#include "moastTypes.hh"

// Include externally supplied prototypes
#include "../../include/servoMisJA_n_codegen_protos.hh"



#ifndef SERVOMISJA_NAME_LIST_LENGTH
#define SERVOMISJA_NAME_LIST_LENGTH 10
#endif

const NMLTYPE servoMisJA_id_list[SERVOMISJA_NAME_LIST_LENGTH]= {
	SERVO_MIS_JA_CFG_CYCLE_TIME_TYPE, /* 0,3201 */
	SERVO_MIS_JA_CFG_DEBUG_TYPE, /* 1,3202 */
	SERVO_MIS_JA_CMD_ABORT_TYPE, /* 2,3002 */
	SERVO_MIS_JA_CMD_HALT_TYPE, /* 3,3003 */
	SERVO_MIS_JA_CMD_INIT_TYPE, /* 4,3001 */
	SERVO_MIS_JA_CMD_MOVE_TYPE, /* 5,3005 */
	SERVO_MIS_JA_CMD_SHUTDOWN_TYPE, /* 6,3004 */
	SERVO_MIS_JA_SET_TYPE, /* 10,3301 */
	SERVO_MIS_JA_STAT_TYPE, /* 11,3101 */
	-1};
const size_t servoMisJA_size_list[SERVOMISJA_NAME_LIST_LENGTH]= {
	sizeof(ServoMisJACfgCycleTime),
	sizeof(ServoMisJACfgDebug),
	sizeof(ServoMisJACmdAbort),
	sizeof(ServoMisJACmdHalt),
	sizeof(ServoMisJACmdInit),
	sizeof(ServoMisJACmdMove),
	sizeof(ServoMisJACmdShutdown),
	sizeof(ServoMisJASet),
	sizeof(ServoMisJAStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	ServoMisJACfgCycleTime	32
Estimated_size	ServoMisJACfgDebug	32
Estimated_size	ServoMisJACmdAbort	24
Estimated_size	ServoMisJACmdHalt	24
Estimated_size	ServoMisJACmdInit	24
Estimated_size	ServoMisJACmdMove	280
Estimated_size	ServoMisJACmdShutdown	24
Estimated_size	ServoMisJALinkCmd	20
Estimated_size	ServoMisJALinkSet	104
Estimated_size	ServoMisJALinkStat	24
Estimated_size	ServoMisJASet	1488
Estimated_size	ServoMisJAStat	624
Estimated_size	MAXIMUM	1488
*/
/*
*	NML/CMS Format function : servoMisJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
int servoMisJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"servoMisJA",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		servoMisJA_id_list,servoMisJA_size_list,
		SERVOMISJA_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case SERVO_MIS_JA_CFG_CYCLE_TIME_TYPE:
		((ServoMisJACfgCycleTime *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_CFG_DEBUG_TYPE:
		((ServoMisJACfgDebug *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_CMD_ABORT_TYPE:
		((ServoMisJACmdAbort *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_CMD_HALT_TYPE:
		((ServoMisJACmdHalt *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_CMD_INIT_TYPE:
		((ServoMisJACmdInit *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_CMD_MOVE_TYPE:
		((ServoMisJACmdMove *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_CMD_SHUTDOWN_TYPE:
		((ServoMisJACmdShutdown *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_SET_TYPE:
		((ServoMisJASet *) buffer)->update(cms);
		break;
	case SERVO_MIS_JA_STAT_TYPE:
		((ServoMisJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for ServoMisJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("ServoMisJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("ServoMisJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACfgDebug::update(CMS *cms)
{

	cms->beginClass("ServoMisJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("ServoMisJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACmdAbort::update(CMS *cms)
{

	cms->beginClass("ServoMisJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMisJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACmdHalt::update(CMS *cms)
{

	cms->beginClass("ServoMisJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMisJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACmdInit::update(CMS *cms)
{

	cms->beginClass("ServoMisJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMisJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJACmdMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACmdMove::update(CMS *cms)
{

	cms->beginClass("ServoMisJACmdMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_dla_length_with_name("linkCmd_length",linkCmd_length);
	cms->beginStructDynamicArray("linkCmd",linkCmd_length,12);
	for(int i_linkCmd = 0;i_linkCmd < linkCmd_length ;i_linkCmd++)
	{
		cms->beginStructArrayElem("linkCmd",i_linkCmd);
		nmlupdate(cms,&(linkCmd[i_linkCmd]));
		cms->endStructArrayElem("linkCmd",i_linkCmd);
	}
	cms->endStructDynamicArray("linkCmd",linkCmd_length,12);

	cms->endClass("ServoMisJACmdMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("ServoMisJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMisJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMisJALinkCmd
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void nmlupdate(CMS *cms,ServoMisJALinkCmd *x)
{

	cms->beginClass("ServoMisJALinkCmd",0);
	cms->update_with_name("linkID",x->linkID);
	cms->update_with_name("value",x->value);
	x->type= (ServoMisJALinkCmdType) cms->update_enumeration_with_name("type", (int)x->type,(void*)&(x->type),0);

	cms->endClass("ServoMisJALinkCmd",0);

}


/*
*	NML/CMS Update function for ServoMisJALinkSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void nmlupdate(CMS *cms,ServoMisJALinkSet *x)
{

	cms->beginClass("ServoMisJALinkSet",0);
	cms->update_with_name("linkID",x->linkID);
	cms->update_with_name("parentLinkID",x->parentLinkID);
	x->jType= (ServoMisJAJointType) cms->update_enumeration_with_name("jType", (int)x->jType,(void*)&(x->jType),0);
	cms->update_with_name("maxVelocity",x->maxVelocity);
	cms->update_with_name("maxTorque",x->maxTorque);
	cms->update_with_name("maxRange",x->maxRange);
	cms->update_with_name("minRange",x->minRange);
	cms->update_with_name("loc",x->loc);
	cms->update_with_name("rot",x->rot);

	cms->endClass("ServoMisJALinkSet",0);

}


/*
*	NML/CMS Update function for ServoMisJALinkStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void nmlupdate(CMS *cms,ServoMisJALinkStat *x)
{

	cms->beginClass("ServoMisJALinkStat",0);
	cms->update_with_name("linkID",x->linkID);
	cms->update_with_name("jointVal",x->jointVal);
	cms->update_with_name("torque",x->torque);

	cms->endClass("ServoMisJALinkStat",0);

}


/*
*	NML/CMS Update function for ServoMisJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJASet::update(CMS *cms)
{

	cms->beginClass("ServoMisJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("worldName",worldName,80);
	cms->update_dla_length_with_name("linkSet_length",linkSet_length);
	cms->beginStructDynamicArray("linkSet",linkSet_length,12);
	for(int i_linkSet = 0;i_linkSet < linkSet_length ;i_linkSet++)
	{
		cms->beginStructArrayElem("linkSet",i_linkSet);
		nmlupdate(cms,(ServoMisJALinkSet *) &(linkSet[i_linkSet]));
		cms->endStructArrayElem("linkSet",i_linkSet);
	}
	cms->endStructDynamicArray("linkSet",linkSet_length,12);

	cms->endClass("ServoMisJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for ServoMisJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void ServoMisJAStat::update(CMS *cms)
{

	cms->beginClass("ServoMisJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("error",error);
	cms->update_with_name("time",time);
	cms->update_with_name("heartbeat",heartbeat);
	cms->update_dla_length_with_name("linkStat_length",linkStat_length);
	cms->beginStructDynamicArray("linkStat",linkStat_length,12);
	for(int i_linkStat = 0;i_linkStat < linkStat_length ;i_linkStat++)
	{
		cms->beginStructArrayElem("linkStat",i_linkStat);
		nmlupdate(cms,&(linkStat[i_linkStat]));
		cms->endStructArrayElem("linkStat",i_linkStat);
	}
	cms->endStructDynamicArray("linkStat",linkStat_length,12);

	cms->endClass("ServoMisJAStat","RCS_STAT_MSG_V2");

}

/*
*	Initializer for ServoMisJALinkCmd
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void initialize_ServoMisJALinkCmd(ServoMisJALinkCmd* x)
{
	x->linkID = (int) 0;
	x->value = (double) 0;
	x->type = (ServoMisJALinkCmdType) 0;

}

/*
*	Initializer for ServoMisJALinkSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void initialize_ServoMisJALinkSet(ServoMisJALinkSet* x)
{
	x->linkID = (int) 0;
	x->parentLinkID = (int) 0;
	x->jType = (ServoMisJAJointType) 0;
	x->maxVelocity = (double) 0;
	x->maxTorque = (double) 0;
	x->maxRange = (double) 0;
	x->minRange = (double) 0;

}

/*
*	Initializer for ServoMisJALinkStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:57 PDT 2008
*/
void initialize_ServoMisJALinkStat(ServoMisJALinkStat* x)
{
	x->linkID = (int) 0;
	x->jointVal = (double) 0;
	x->torque = (double) 0;

}

