/*
*	New C++ File starts here.
*	This file should be named servoSP.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "servoSP.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/servoSP_n_codegen_protos.hh"



#ifndef SERVOSP_NAME_LIST_LENGTH
#define SERVOSP_NAME_LIST_LENGTH 10
#endif

const NMLTYPE servoSP_id_list[SERVOSP_NAME_LIST_LENGTH]= {
	SERVO_SP_CFG_CYCLE_TIME_TYPE, /* 1,2201 */
	SERVO_SP_CFG_DEBUG_TYPE, /* 2,2202 */
	SERVO_SP_CMD_ABORT_TYPE, /* 3,2002 */
	SERVO_SP_CMD_GO_TYPE, /* 4,2005 */
	SERVO_SP_CMD_HALT_TYPE, /* 5,2003 */
	SERVO_SP_CMD_INIT_TYPE, /* 6,2001 */
	SERVO_SP_CMD_SHUTDOWN_TYPE, /* 7,2004 */
	SERVO_SP_SET_TYPE, /* 8,2301 */
	SERVO_SP_STAT_TYPE, /* 9,2101 */
	-1};
const size_t servoSP_size_list[SERVOSP_NAME_LIST_LENGTH]= {
	sizeof(ServoSPCfgCycleTime),
	sizeof(ServoSPCfgDebug),
	sizeof(ServoSPCmdAbort),
	sizeof(ServoSPCmdGo),
	sizeof(ServoSPCmdHalt),
	sizeof(ServoSPCmdInit),
	sizeof(ServoSPCmdShutdown),
	sizeof(ServoSPSet),
	sizeof(ServoSPStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	SensorSetElem	240
Estimated_size	ServoSPCfgCycleTime	32
Estimated_size	ServoSPCfgDebug	32
Estimated_size	ServoSPCmdAbort	24
Estimated_size	ServoSPCmdGo	24
Estimated_size	ServoSPCmdHalt	24
Estimated_size	ServoSPCmdInit	24
Estimated_size	ServoSPCmdShutdown	24
Estimated_size	ServoSPSet	8704
Estimated_size	ServoSPStat	313
Estimated_size	MAXIMUM	8704
*/
/*
*	NML/CMS Format function : servoSP_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
int servoSP_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"servoSP",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		servoSP_id_list,servoSP_size_list,
		SERVOSP_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case SERVO_SP_CFG_CYCLE_TIME_TYPE:
		((ServoSPCfgCycleTime *) buffer)->update(cms);
		break;
	case SERVO_SP_CFG_DEBUG_TYPE:
		((ServoSPCfgDebug *) buffer)->update(cms);
		break;
	case SERVO_SP_CMD_ABORT_TYPE:
		((ServoSPCmdAbort *) buffer)->update(cms);
		break;
	case SERVO_SP_CMD_GO_TYPE:
		((ServoSPCmdGo *) buffer)->update(cms);
		break;
	case SERVO_SP_CMD_HALT_TYPE:
		((ServoSPCmdHalt *) buffer)->update(cms);
		break;
	case SERVO_SP_CMD_INIT_TYPE:
		((ServoSPCmdInit *) buffer)->update(cms);
		break;
	case SERVO_SP_CMD_SHUTDOWN_TYPE:
		((ServoSPCmdShutdown *) buffer)->update(cms);
		break;
	case SERVO_SP_SET_TYPE:
		((ServoSPSet *) buffer)->update(cms);
		break;
	case SERVO_SP_STAT_TYPE:
		((ServoSPStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for SensorSetElem
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void nmlupdate(CMS *cms,SensorSetElem *x)
{

	cms->beginClass("SensorSetElem",0);
	x->sType= (ServoSensorType) cms->update_enumeration_with_name("sType", (int)x->sType,(void*)&(x->sType),0);
	cms->update_with_name("senDataBufName",x->senDataBufName,80);
	cms->update_with_name("sensorID",x->sensorID);
	cms->update_with_name("mountID",x->mountID);
	cms->update_with_name("linkID",x->linkID);
	cms->update_with_name("sensorToMount",x->sensorToMount);
	cms->update_with_name("desiredPeriod",x->desiredPeriod);
	cms->update_dla_length_with_name("parameters_length",x->parameters_length);
	cms->update_dla_with_name("parameters",(double *) x->parameters, x->parameters_length,6);

	cms->endClass("SensorSetElem",0);

}


/*
*	NML/CMS Update function for ServoSPCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("ServoSPCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("ServoSPCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCfgDebug::update(CMS *cms)
{

	cms->beginClass("ServoSPCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("ServoSPCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCmdAbort::update(CMS *cms)
{

	cms->beginClass("ServoSPCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoSPCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPCmdGo
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCmdGo::update(CMS *cms)
{

	cms->beginClass("ServoSPCmdGo","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoSPCmdGo","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCmdHalt::update(CMS *cms)
{

	cms->beginClass("ServoSPCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoSPCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCmdInit::update(CMS *cms)
{

	cms->beginClass("ServoSPCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoSPCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPCmdShutdown::update(CMS *cms)
{

	cms->beginClass("ServoSPCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoSPCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoSPSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPSet::update(CMS *cms)
{

	cms->beginClass("ServoSPSet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("vehicleID",vehicleID);
	cms->update_with_name("worldName",worldName,80);
	cms->update_with_name("startPose",startPose);
	cms->update_dla_length_with_name("sSetElem_length",sSetElem_length);
	cms->beginStructDynamicArray("sSetElem",sSetElem_length,35);
	for(int i_sSetElem = 0;i_sSetElem < sSetElem_length ;i_sSetElem++)
	{
		cms->beginStructArrayElem("sSetElem",i_sSetElem);
		nmlupdate(cms,(SensorSetElem *) &(sSetElem[i_sSetElem]));
		cms->endStructArrayElem("sSetElem",i_sSetElem);
	}
	cms->endStructDynamicArray("sSetElem",sSetElem_length,35);

	cms->endClass("ServoSPSet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for ServoSPStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void ServoSPStat::update(CMS *cms)
{

	cms->beginClass("ServoSPStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("error",error);
	cms->update_with_name("heartbeat",heartbeat);
	cms->update_with_name("transmitData",transmitData);

	cms->endClass("ServoSPStat","RCS_STAT_MSG_V2");

}

/*
*	Initializer for SensorSetElem
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:58 PDT 2008
*/
void initialize_SensorSetElem(SensorSetElem* x)
{
	x->sType = (ServoSensorType) 0;
	for(int i_senDataBufName=0; i_senDataBufName< 80; i_senDataBufName++)
	{
		((char*) x->senDataBufName)[i_senDataBufName]  = (char) 0;
	}
	x->sensorID = (int) 0;
	x->mountID = (int) 0;
	x->linkID = (int) 0;
	x->desiredPeriod = (double) 0;
	x->parameters_length = (int) 0;
	for(int i_parameters=0; i_parameters< 6; i_parameters++)
	{
		((double*) x->parameters)[i_parameters]  = (double) 0;
	}

}

