/*
*	New C++ File starts here.
*	This file should be named vehSP.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "vehSP.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/vehSP_n_codegen_protos.hh"



#ifndef VEHSP_NAME_LIST_LENGTH
#define VEHSP_NAME_LIST_LENGTH 9
#endif

const NMLTYPE vehSP_id_list[VEHSP_NAME_LIST_LENGTH]= {
	VEH_SP_CFG_CYCLE_TIME_TYPE, /* 0,12201 */
	VEH_SP_CFG_DEBUG_TYPE, /* 1,12202 */
	VEH_SP_CMD_ABORT_TYPE, /* 2,12002 */
	VEH_SP_CMD_HALT_TYPE, /* 3,12003 */
	VEH_SP_CMD_INIT_TYPE, /* 4,12001 */
	VEH_SP_CMD_SHUTDOWN_TYPE, /* 5,12004 */
	VEH_SP_SET_TYPE, /* 6,12301 */
	VEH_SP_STAT_TYPE, /* 7,12101 */
	-1};
const size_t vehSP_size_list[VEHSP_NAME_LIST_LENGTH]= {
	sizeof(VehSPCfgCycleTime),
	sizeof(VehSPCfgDebug),
	sizeof(VehSPCmdAbort),
	sizeof(VehSPCmdHalt),
	sizeof(VehSPCmdInit),
	sizeof(VehSPCmdShutdown),
	sizeof(VehSPSet),
	sizeof(VehSPStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	VehSPCfgCycleTime	32
Estimated_size	VehSPCfgDebug	32
Estimated_size	VehSPCmdAbort	24
Estimated_size	VehSPCmdHalt	24
Estimated_size	VehSPCmdInit	24
Estimated_size	VehSPCmdShutdown	24
Estimated_size	VehSPSet	144
Estimated_size	VehSPStat	136
Estimated_size	MAXIMUM	144
*/
/*
*	NML/CMS Format function : vehSP_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
int vehSP_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"vehSP",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		vehSP_id_list,vehSP_size_list,
		VEHSP_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case VEH_SP_CFG_CYCLE_TIME_TYPE:
		((VehSPCfgCycleTime *) buffer)->update(cms);
		break;
	case VEH_SP_CFG_DEBUG_TYPE:
		((VehSPCfgDebug *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_ABORT_TYPE:
		((VehSPCmdAbort *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_HALT_TYPE:
		((VehSPCmdHalt *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_INIT_TYPE:
		((VehSPCmdInit *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_SHUTDOWN_TYPE:
		((VehSPCmdShutdown *) buffer)->update(cms);
		break;
	case VEH_SP_SET_TYPE:
		((VehSPSet *) buffer)->update(cms);
		break;
	case VEH_SP_STAT_TYPE:
		((VehSPStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for VehSPCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("VehSPCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("VehSPCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPCfgDebug::update(CMS *cms)
{

	cms->beginClass("VehSPCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("VehSPCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPCmdAbort::update(CMS *cms)
{

	cms->beginClass("VehSPCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPCmdHalt::update(CMS *cms)
{

	cms->beginClass("VehSPCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPCmdInit::update(CMS *cms)
{

	cms->beginClass("VehSPCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPCmdShutdown::update(CMS *cms)
{

	cms->beginClass("VehSPCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPSet::update(CMS *cms)
{

	cms->beginClass("VehSPSet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);

	cms->endClass("VehSPSet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for VehSPStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:59 PDT 2008
*/
void VehSPStat::update(CMS *cms)
{

	cms->beginClass("VehSPStat","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("heartbeat",heartbeat);

	cms->endClass("VehSPStat","RCS_STAT_MSG");

}

