/*
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*/

/*!
  \file skin.h

  \brief Declarations of the Simware skin interface functions.

  \code CVS Status:
  $Author: dr_steveb $
  $Revision: 1.1 $
  $Date: 2009/03/30 18:30:44 $
  \endcode

  \author Fred Proctor
*/

#ifndef SKIN_H
#define SKIN_H

#include "simware.h"

typedef struct {
  void *handle;
  int (*init)(char *init_string);
  int (*ask)(int (*tell)(simware_struct *));
  int (*tell)(simware_struct *);
  int (*fini)(void);
} skin_struct;


#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif

extern int skin_load(skin_struct *skin, char *object_name);
extern int skin_unload(skin_struct *skin);
extern int init(simware_struct *initRobot);
extern int ask(int (*tell)(simware_struct *));
extern int tell(simware_struct *);
extern int fini(void);

#if 0
{
#endif
#ifdef __cplusplus
}
#endif

#endif
