/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "amMobJA.hh"

// Forward Function Prototypes
void nmlupdate(CMS *cms, Waypoint *x);
void initialize_Waypoint(Waypoint *x);


#ifndef MAX_AMMOBJA_NAME_LENGTH
#define MAX_AMMOBJA_NAME_LENGTH 28
#endif
#ifndef AMMOBJA_NAME_LIST_LENGTH
#define AMMOBJA_NAME_LIST_LENGTH 19
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char amMobJA_name_list[AMMOBJA_NAME_LIST_LENGTH][MAX_AMMOBJA_NAME_LENGTH]= {
	"AmMobJACfgCellResolution", /* 0,11201 */
	"AmMobJACfgCycleTime", /* 1,11202 */
	"AmMobJACfgDebug", /* 2,11203 */
	"AmMobJACfgDumpWM", /* 3,11204 */
	"AmMobJACfgNop", /* 4,11205 */
	"AmMobJACfgPlanHorizon", /* 5,11206 */
	"AmMobJACfgVehicleMinTurnRad", /* 6,11207 */
	"AmMobJACfgVehicleWidth", /* 7,11208 */
	"AmMobJACmdAbort", /* 8,11002 */
	"AmMobJACmdHalt", /* 9,11003 */
	"AmMobJACmdInit", /* 10,11001 */
	"AmMobJACmdMoveWaypoint", /* 11,11005 */
	"AmMobJACmdNop", /* 12,11007 */
	"AmMobJACmdPrepareMove", /* 13,11006 */
	"AmMobJACmdShutdown", /* 14,11004 */
	"AmMobJACmdSpin", /* 15,11008 */
	"AmMobJASet", /* 16,11301 */
	"AmMobJAStat", /* 17,11101 */
	""};
const NMLTYPE amMobJA_id_list[AMMOBJA_NAME_LIST_LENGTH]= {
	AM_MOB_JA_CFG_CELL_RESOLUTION_TYPE, /* 0,11201 */
	AM_MOB_JA_CFG_CYCLE_TIME_TYPE, /* 1,11202 */
	AM_MOB_JA_CFG_DEBUG_TYPE, /* 2,11203 */
	AM_MOB_JA_CFG_DUMP_WM_TYPE, /* 3,11204 */
	AM_MOB_JA_CFG_NOP_TYPE, /* 4,11205 */
	AM_MOB_JA_CFG_PLAN_HORIZON_TYPE, /* 5,11206 */
	AM_MOB_JA_CFG_VEHICLE_MIN_TURN_RAD_TYPE, /* 6,11207 */
	AM_MOB_JA_CFG_VEHICLE_WIDTH_TYPE, /* 7,11208 */
	AM_MOB_JA_CMD_ABORT_TYPE, /* 8,11002 */
	AM_MOB_JA_CMD_HALT_TYPE, /* 9,11003 */
	AM_MOB_JA_CMD_INIT_TYPE, /* 10,11001 */
	AM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE, /* 11,11005 */
	AM_MOB_JA_CMD_NOP_TYPE, /* 12,11007 */
	AM_MOB_JA_CMD_PREPARE_MOVE_TYPE, /* 13,11006 */
	AM_MOB_JA_CMD_SHUTDOWN_TYPE, /* 14,11004 */
	AM_MOB_JA_CMD_SPIN_TYPE, /* 15,11008 */
	AM_MOB_JA_SET_TYPE, /* 16,11301 */
	AM_MOB_JA_STAT_TYPE, /* 17,11101 */
	-1};
const size_t amMobJA_size_list[AMMOBJA_NAME_LIST_LENGTH]= {
	sizeof(AmMobJACfgCellResolution),
	sizeof(AmMobJACfgCycleTime),
	sizeof(AmMobJACfgDebug),
	sizeof(AmMobJACfgDumpWM),
	sizeof(AmMobJACfgNop),
	sizeof(AmMobJACfgPlanHorizon),
	sizeof(AmMobJACfgVehicleMinTurnRad),
	sizeof(AmMobJACfgVehicleWidth),
	sizeof(AmMobJACmdAbort),
	sizeof(AmMobJACmdHalt),
	sizeof(AmMobJACmdInit),
	sizeof(AmMobJACmdMoveWaypoint),
	sizeof(AmMobJACmdNop),
	sizeof(AmMobJACmdPrepareMove),
	sizeof(AmMobJACmdShutdown),
	sizeof(AmMobJACmdSpin),
	sizeof(AmMobJASet),
	sizeof(AmMobJAStat),
	0};
const char *amMobJA_symbol_lookup(long type);


// Enumerated Type Constants

// anonymous_enum_______include_moastTypes_hh_203
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_203_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_203_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *amMobJA_enum_anonymous_enum_______include_moastTypes_hh_203_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_203_info_struct={
	"anonymous_enum_______include_moastTypes_hh_203",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_203_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_203_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH,
	(cms_symbol_lookup_function_t)amMobJA_enum_anonymous_enum_______include_moastTypes_hh_203_symbol_lookup
	};

// RCS_STATUS
#ifndef MAX_ENUM_RCS_STATUS_STRING_LENGTH
#define MAX_ENUM_RCS_STATUS_STRING_LENGTH 21
#endif
#ifndef ENUM_RCS_STATUS_LENGTH
#define ENUM_RCS_STATUS_LENGTH 5
#endif

static const char enum_RCS_STATUS_string_list[ENUM_RCS_STATUS_LENGTH][MAX_ENUM_RCS_STATUS_STRING_LENGTH]= {
	"RCS_DONE", /* 0,1 */
	"RCS_ERROR", /* 1,3 */
	"RCS_EXEC", /* 2,2 */
	"UNINITIALIZED_STATUS", /* 3,-1 */
	""};

static const int enum_RCS_STATUS_int_list[ENUM_RCS_STATUS_LENGTH]= {
	RCS_DONE, /* 0,1 */
	RCS_ERROR, /* 1,3 */
	RCS_EXEC, /* 2,2 */
	UNINITIALIZED_STATUS, /* 3,-1 */
	};

const char *amMobJA_enum_RCS_STATUS_symbol_lookup(long v)
{
	switch(v)
	{
		case RCS_DONE: return("RCS_DONE"); /* 1 */
		case RCS_ERROR: return("RCS_ERROR"); /* 3 */
		case RCS_EXEC: return("RCS_EXEC"); /* 2 */
		case UNINITIALIZED_STATUS: return("UNINITIALIZED_STATUS"); /* -1 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_STATUS_info_struct={
	"RCS_STATUS",
	(const char **)enum_RCS_STATUS_string_list,
	enum_RCS_STATUS_int_list,
	MAX_ENUM_RCS_STATUS_STRING_LENGTH,
	ENUM_RCS_STATUS_LENGTH,
	(cms_symbol_lookup_function_t)amMobJA_enum_RCS_STATUS_symbol_lookup
	};

// RCS_ADMIN_STATE
#ifndef MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH
#define MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH 20
#endif
#ifndef ENUM_RCS_ADMIN_STATE_LENGTH
#define ENUM_RCS_ADMIN_STATE_LENGTH 5
#endif

static const char enum_RCS_ADMIN_STATE_string_list[ENUM_RCS_ADMIN_STATE_LENGTH][MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH]= {
	"ADMIN_INITIALIZED", /* 0,2 */
	"ADMIN_SHUT_DOWN", /* 1,3 */
	"ADMIN_UNINITIALIZED", /* 2,1 */
	"RCS_ADMIN_ZERO", /* 3,0 */
	""};

static const int enum_RCS_ADMIN_STATE_int_list[ENUM_RCS_ADMIN_STATE_LENGTH]= {
	ADMIN_INITIALIZED, /* 0,2 */
	ADMIN_SHUT_DOWN, /* 1,3 */
	ADMIN_UNINITIALIZED, /* 2,1 */
	RCS_ADMIN_ZERO, /* 3,0 */
	};

const char *amMobJA_enum_RCS_ADMIN_STATE_symbol_lookup(long v)
{
	switch(v)
	{
		case ADMIN_INITIALIZED: return("ADMIN_INITIALIZED"); /* 2 */
		case ADMIN_SHUT_DOWN: return("ADMIN_SHUT_DOWN"); /* 3 */
		case ADMIN_UNINITIALIZED: return("ADMIN_UNINITIALIZED"); /* 1 */
		case RCS_ADMIN_ZERO: return("RCS_ADMIN_ZERO"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_ADMIN_STATE_info_struct={
	"RCS_ADMIN_STATE",
	(const char **)enum_RCS_ADMIN_STATE_string_list,
	enum_RCS_ADMIN_STATE_int_list,
	MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH,
	ENUM_RCS_ADMIN_STATE_LENGTH,
	(cms_symbol_lookup_function_t)amMobJA_enum_RCS_ADMIN_STATE_symbol_lookup
	};

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *amMobJA_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)amMobJA_enum_moastSteerType_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *amMobJA_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)amMobJA_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *amMobJA_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)amMobJA_enum_moastRobotType_symbol_lookup
	};

/*
Estimated_size	AmMobJACfgCellResolution	32
Estimated_size	AmMobJACfgCycleTime	32
Estimated_size	AmMobJACfgDebug	32
Estimated_size	AmMobJACfgDumpWM	25
Estimated_size	AmMobJACfgNop	24
Estimated_size	AmMobJACfgPlanHorizon	32
Estimated_size	AmMobJACfgVehicleMinTurnRad	32
Estimated_size	AmMobJACfgVehicleWidth	32
Estimated_size	AmMobJACmdAbort	24
Estimated_size	AmMobJACmdHalt	24
Estimated_size	AmMobJACmdInit	24
Estimated_size	AmMobJACmdMoveWaypoint	4164
Estimated_size	AmMobJACmdNop	24
Estimated_size	AmMobJACmdPrepareMove	40
Estimated_size	AmMobJACmdShutdown	24
Estimated_size	AmMobJACmdSpin	48
Estimated_size	AmMobJASet	240
Estimated_size	AmMobJAStat	5120
Estimated_size	MAXIMUM	5120
*/
/*
*	NML/CMS Format function : amMobJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
int amMobJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"amMobJA",
		(cms_symbol_lookup_function_t) amMobJA_symbol_lookup,
		(const char **)amMobJA_name_list,
		amMobJA_id_list,amMobJA_size_list,
		AMMOBJA_NAME_LIST_LENGTH,
		MAX_AMMOBJA_NAME_LENGTH);

	switch(type)
	{
	case AM_MOB_JA_CFG_CELL_RESOLUTION_TYPE:
		((AmMobJACfgCellResolution *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_CYCLE_TIME_TYPE:
		((AmMobJACfgCycleTime *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_DEBUG_TYPE:
		((AmMobJACfgDebug *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_DUMP_WM_TYPE:
		((AmMobJACfgDumpWM *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_NOP_TYPE:
		((AmMobJACfgNop *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_PLAN_HORIZON_TYPE:
		((AmMobJACfgPlanHorizon *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_VEHICLE_MIN_TURN_RAD_TYPE:
		((AmMobJACfgVehicleMinTurnRad *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_VEHICLE_WIDTH_TYPE:
		((AmMobJACfgVehicleWidth *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_ABORT_TYPE:
		((AmMobJACmdAbort *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_HALT_TYPE:
		((AmMobJACmdHalt *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_INIT_TYPE:
		((AmMobJACmdInit *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE:
		((AmMobJACmdMoveWaypoint *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_NOP_TYPE:
		((AmMobJACmdNop *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_PREPARE_MOVE_TYPE:
		((AmMobJACmdPrepareMove *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_SHUTDOWN_TYPE:
		((AmMobJACmdShutdown *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_SPIN_TYPE:
		((AmMobJACmdSpin *) buffer)->update(cms);
		break;
	case AM_MOB_JA_SET_TYPE:
		((AmMobJASet *) buffer)->update(cms);
		break;
	case AM_MOB_JA_STAT_TYPE:
		((AmMobJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *amMobJA_symbol_lookup(long type)
{
	switch(type)
	{
	case AM_MOB_JA_CFG_CELL_RESOLUTION_TYPE:
		return "AmMobJACfgCellResolution";
	case AM_MOB_JA_CFG_CYCLE_TIME_TYPE:
		return "AmMobJACfgCycleTime";
	case AM_MOB_JA_CFG_DEBUG_TYPE:
		return "AmMobJACfgDebug";
	case AM_MOB_JA_CFG_DUMP_WM_TYPE:
		return "AmMobJACfgDumpWM";
	case AM_MOB_JA_CFG_NOP_TYPE:
		return "AmMobJACfgNop";
	case AM_MOB_JA_CFG_PLAN_HORIZON_TYPE:
		return "AmMobJACfgPlanHorizon";
	case AM_MOB_JA_CFG_VEHICLE_MIN_TURN_RAD_TYPE:
		return "AmMobJACfgVehicleMinTurnRad";
	case AM_MOB_JA_CFG_VEHICLE_WIDTH_TYPE:
		return "AmMobJACfgVehicleWidth";
	case AM_MOB_JA_CMD_ABORT_TYPE:
		return "AmMobJACmdAbort";
	case AM_MOB_JA_CMD_HALT_TYPE:
		return "AmMobJACmdHalt";
	case AM_MOB_JA_CMD_INIT_TYPE:
		return "AmMobJACmdInit";
	case AM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE:
		return "AmMobJACmdMoveWaypoint";
	case AM_MOB_JA_CMD_NOP_TYPE:
		return "AmMobJACmdNop";
	case AM_MOB_JA_CMD_PREPARE_MOVE_TYPE:
		return "AmMobJACmdPrepareMove";
	case AM_MOB_JA_CMD_SHUTDOWN_TYPE:
		return "AmMobJACmdShutdown";
	case AM_MOB_JA_CMD_SPIN_TYPE:
		return "AmMobJACmdSpin";
	case AM_MOB_JA_SET_TYPE:
		return "AmMobJASet";
	case AM_MOB_JA_STAT_TYPE:
		return "AmMobJAStat";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for AmMobJACfgCellResolution
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgCellResolution::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgCellResolution","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cellResolution",cellResolution);

	cms->endClass("AmMobJACfgCellResolution","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("AmMobJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgDebug::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("AmMobJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgDumpWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgDumpWM::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgDumpWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("turnOn",turnOn);

	cms->endClass("AmMobJACfgDumpWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgNop::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgPlanHorizon
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgPlanHorizon::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgPlanHorizon","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("planHorizon",planHorizon);

	cms->endClass("AmMobJACfgPlanHorizon","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgVehicleMinTurnRad
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgVehicleMinTurnRad::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgVehicleMinTurnRad","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vehicleMinTurnRad",vehicleMinTurnRad);

	cms->endClass("AmMobJACfgVehicleMinTurnRad","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgVehicleWidth
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACfgVehicleWidth::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgVehicleWidth","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vehicleWidth",vehicleWidth);

	cms->endClass("AmMobJACfgVehicleWidth","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdAbort::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdHalt::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdInit::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdMoveWaypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdMoveWaypoint::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdMoveWaypoint","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("computeHorizonCosts",computeHorizonCosts);
	cms->update_with_name("neighborhood",neighborhood);
	cms->update_with_name("speed",speed);
	cms->update_dla_length_with_name("waypoint_length",waypoint_length);
	cms->beginStructDynamicArray("waypoint",waypoint_length,100);
	for(int i_waypoint = 0;i_waypoint < waypoint_length ;i_waypoint++)
	{
		cms->beginStructArrayElem("waypoint",i_waypoint);
		nmlupdate(cms,&(waypoint[i_waypoint]));
		cms->endStructArrayElem("waypoint",i_waypoint);
	}
	cms->endStructDynamicArray("waypoint",waypoint_length,100);

	cms->endClass("AmMobJACmdMoveWaypoint","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdNop::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdPrepareMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdPrepareMove::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdPrepareMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("neighborhood",neighborhood);
	cms->update_with_name("speed",speed);

	cms->endClass("AmMobJACmdPrepareMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdSpin
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJACmdSpin::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdSpin","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("direction",direction);
	cms->update_with_name("absAngle",absAngle);
	cms->update_with_name("tolerance",tolerance);

	cms->endClass("AmMobJACmdSpin","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJASet::update(CMS *cms)
{

	cms->beginClass("AmMobJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cellResolution",cellResolution);
	cms->update_with_name("controlPoint",controlPoint);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("dumpWM",dumpWM);
	cms->update_with_name("planHorizon",planHorizon);
	cms->update_with_name("vehicleMinTurnRad",vehicleMinTurnRad);
	cms->update_with_name("vehicleWidth",vehicleWidth);

	cms->endClass("AmMobJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for AmMobJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:57 GMT-05:00 2008
*/
void AmMobJAStat::update(CMS *cms)
{

	cms->beginClass("AmMobJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("amMobJAError",amMobJAError);
	cms->update_dla_length_with_name("seed_length",seed_length);
	cms->update_dla_with_name("seed",seed,seed_length,200);

	cms->endClass("AmMobJAStat","RCS_STAT_MSG_V2");

}

