/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "primMobJA.hh"

// Forward Function Prototypes
void nmlupdate(CMS *cms, ArcSegment *x);
void initialize_ArcSegment(ArcSegment *x);
void nmlupdate(CMS *cms, Waypoint *x);
void initialize_Waypoint(Waypoint *x);


#ifndef MAX_PRIMMOBJA_NAME_LENGTH
#define MAX_PRIMMOBJA_NAME_LENGTH 27
#endif
#ifndef PRIMMOBJA_NAME_LIST_LENGTH
#define PRIMMOBJA_NAME_LIST_LENGTH 18
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char primMobJA_name_list[PRIMMOBJA_NAME_LIST_LENGTH][MAX_PRIMMOBJA_NAME_LENGTH]= {
	"PrimMobJACfgCycleTime", /* 0,8202 */
	"PrimMobJACfgDebug", /* 1,8204 */
	"PrimMobJACfgMove", /* 2,8203 */
	"PrimMobJACfgNop", /* 3,8201 */
	"PrimMobJACmdAbort", /* 4,8003 */
	"PrimMobJACmdDock", /* 5,8011 */
	"PrimMobJACmdHalt", /* 6,8004 */
	"PrimMobJACmdInit", /* 7,8002 */
	"PrimMobJACmdMoveArcSegment", /* 8,8006 */
	"PrimMobJACmdMoveWaypoint", /* 9,8007 */
	"PrimMobJACmdNop", /* 10,8001 */
	"PrimMobJACmdRotate", /* 11,8008 */
	"PrimMobJACmdShutdown", /* 12,8005 */
	"PrimMobJACmdStop", /* 13,8010 */
	"PrimMobJACmdVel", /* 14,8009 */
	"PrimMobJASet", /* 15,8301 */
	"PrimMobJAStat", /* 16,8101 */
	""};
const NMLTYPE primMobJA_id_list[PRIMMOBJA_NAME_LIST_LENGTH]= {
	PRIM_MOB_JA_CFG_CYCLE_TIME_TYPE, /* 0,8202 */
	PRIM_MOB_JA_CFG_DEBUG_TYPE, /* 1,8204 */
	PRIM_MOB_JA_CFG_MOVE_TYPE, /* 2,8203 */
	PRIM_MOB_JA_CFG_NOP_TYPE, /* 3,8201 */
	PRIM_MOB_JA_CMD_ABORT_TYPE, /* 4,8003 */
	PRIM_MOB_JA_CMD_DOCK_TYPE, /* 5,8011 */
	PRIM_MOB_JA_CMD_HALT_TYPE, /* 6,8004 */
	PRIM_MOB_JA_CMD_INIT_TYPE, /* 7,8002 */
	PRIM_MOB_JA_CMD_MOVE_ARC_SEGMENT_TYPE, /* 8,8006 */
	PRIM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE, /* 9,8007 */
	PRIM_MOB_JA_CMD_NOP_TYPE, /* 10,8001 */
	PRIM_MOB_JA_CMD_ROTATE_TYPE, /* 11,8008 */
	PRIM_MOB_JA_CMD_SHUTDOWN_TYPE, /* 12,8005 */
	PRIM_MOB_JA_CMD_STOP_TYPE, /* 13,8010 */
	PRIM_MOB_JA_CMD_VEL_TYPE, /* 14,8009 */
	PRIM_MOB_JA_SET_TYPE, /* 15,8301 */
	PRIM_MOB_JA_STAT_TYPE, /* 16,8101 */
	-1};
const size_t primMobJA_size_list[PRIMMOBJA_NAME_LIST_LENGTH]= {
	sizeof(PrimMobJACfgCycleTime),
	sizeof(PrimMobJACfgDebug),
	sizeof(PrimMobJACfgMove),
	sizeof(PrimMobJACfgNop),
	sizeof(PrimMobJACmdAbort),
	sizeof(PrimMobJACmdDock),
	sizeof(PrimMobJACmdHalt),
	sizeof(PrimMobJACmdInit),
	sizeof(PrimMobJACmdMoveArcSegment),
	sizeof(PrimMobJACmdMoveWaypoint),
	sizeof(PrimMobJACmdNop),
	sizeof(PrimMobJACmdRotate),
	sizeof(PrimMobJACmdShutdown),
	sizeof(PrimMobJACmdStop),
	sizeof(PrimMobJACmdVel),
	sizeof(PrimMobJASet),
	sizeof(PrimMobJAStat),
	0};
const char *primMobJA_symbol_lookup(long type);


// Enumerated Type Constants

// anonymous_enum_______include_moastTypes_hh_203
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_203_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_203_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *primMobJA_enum_anonymous_enum_______include_moastTypes_hh_203_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_203_info_struct={
	"anonymous_enum_______include_moastTypes_hh_203",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_203_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_203_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_anonymous_enum_______include_moastTypes_hh_203_symbol_lookup
	};

// RCS_STATUS
#ifndef MAX_ENUM_RCS_STATUS_STRING_LENGTH
#define MAX_ENUM_RCS_STATUS_STRING_LENGTH 21
#endif
#ifndef ENUM_RCS_STATUS_LENGTH
#define ENUM_RCS_STATUS_LENGTH 5
#endif

static const char enum_RCS_STATUS_string_list[ENUM_RCS_STATUS_LENGTH][MAX_ENUM_RCS_STATUS_STRING_LENGTH]= {
	"RCS_DONE", /* 0,1 */
	"RCS_ERROR", /* 1,3 */
	"RCS_EXEC", /* 2,2 */
	"UNINITIALIZED_STATUS", /* 3,-1 */
	""};

static const int enum_RCS_STATUS_int_list[ENUM_RCS_STATUS_LENGTH]= {
	RCS_DONE, /* 0,1 */
	RCS_ERROR, /* 1,3 */
	RCS_EXEC, /* 2,2 */
	UNINITIALIZED_STATUS, /* 3,-1 */
	};

const char *primMobJA_enum_RCS_STATUS_symbol_lookup(long v)
{
	switch(v)
	{
		case RCS_DONE: return("RCS_DONE"); /* 1 */
		case RCS_ERROR: return("RCS_ERROR"); /* 3 */
		case RCS_EXEC: return("RCS_EXEC"); /* 2 */
		case UNINITIALIZED_STATUS: return("UNINITIALIZED_STATUS"); /* -1 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_STATUS_info_struct={
	"RCS_STATUS",
	(const char **)enum_RCS_STATUS_string_list,
	enum_RCS_STATUS_int_list,
	MAX_ENUM_RCS_STATUS_STRING_LENGTH,
	ENUM_RCS_STATUS_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_RCS_STATUS_symbol_lookup
	};

// RCS_ADMIN_STATE
#ifndef MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH
#define MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH 20
#endif
#ifndef ENUM_RCS_ADMIN_STATE_LENGTH
#define ENUM_RCS_ADMIN_STATE_LENGTH 5
#endif

static const char enum_RCS_ADMIN_STATE_string_list[ENUM_RCS_ADMIN_STATE_LENGTH][MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH]= {
	"ADMIN_INITIALIZED", /* 0,2 */
	"ADMIN_SHUT_DOWN", /* 1,3 */
	"ADMIN_UNINITIALIZED", /* 2,1 */
	"RCS_ADMIN_ZERO", /* 3,0 */
	""};

static const int enum_RCS_ADMIN_STATE_int_list[ENUM_RCS_ADMIN_STATE_LENGTH]= {
	ADMIN_INITIALIZED, /* 0,2 */
	ADMIN_SHUT_DOWN, /* 1,3 */
	ADMIN_UNINITIALIZED, /* 2,1 */
	RCS_ADMIN_ZERO, /* 3,0 */
	};

const char *primMobJA_enum_RCS_ADMIN_STATE_symbol_lookup(long v)
{
	switch(v)
	{
		case ADMIN_INITIALIZED: return("ADMIN_INITIALIZED"); /* 2 */
		case ADMIN_SHUT_DOWN: return("ADMIN_SHUT_DOWN"); /* 3 */
		case ADMIN_UNINITIALIZED: return("ADMIN_UNINITIALIZED"); /* 1 */
		case RCS_ADMIN_ZERO: return("RCS_ADMIN_ZERO"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_ADMIN_STATE_info_struct={
	"RCS_ADMIN_STATE",
	(const char **)enum_RCS_ADMIN_STATE_string_list,
	enum_RCS_ADMIN_STATE_int_list,
	MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH,
	ENUM_RCS_ADMIN_STATE_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_RCS_ADMIN_STATE_symbol_lookup
	};

// anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66
#ifndef MAX_ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_STRING_LENGTH 26
#endif
#ifndef ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_LENGTH
#define ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_LENGTH 2
#endif

static const char enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_string_list[ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_LENGTH][MAX_ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_STRING_LENGTH]= {
	"PRIM_MOB_JA_ERROR_BAD_CFG", /* 0,8401 */
	""};

static const int enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_int_list[ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_LENGTH]= {
	PRIM_MOB_JA_ERROR_BAD_CFG, /* 0,8401 */
	};

const char *primMobJA_enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_symbol_lookup(long v)
{
	switch(v)
	{
		case PRIM_MOB_JA_ERROR_BAD_CFG: return("PRIM_MOB_JA_ERROR_BAD_CFG"); /* 8401 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_info_struct={
	"anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66",
	(const char **)enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_string_list,
	enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_int_list,
	MAX_ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM__USR_LOCAL_SRC_MOAST_DEVEL_INCLUDE_PRIMMOBJA_HH_66_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_anonymous_enum__usr_local_src_moast_devel_include_primMobJA_hh_66_symbol_lookup
	};

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *primMobJA_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_moastSteerType_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *primMobJA_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *primMobJA_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)primMobJA_enum_moastRobotType_symbol_lookup
	};

/*
Estimated_size	PrimMobJACfgCycleTime	32
Estimated_size	PrimMobJACfgDebug	32
Estimated_size	PrimMobJACfgMove	72
Estimated_size	PrimMobJACfgNop	24
Estimated_size	PrimMobJACmdAbort	24
Estimated_size	PrimMobJACmdDock	144
Estimated_size	PrimMobJACmdHalt	24
Estimated_size	PrimMobJACmdInit	24
Estimated_size	PrimMobJACmdMoveArcSegment	10440
Estimated_size	PrimMobJACmdMoveWaypoint	4148
Estimated_size	PrimMobJACmdNop	24
Estimated_size	PrimMobJACmdRotate	48
Estimated_size	PrimMobJACmdShutdown	24
Estimated_size	PrimMobJACmdStop	24
Estimated_size	PrimMobJACmdVel	40
Estimated_size	PrimMobJASet	248
Estimated_size	PrimMobJAStat	320
Estimated_size	MAXIMUM	10440
*/
/*
*	NML/CMS Format function : primMobJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
int primMobJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"primMobJA",
		(cms_symbol_lookup_function_t) primMobJA_symbol_lookup,
		(const char **)primMobJA_name_list,
		primMobJA_id_list,primMobJA_size_list,
		PRIMMOBJA_NAME_LIST_LENGTH,
		MAX_PRIMMOBJA_NAME_LENGTH);

	switch(type)
	{
	case PRIM_MOB_JA_CFG_CYCLE_TIME_TYPE:
		((PrimMobJACfgCycleTime *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CFG_DEBUG_TYPE:
		((PrimMobJACfgDebug *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CFG_MOVE_TYPE:
		((PrimMobJACfgMove *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CFG_NOP_TYPE:
		((PrimMobJACfgNop *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_ABORT_TYPE:
		((PrimMobJACmdAbort *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_DOCK_TYPE:
		((PrimMobJACmdDock *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_HALT_TYPE:
		((PrimMobJACmdHalt *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_INIT_TYPE:
		((PrimMobJACmdInit *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_MOVE_ARC_SEGMENT_TYPE:
		((PrimMobJACmdMoveArcSegment *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE:
		((PrimMobJACmdMoveWaypoint *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_NOP_TYPE:
		((PrimMobJACmdNop *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_ROTATE_TYPE:
		((PrimMobJACmdRotate *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_SHUTDOWN_TYPE:
		((PrimMobJACmdShutdown *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_STOP_TYPE:
		((PrimMobJACmdStop *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_VEL_TYPE:
		((PrimMobJACmdVel *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_SET_TYPE:
		((PrimMobJASet *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_STAT_TYPE:
		((PrimMobJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *primMobJA_symbol_lookup(long type)
{
	switch(type)
	{
	case PRIM_MOB_JA_CFG_CYCLE_TIME_TYPE:
		return "PrimMobJACfgCycleTime";
	case PRIM_MOB_JA_CFG_DEBUG_TYPE:
		return "PrimMobJACfgDebug";
	case PRIM_MOB_JA_CFG_MOVE_TYPE:
		return "PrimMobJACfgMove";
	case PRIM_MOB_JA_CFG_NOP_TYPE:
		return "PrimMobJACfgNop";
	case PRIM_MOB_JA_CMD_ABORT_TYPE:
		return "PrimMobJACmdAbort";
	case PRIM_MOB_JA_CMD_DOCK_TYPE:
		return "PrimMobJACmdDock";
	case PRIM_MOB_JA_CMD_HALT_TYPE:
		return "PrimMobJACmdHalt";
	case PRIM_MOB_JA_CMD_INIT_TYPE:
		return "PrimMobJACmdInit";
	case PRIM_MOB_JA_CMD_MOVE_ARC_SEGMENT_TYPE:
		return "PrimMobJACmdMoveArcSegment";
	case PRIM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE:
		return "PrimMobJACmdMoveWaypoint";
	case PRIM_MOB_JA_CMD_NOP_TYPE:
		return "PrimMobJACmdNop";
	case PRIM_MOB_JA_CMD_ROTATE_TYPE:
		return "PrimMobJACmdRotate";
	case PRIM_MOB_JA_CMD_SHUTDOWN_TYPE:
		return "PrimMobJACmdShutdown";
	case PRIM_MOB_JA_CMD_STOP_TYPE:
		return "PrimMobJACmdStop";
	case PRIM_MOB_JA_CMD_VEL_TYPE:
		return "PrimMobJACmdVel";
	case PRIM_MOB_JA_SET_TYPE:
		return "PrimMobJASet";
	case PRIM_MOB_JA_STAT_TYPE:
		return "PrimMobJAStat";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for PrimMobJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("PrimMobJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACfgDebug::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("PrimMobJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACfgMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACfgMove::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vmax",vmax);
	cms->update_with_name("amax",amax);
	cms->update_with_name("wmax",wmax);
	cms->update_with_name("alphamax",alphamax);
	cms->update_with_name("vCutoffAngle",vCutoffAngle);
	cms->update_with_name("wCutoffAngle",wCutoffAngle);

	cms->endClass("PrimMobJACfgMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACfgNop::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdAbort::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdDock
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdDock::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdDock","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("freeSpaceUpperRight",freeSpaceUpperRight);
	cms->update_with_name("freeSpaceLowerLeft",freeSpaceLowerLeft);
	cms->update_with_name("stationUpperRight",stationUpperRight);
	cms->update_with_name("stationLowerLeft",stationLowerLeft);
	cms->update_with_name("dockPoint",dockPoint);

	cms->endClass("PrimMobJACmdDock","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdHalt::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdInit::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdMoveArcSegment
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdMoveArcSegment::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdMoveArcSegment","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_dla_length_with_name("arcList_length",arcList_length);
	cms->beginStructDynamicArray("arcList",arcList_length,100);
	for(int i_arcList = 0;i_arcList < arcList_length ;i_arcList++)
	{
		cms->beginStructArrayElem("arcList",i_arcList);
		nmlupdate(cms,&(arcList[i_arcList]));
		cms->endStructArrayElem("arcList",i_arcList);
	}
	cms->endStructDynamicArray("arcList",arcList_length,100);

	cms->endClass("PrimMobJACmdMoveArcSegment","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdMoveWaypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdMoveWaypoint::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdMoveWaypoint","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("prim_path",prim_path);
	cms->update_dla_length_with_name("waypoint_length",waypoint_length);
	cms->beginStructDynamicArray("waypoint",waypoint_length,100);
	for(int i_waypoint = 0;i_waypoint < waypoint_length ;i_waypoint++)
	{
		cms->beginStructArrayElem("waypoint",i_waypoint);
		nmlupdate(cms,&(waypoint[i_waypoint]));
		cms->endStructArrayElem("waypoint",i_waypoint);
	}
	cms->endStructDynamicArray("waypoint",waypoint_length,100);

	cms->endClass("PrimMobJACmdMoveWaypoint","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdNop::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdRotate
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdRotate::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdRotate","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("theta",theta);
	cms->update_with_name("thetaTol",thetaTol);
	cms->update_with_name("direction",direction);

	cms->endClass("PrimMobJACmdRotate","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdStop
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdStop::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdStop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdStop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdVel
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJACmdVel::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdVel","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("v",v);
	cms->update_with_name("w",w);

	cms->endClass("PrimMobJACmdVel","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJASet::update(CMS *cms)
{

	cms->beginClass("PrimMobJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("vmax",vmax);
	cms->update_with_name("amax",amax);
	cms->update_with_name("wmax",wmax);
	cms->update_with_name("alphamax",alphamax);
	cms->update_with_name("vCutoffAngle",vCutoffAngle);
	cms->update_with_name("wCutoffAngle",wCutoffAngle);
	cms->update_with_name("controlPoint",controlPoint);

	cms->endClass("PrimMobJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for PrimMobJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Sun Oct 19 17:55:55 GMT-04:00 2008
*/
void PrimMobJAStat::update(CMS *cms)
{

	cms->beginClass("PrimMobJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("command_type_sent",command_type_sent);
	cms->update_with_name("serial_number_sent",serial_number_sent);
	cms->update_with_name("pathIndex",pathIndex);

	cms->endClass("PrimMobJAStat","RCS_STAT_MSG_V2");

}

