/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "primSP.hh"

// Forward Function Prototypes


#ifndef MAX_PRIMSP_NAME_LENGTH
#define MAX_PRIMSP_NAME_LENGTH 19
#endif
#ifndef PRIMSP_NAME_LIST_LENGTH
#define PRIMSP_NAME_LIST_LENGTH 12
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char primSP_name_list[PRIMSP_NAME_LIST_LENGTH][MAX_PRIMSP_NAME_LENGTH]= {
	"PrimSPCfgCycleTime", /* 0,6202 */
	"PrimSPCfgDebug", /* 1,6203 */
	"PrimSPCfgNop", /* 2,6201 */
	"PrimSPCmdAbort", /* 3,6003 */
	"PrimSPCmdGo", /* 4,6006 */
	"PrimSPCmdHalt", /* 5,6004 */
	"PrimSPCmdInit", /* 6,6002 */
	"PrimSPCmdNop", /* 7,6001 */
	"PrimSPCmdShutdown", /* 8,6005 */
	"PrimSPSet", /* 9,6301 */
	"PrimSPStat", /* 10,6101 */
	""};
const NMLTYPE primSP_id_list[PRIMSP_NAME_LIST_LENGTH]= {
	PRIM_SP_CFG_CYCLE_TIME_TYPE, /* 0,6202 */
	PRIM_SP_CFG_DEBUG_TYPE, /* 1,6203 */
	PRIM_SP_CFG_NOP_TYPE, /* 2,6201 */
	PRIM_SP_CMD_ABORT_TYPE, /* 3,6003 */
	PRIM_SP_CMD_GO_TYPE, /* 4,6006 */
	PRIM_SP_CMD_HALT_TYPE, /* 5,6004 */
	PRIM_SP_CMD_INIT_TYPE, /* 6,6002 */
	PRIM_SP_CMD_NOP_TYPE, /* 7,6001 */
	PRIM_SP_CMD_SHUTDOWN_TYPE, /* 8,6005 */
	PRIM_SP_SET_TYPE, /* 9,6301 */
	PRIM_SP_STAT_TYPE, /* 10,6101 */
	-1};
const size_t primSP_size_list[PRIMSP_NAME_LIST_LENGTH]= {
	sizeof(PrimSPCfgCycleTime),
	sizeof(PrimSPCfgDebug),
	sizeof(PrimSPCfgNop),
	sizeof(PrimSPCmdAbort),
	sizeof(PrimSPCmdGo),
	sizeof(PrimSPCmdHalt),
	sizeof(PrimSPCmdInit),
	sizeof(PrimSPCmdNop),
	sizeof(PrimSPCmdShutdown),
	sizeof(PrimSPSet),
	sizeof(PrimSPStat),
	0};
const char *primSP_symbol_lookup(long type);


// Enumerated Type Constants

// anonymous_enum_______include_moastTypes_hh_203
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_203_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_203_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *primSP_enum_anonymous_enum_______include_moastTypes_hh_203_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_203_info_struct={
	"anonymous_enum_______include_moastTypes_hh_203",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_203_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_203_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_203_LENGTH,
	(cms_symbol_lookup_function_t)primSP_enum_anonymous_enum_______include_moastTypes_hh_203_symbol_lookup
	};

// RCS_STATUS
#ifndef MAX_ENUM_RCS_STATUS_STRING_LENGTH
#define MAX_ENUM_RCS_STATUS_STRING_LENGTH 21
#endif
#ifndef ENUM_RCS_STATUS_LENGTH
#define ENUM_RCS_STATUS_LENGTH 5
#endif

static const char enum_RCS_STATUS_string_list[ENUM_RCS_STATUS_LENGTH][MAX_ENUM_RCS_STATUS_STRING_LENGTH]= {
	"RCS_DONE", /* 0,1 */
	"RCS_ERROR", /* 1,3 */
	"RCS_EXEC", /* 2,2 */
	"UNINITIALIZED_STATUS", /* 3,-1 */
	""};

static const int enum_RCS_STATUS_int_list[ENUM_RCS_STATUS_LENGTH]= {
	RCS_DONE, /* 0,1 */
	RCS_ERROR, /* 1,3 */
	RCS_EXEC, /* 2,2 */
	UNINITIALIZED_STATUS, /* 3,-1 */
	};

const char *primSP_enum_RCS_STATUS_symbol_lookup(long v)
{
	switch(v)
	{
		case RCS_DONE: return("RCS_DONE"); /* 1 */
		case RCS_ERROR: return("RCS_ERROR"); /* 3 */
		case RCS_EXEC: return("RCS_EXEC"); /* 2 */
		case UNINITIALIZED_STATUS: return("UNINITIALIZED_STATUS"); /* -1 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_STATUS_info_struct={
	"RCS_STATUS",
	(const char **)enum_RCS_STATUS_string_list,
	enum_RCS_STATUS_int_list,
	MAX_ENUM_RCS_STATUS_STRING_LENGTH,
	ENUM_RCS_STATUS_LENGTH,
	(cms_symbol_lookup_function_t)primSP_enum_RCS_STATUS_symbol_lookup
	};

// RCS_ADMIN_STATE
#ifndef MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH
#define MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH 20
#endif
#ifndef ENUM_RCS_ADMIN_STATE_LENGTH
#define ENUM_RCS_ADMIN_STATE_LENGTH 5
#endif

static const char enum_RCS_ADMIN_STATE_string_list[ENUM_RCS_ADMIN_STATE_LENGTH][MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH]= {
	"ADMIN_INITIALIZED", /* 0,2 */
	"ADMIN_SHUT_DOWN", /* 1,3 */
	"ADMIN_UNINITIALIZED", /* 2,1 */
	"RCS_ADMIN_ZERO", /* 3,0 */
	""};

static const int enum_RCS_ADMIN_STATE_int_list[ENUM_RCS_ADMIN_STATE_LENGTH]= {
	ADMIN_INITIALIZED, /* 0,2 */
	ADMIN_SHUT_DOWN, /* 1,3 */
	ADMIN_UNINITIALIZED, /* 2,1 */
	RCS_ADMIN_ZERO, /* 3,0 */
	};

const char *primSP_enum_RCS_ADMIN_STATE_symbol_lookup(long v)
{
	switch(v)
	{
		case ADMIN_INITIALIZED: return("ADMIN_INITIALIZED"); /* 2 */
		case ADMIN_SHUT_DOWN: return("ADMIN_SHUT_DOWN"); /* 3 */
		case ADMIN_UNINITIALIZED: return("ADMIN_UNINITIALIZED"); /* 1 */
		case RCS_ADMIN_ZERO: return("RCS_ADMIN_ZERO"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_ADMIN_STATE_info_struct={
	"RCS_ADMIN_STATE",
	(const char **)enum_RCS_ADMIN_STATE_string_list,
	enum_RCS_ADMIN_STATE_int_list,
	MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH,
	ENUM_RCS_ADMIN_STATE_LENGTH,
	(cms_symbol_lookup_function_t)primSP_enum_RCS_ADMIN_STATE_symbol_lookup
	};

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *primSP_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)primSP_enum_moastSteerType_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *primSP_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)primSP_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *primSP_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)primSP_enum_moastRobotType_symbol_lookup
	};

/*
Estimated_size	PrimSPCfgCycleTime	32
Estimated_size	PrimSPCfgDebug	32
Estimated_size	PrimSPCfgNop	24
Estimated_size	PrimSPCmdAbort	24
Estimated_size	PrimSPCmdGo	32
Estimated_size	PrimSPCmdHalt	24
Estimated_size	PrimSPCmdInit	24
Estimated_size	PrimSPCmdNop	24
Estimated_size	PrimSPCmdShutdown	24
Estimated_size	PrimSPSet	144
Estimated_size	PrimSPStat	296
Estimated_size	MAXIMUM	296
*/
/*
*	NML/CMS Format function : primSP_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
int primSP_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"primSP",
		(cms_symbol_lookup_function_t) primSP_symbol_lookup,
		(const char **)primSP_name_list,
		primSP_id_list,primSP_size_list,
		PRIMSP_NAME_LIST_LENGTH,
		MAX_PRIMSP_NAME_LENGTH);

	switch(type)
	{
	case PRIM_SP_CFG_CYCLE_TIME_TYPE:
		((PrimSPCfgCycleTime *) buffer)->update(cms);
		break;
	case PRIM_SP_CFG_DEBUG_TYPE:
		((PrimSPCfgDebug *) buffer)->update(cms);
		break;
	case PRIM_SP_CFG_NOP_TYPE:
		((PrimSPCfgNop *) buffer)->update(cms);
		break;
	case PRIM_SP_CMD_ABORT_TYPE:
		((PrimSPCmdAbort *) buffer)->update(cms);
		break;
	case PRIM_SP_CMD_GO_TYPE:
		((PrimSPCmdGo *) buffer)->update(cms);
		break;
	case PRIM_SP_CMD_HALT_TYPE:
		((PrimSPCmdHalt *) buffer)->update(cms);
		break;
	case PRIM_SP_CMD_INIT_TYPE:
		((PrimSPCmdInit *) buffer)->update(cms);
		break;
	case PRIM_SP_CMD_NOP_TYPE:
		((PrimSPCmdNop *) buffer)->update(cms);
		break;
	case PRIM_SP_CMD_SHUTDOWN_TYPE:
		((PrimSPCmdShutdown *) buffer)->update(cms);
		break;
	case PRIM_SP_SET_TYPE:
		((PrimSPSet *) buffer)->update(cms);
		break;
	case PRIM_SP_STAT_TYPE:
		((PrimSPStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *primSP_symbol_lookup(long type)
{
	switch(type)
	{
	case PRIM_SP_CFG_CYCLE_TIME_TYPE:
		return "PrimSPCfgCycleTime";
	case PRIM_SP_CFG_DEBUG_TYPE:
		return "PrimSPCfgDebug";
	case PRIM_SP_CFG_NOP_TYPE:
		return "PrimSPCfgNop";
	case PRIM_SP_CMD_ABORT_TYPE:
		return "PrimSPCmdAbort";
	case PRIM_SP_CMD_GO_TYPE:
		return "PrimSPCmdGo";
	case PRIM_SP_CMD_HALT_TYPE:
		return "PrimSPCmdHalt";
	case PRIM_SP_CMD_INIT_TYPE:
		return "PrimSPCmdInit";
	case PRIM_SP_CMD_NOP_TYPE:
		return "PrimSPCmdNop";
	case PRIM_SP_CMD_SHUTDOWN_TYPE:
		return "PrimSPCmdShutdown";
	case PRIM_SP_SET_TYPE:
		return "PrimSPSet";
	case PRIM_SP_STAT_TYPE:
		return "PrimSPStat";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for PrimSPCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("PrimSPCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("PrimSPCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCfgDebug::update(CMS *cms)
{

	cms->beginClass("PrimSPCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("PrimSPCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCfgNop::update(CMS *cms)
{

	cms->beginClass("PrimSPCfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimSPCfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCmdAbort::update(CMS *cms)
{

	cms->beginClass("PrimSPCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimSPCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCmdGo
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCmdGo::update(CMS *cms)
{

	cms->beginClass("PrimSPCmdGo","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("outputCycleTime",outputCycleTime);

	cms->endClass("PrimSPCmdGo","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCmdHalt::update(CMS *cms)
{

	cms->beginClass("PrimSPCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimSPCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCmdInit::update(CMS *cms)
{

	cms->beginClass("PrimSPCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimSPCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCmdNop::update(CMS *cms)
{

	cms->beginClass("PrimSPCmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimSPCmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPCmdShutdown::update(CMS *cms)
{

	cms->beginClass("PrimSPCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimSPCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimSPSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPSet::update(CMS *cms)
{

	cms->beginClass("PrimSPSet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);

	cms->endClass("PrimSPSet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for PrimSPStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 12 08:39:58 GMT-05:00 2008
*/
void PrimSPStat::update(CMS *cms)
{

	cms->beginClass("PrimSPStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");


	cms->endClass("PrimSPStat","RCS_STAT_MSG_V2");

}

