/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "servoMobJA.hh"

// Forward Function Prototypes
void nmlupdate(CMS *cms, ServoMobJAFlipperMsg *x);
void initialize_ServoMobJAFlipperMsg(ServoMobJAFlipperMsg *x);
void nmlupdate(CMS *cms, ServoMobJAFlipperSet *x);
void initialize_ServoMobJAFlipperSet(ServoMobJAFlipperSet *x);

/*
*	Initializer for ServoMobJAFlipperMsg
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void initialize_ServoMobJAFlipperMsg(ServoMobJAFlipperMsg* x)
{
	x->fType = (moastFlipperType) 0;
	x->flipperAngle = (double) 0;

}

/*
*	Initializer for ServoMobJAFlipperSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void initialize_ServoMobJAFlipperSet(ServoMobJAFlipperSet* x)
{
	x->fType = (moastFlipperType) 0;
	x->minAngle = (double) 0;
	x->maxAngle = (double) 0;
	x->length = (double) 0;
	x->width = (double) 0;

}


#ifndef MAX_SERVOMOBJA_NAME_LENGTH
#define MAX_SERVOMOBJA_NAME_LENGTH 24
#endif
#ifndef SERVOMOBJA_NAME_LIST_LENGTH
#define SERVOMOBJA_NAME_LIST_LENGTH 20
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char servoMobJA_name_list[SERVOMOBJA_NAME_LIST_LENGTH][MAX_SERVOMOBJA_NAME_LENGTH]= {
	"ServoMobJACfgCycleTime", /* 0,4201 */
	"ServoMobJACfgDebug", /* 1,4202 */
	"ServoMobJACfgTeleport", /* 2,4203 */
	"ServoMobJACmdAbort", /* 3,4002 */
	"ServoMobJACmdAckerman", /* 4,4005 */
	"ServoMobJACmdFlipSkid", /* 5,4007 */
	"ServoMobJACmdHalt", /* 6,4003 */
	"ServoMobJACmdInit", /* 7,4001 */
	"ServoMobJACmdOmni", /* 8,4008 */
	"ServoMobJACmdRotaryWing", /* 9,4010 */
	"ServoMobJACmdShutdown", /* 10,4004 */
	"ServoMobJACmdSkid", /* 11,4006 */
	"ServoMobJACmdSubmarine", /* 12,4009 */
	"ServoMobJASet", /* 15,4301 */
	"ServoMobJASetAirBot", /* 16,4303 */
	"ServoMobJASetGrdVeh", /* 17,4302 */
	"ServoMobJAStat", /* 18,4101 */
	"ServoMobJAStatAirBot", /* 19,4103 */
	"ServoMobJAStatGrdVeh", /* 20,4102 */
	""};
const NMLTYPE servoMobJA_id_list[SERVOMOBJA_NAME_LIST_LENGTH]= {
	SERVO_MOB_JA_CFG_CYCLE_TIME_TYPE, /* 0,4201 */
	SERVO_MOB_JA_CFG_DEBUG_TYPE, /* 1,4202 */
	SERVO_MOB_JA_CFG_TELEPORT_TYPE, /* 2,4203 */
	SERVO_MOB_JA_CMD_ABORT_TYPE, /* 3,4002 */
	SERVO_MOB_JA_CMD_ACKERMAN_TYPE, /* 4,4005 */
	SERVO_MOB_JA_CMD_FLIP_SKID_TYPE, /* 5,4007 */
	SERVO_MOB_JA_CMD_HALT_TYPE, /* 6,4003 */
	SERVO_MOB_JA_CMD_INIT_TYPE, /* 7,4001 */
	SERVO_MOB_JA_CMD_OMNI_TYPE, /* 8,4008 */
	SERVO_MOB_JA_CMD_ROTARY_WING_TYPE, /* 9,4010 */
	SERVO_MOB_JA_CMD_SHUTDOWN_TYPE, /* 10,4004 */
	SERVO_MOB_JA_CMD_SKID_TYPE, /* 11,4006 */
	SERVO_MOB_JA_CMD_SUBMARINE_TYPE, /* 12,4009 */
	SERVO_MOB_JA_SET_TYPE, /* 15,4301 */
	SERVO_MOB_JA_SET_AIR_BOT_TYPE, /* 16,4303 */
	SERVO_MOB_JA_SET_GRD_VEH_TYPE, /* 17,4302 */
	SERVO_MOB_JA_STAT_TYPE, /* 18,4101 */
	SERVO_MOB_JA_STAT_AIR_BOT_TYPE, /* 19,4103 */
	SERVO_MOB_JA_STAT_GRD_VEH_TYPE, /* 20,4102 */
	-1};
const size_t servoMobJA_size_list[SERVOMOBJA_NAME_LIST_LENGTH]= {
	sizeof(ServoMobJACfgCycleTime),
	sizeof(ServoMobJACfgDebug),
	sizeof(ServoMobJACfgTeleport),
	sizeof(ServoMobJACmdAbort),
	sizeof(ServoMobJACmdAckerman),
	sizeof(ServoMobJACmdFlipSkid),
	sizeof(ServoMobJACmdHalt),
	sizeof(ServoMobJACmdInit),
	sizeof(ServoMobJACmdOmni),
	sizeof(ServoMobJACmdRotaryWing),
	sizeof(ServoMobJACmdShutdown),
	sizeof(ServoMobJACmdSkid),
	sizeof(ServoMobJACmdSubmarine),
	sizeof(ServoMobJASet),
	sizeof(ServoMobJASetAirBot),
	sizeof(ServoMobJASetGrdVeh),
	sizeof(ServoMobJAStat),
	sizeof(ServoMobJAStatAirBot),
	sizeof(ServoMobJAStatGrdVeh),
	0};
const char *servoMobJA_symbol_lookup(long type);


// Enumerated Type Constants

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *servoMobJA_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)servoMobJA_enum_moastSteerType_symbol_lookup
	};

// anonymous_enum_______include_moastTypes_hh_195
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_195_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_195_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *servoMobJA_enum_anonymous_enum_______include_moastTypes_hh_195_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_195_info_struct={
	"anonymous_enum_______include_moastTypes_hh_195",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_195_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_195_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_195_LENGTH,
	(cms_symbol_lookup_function_t)servoMobJA_enum_anonymous_enum_______include_moastTypes_hh_195_symbol_lookup
	};

// RCS_ADMIN_STATE
#ifndef MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH
#define MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH 20
#endif
#ifndef ENUM_RCS_ADMIN_STATE_LENGTH
#define ENUM_RCS_ADMIN_STATE_LENGTH 5
#endif

static const char enum_RCS_ADMIN_STATE_string_list[ENUM_RCS_ADMIN_STATE_LENGTH][MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH]= {
	"ADMIN_INITIALIZED", /* 0,2 */
	"ADMIN_SHUT_DOWN", /* 1,3 */
	"ADMIN_UNINITIALIZED", /* 2,1 */
	"RCS_ADMIN_ZERO", /* 3,0 */
	""};

static const int enum_RCS_ADMIN_STATE_int_list[ENUM_RCS_ADMIN_STATE_LENGTH]= {
	ADMIN_INITIALIZED, /* 0,2 */
	ADMIN_SHUT_DOWN, /* 1,3 */
	ADMIN_UNINITIALIZED, /* 2,1 */
	RCS_ADMIN_ZERO, /* 3,0 */
	};

const char *servoMobJA_enum_RCS_ADMIN_STATE_symbol_lookup(long v)
{
	switch(v)
	{
		case ADMIN_INITIALIZED: return("ADMIN_INITIALIZED"); /* 2 */
		case ADMIN_SHUT_DOWN: return("ADMIN_SHUT_DOWN"); /* 3 */
		case ADMIN_UNINITIALIZED: return("ADMIN_UNINITIALIZED"); /* 1 */
		case RCS_ADMIN_ZERO: return("RCS_ADMIN_ZERO"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_ADMIN_STATE_info_struct={
	"RCS_ADMIN_STATE",
	(const char **)enum_RCS_ADMIN_STATE_string_list,
	enum_RCS_ADMIN_STATE_int_list,
	MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH,
	ENUM_RCS_ADMIN_STATE_LENGTH,
	(cms_symbol_lookup_function_t)servoMobJA_enum_RCS_ADMIN_STATE_symbol_lookup
	};

// RCS_STATUS
#ifndef MAX_ENUM_RCS_STATUS_STRING_LENGTH
#define MAX_ENUM_RCS_STATUS_STRING_LENGTH 21
#endif
#ifndef ENUM_RCS_STATUS_LENGTH
#define ENUM_RCS_STATUS_LENGTH 5
#endif

static const char enum_RCS_STATUS_string_list[ENUM_RCS_STATUS_LENGTH][MAX_ENUM_RCS_STATUS_STRING_LENGTH]= {
	"RCS_DONE", /* 0,1 */
	"RCS_ERROR", /* 1,3 */
	"RCS_EXEC", /* 2,2 */
	"UNINITIALIZED_STATUS", /* 3,-1 */
	""};

static const int enum_RCS_STATUS_int_list[ENUM_RCS_STATUS_LENGTH]= {
	RCS_DONE, /* 0,1 */
	RCS_ERROR, /* 1,3 */
	RCS_EXEC, /* 2,2 */
	UNINITIALIZED_STATUS, /* 3,-1 */
	};

const char *servoMobJA_enum_RCS_STATUS_symbol_lookup(long v)
{
	switch(v)
	{
		case RCS_DONE: return("RCS_DONE"); /* 1 */
		case RCS_ERROR: return("RCS_ERROR"); /* 3 */
		case RCS_EXEC: return("RCS_EXEC"); /* 2 */
		case UNINITIALIZED_STATUS: return("UNINITIALIZED_STATUS"); /* -1 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_STATUS_info_struct={
	"RCS_STATUS",
	(const char **)enum_RCS_STATUS_string_list,
	enum_RCS_STATUS_int_list,
	MAX_ENUM_RCS_STATUS_STRING_LENGTH,
	ENUM_RCS_STATUS_LENGTH,
	(cms_symbol_lookup_function_t)servoMobJA_enum_RCS_STATUS_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *servoMobJA_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)servoMobJA_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *servoMobJA_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)servoMobJA_enum_moastRobotType_symbol_lookup
	};

/*
Estimated_size	ServoMobJACfgCycleTime	32
Estimated_size	ServoMobJACfgDebug	32
Estimated_size	ServoMobJACfgTeleport	80
Estimated_size	ServoMobJACmdAbort	24
Estimated_size	ServoMobJACmdAckerman	48
Estimated_size	ServoMobJACmdFlipSkid	120
Estimated_size	ServoMobJACmdHalt	24
Estimated_size	ServoMobJACmdInit	24
Estimated_size	ServoMobJACmdOmni	48
Estimated_size	ServoMobJACmdRotaryWing	56
Estimated_size	ServoMobJACmdShutdown	24
Estimated_size	ServoMobJACmdSkid	40
Estimated_size	ServoMobJACmdSubmarine	48
Estimated_size	ServoMobJAFlipperMsg	16
Estimated_size	ServoMobJAFlipperSet	88
Estimated_size	ServoMobJASet	400
Estimated_size	ServoMobJASetAirBot	432
Estimated_size	ServoMobJASetGrdVeh	832
Estimated_size	ServoMobJAStat	336
Estimated_size	ServoMobJAStatAirBot	368
Estimated_size	ServoMobJAStatGrdVeh	432
Estimated_size	MAXIMUM	832
*/
/*
*	NML/CMS Format function : servoMobJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
int servoMobJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"servoMobJA",
		(cms_symbol_lookup_function_t) servoMobJA_symbol_lookup,
		(const char **)servoMobJA_name_list,
		servoMobJA_id_list,servoMobJA_size_list,
		SERVOMOBJA_NAME_LIST_LENGTH,
		MAX_SERVOMOBJA_NAME_LENGTH);

	switch(type)
	{
	case SERVO_MOB_JA_CFG_CYCLE_TIME_TYPE:
		((ServoMobJACfgCycleTime *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CFG_DEBUG_TYPE:
		((ServoMobJACfgDebug *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CFG_TELEPORT_TYPE:
		((ServoMobJACfgTeleport *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_ABORT_TYPE:
		((ServoMobJACmdAbort *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_ACKERMAN_TYPE:
		((ServoMobJACmdAckerman *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_FLIP_SKID_TYPE:
		((ServoMobJACmdFlipSkid *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_HALT_TYPE:
		((ServoMobJACmdHalt *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_INIT_TYPE:
		((ServoMobJACmdInit *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_OMNI_TYPE:
		((ServoMobJACmdOmni *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_ROTARY_WING_TYPE:
		((ServoMobJACmdRotaryWing *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_SHUTDOWN_TYPE:
		((ServoMobJACmdShutdown *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_SKID_TYPE:
		((ServoMobJACmdSkid *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_CMD_SUBMARINE_TYPE:
		((ServoMobJACmdSubmarine *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_SET_TYPE:
		((ServoMobJASet *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_SET_AIR_BOT_TYPE:
		((ServoMobJASetAirBot *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_SET_GRD_VEH_TYPE:
		((ServoMobJASetGrdVeh *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_STAT_TYPE:
		((ServoMobJAStat *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_STAT_AIR_BOT_TYPE:
		((ServoMobJAStatAirBot *) buffer)->update(cms);
		break;
	case SERVO_MOB_JA_STAT_GRD_VEH_TYPE:
		((ServoMobJAStatGrdVeh *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *servoMobJA_symbol_lookup(long type)
{
	switch(type)
	{
	case SERVO_MOB_JA_CFG_CYCLE_TIME_TYPE:
		return "ServoMobJACfgCycleTime";
	case SERVO_MOB_JA_CFG_DEBUG_TYPE:
		return "ServoMobJACfgDebug";
	case SERVO_MOB_JA_CFG_TELEPORT_TYPE:
		return "ServoMobJACfgTeleport";
	case SERVO_MOB_JA_CMD_ABORT_TYPE:
		return "ServoMobJACmdAbort";
	case SERVO_MOB_JA_CMD_ACKERMAN_TYPE:
		return "ServoMobJACmdAckerman";
	case SERVO_MOB_JA_CMD_FLIP_SKID_TYPE:
		return "ServoMobJACmdFlipSkid";
	case SERVO_MOB_JA_CMD_HALT_TYPE:
		return "ServoMobJACmdHalt";
	case SERVO_MOB_JA_CMD_INIT_TYPE:
		return "ServoMobJACmdInit";
	case SERVO_MOB_JA_CMD_OMNI_TYPE:
		return "ServoMobJACmdOmni";
	case SERVO_MOB_JA_CMD_ROTARY_WING_TYPE:
		return "ServoMobJACmdRotaryWing";
	case SERVO_MOB_JA_CMD_SHUTDOWN_TYPE:
		return "ServoMobJACmdShutdown";
	case SERVO_MOB_JA_CMD_SKID_TYPE:
		return "ServoMobJACmdSkid";
	case SERVO_MOB_JA_CMD_SUBMARINE_TYPE:
		return "ServoMobJACmdSubmarine";
	case SERVO_MOB_JA_SET_TYPE:
		return "ServoMobJASet";
	case SERVO_MOB_JA_SET_AIR_BOT_TYPE:
		return "ServoMobJASetAirBot";
	case SERVO_MOB_JA_SET_GRD_VEH_TYPE:
		return "ServoMobJASetGrdVeh";
	case SERVO_MOB_JA_STAT_TYPE:
		return "ServoMobJAStat";
	case SERVO_MOB_JA_STAT_AIR_BOT_TYPE:
		return "ServoMobJAStatAirBot";
	case SERVO_MOB_JA_STAT_GRD_VEH_TYPE:
		return "ServoMobJAStatGrdVeh";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for ServoMobJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("ServoMobJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("ServoMobJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACfgDebug::update(CMS *cms)
{

	cms->beginClass("ServoMobJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("ServoMobJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACfgTeleport
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACfgTeleport::update(CMS *cms)
{

	cms->beginClass("ServoMobJACfgTeleport","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("goal",goal);

	cms->endClass("ServoMobJACfgTeleport","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdAbort::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMobJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdAckerman
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdAckerman::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdAckerman","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("velocity",velocity);
	cms->update_with_name("steerAngle",steerAngle);
	cms->update_with_name("crabAngle",crabAngle);

	cms->endClass("ServoMobJACmdAckerman","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdFlipSkid
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdFlipSkid::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdFlipSkid","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("wLeft",wLeft);
	cms->update_with_name("wRight",wRight);
	cms->update_dla_length_with_name("fCmd_length",fCmd_length);
	cms->beginStructDynamicArray("fCmd",fCmd_length,4);
	for(int i_fCmd = 0;i_fCmd < fCmd_length ;i_fCmd++)
	{
		cms->beginStructArrayElem("fCmd",i_fCmd);
		nmlupdate(cms,&(fCmd[i_fCmd]));
		cms->endStructArrayElem("fCmd",i_fCmd);
	}
	cms->endStructDynamicArray("fCmd",fCmd_length,4);

	cms->endClass("ServoMobJACmdFlipSkid","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdHalt::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMobJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdInit::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMobJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdOmni
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdOmni::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdOmni","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vLinear",vLinear);
	cms->update_with_name("vLateral",vLateral);
	cms->update_with_name("rot",rot);

	cms->endClass("ServoMobJACmdOmni","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdRotaryWing
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdRotaryWing::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdRotaryWing","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vLinear",vLinear);
	cms->update_with_name("vLateral",vLateral);
	cms->update_with_name("vVertical",vVertical);
	cms->update_with_name("vRotation",vRotation);

	cms->endClass("ServoMobJACmdRotaryWing","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("ServoMobJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdSkid
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdSkid::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdSkid","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("wLeft",wLeft);
	cms->update_with_name("wRight",wRight);

	cms->endClass("ServoMobJACmdSkid","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJACmdSubmarine
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJACmdSubmarine::update(CMS *cms)
{

	cms->beginClass("ServoMobJACmdSubmarine","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("propeller",propeller);
	cms->update_with_name("rudder",rudder);
	cms->update_with_name("sternPlane",sternPlane);

	cms->endClass("ServoMobJACmdSubmarine","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for ServoMobJAFlipperMsg
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void nmlupdate(CMS *cms,ServoMobJAFlipperMsg *x)
{

	cms->beginClass("ServoMobJAFlipperMsg",0);
	x->fType= (moastFlipperType) cms->update_enumeration_with_name("fType", (int)x->fType,(void*)&(x->fType),&enum_moastFlipperType_info_struct);
	cms->update_with_name("flipperAngle",x->flipperAngle);

	cms->endClass("ServoMobJAFlipperMsg",0);

}


/*
*	NML/CMS Update function for ServoMobJAFlipperSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void nmlupdate(CMS *cms,ServoMobJAFlipperSet *x)
{

	cms->beginClass("ServoMobJAFlipperSet",0);
	x->fType= (moastFlipperType) cms->update_enumeration_with_name("fType", (int)x->fType,(void*)&(x->fType),&enum_moastFlipperType_info_struct);
	cms->update_with_name("minAngle",x->minAngle);
	cms->update_with_name("maxAngle",x->maxAngle);
	cms->update_with_name("length",x->length);
	cms->update_with_name("width",x->width);
	cms->update_with_name("location",x->location);
	cms->update_with_name("orientation",x->orientation);

	cms->endClass("ServoMobJAFlipperSet",0);

}


/*
*	NML/CMS Update function for ServoMobJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJASet::update(CMS *cms)
{

	cms->beginClass("ServoMobJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("worldName",worldName,80);
	cms->update_with_name("platformName",(char *) platformName,80);
	cms->update_with_name("length",length);
	cms->update_with_name("width",width);
	cms->update_with_name("height",height);
	cms->update_with_name("mass",mass);
	cms->update_with_name("cg",cg);
	cms->update_with_name("steerType",steerType);
	cms->update_with_name("botType",botType);
	cms->update_with_name("effCount",effCount);
	cms->update_with_name("senCount",senCount);
	cms->update_with_name("misCount",misCount);

	cms->endClass("ServoMobJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for ServoMobJASetAirBot
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJASetAirBot::update(CMS *cms)
{

	cms->beginClass("ServoMobJASetAirBot","ServoMobJASet");

	cms->beginBaseClass("ServoMobJASet");
	ServoMobJASet::update(cms);
	cms->endBaseClass("ServoMobJASet");

	cms->update_with_name("maxLatVel",maxLatVel);
	cms->update_with_name("maxLinVel",maxLinVel);
	cms->update_with_name("maxRotVel",maxRotVel);
	cms->update_with_name("maxVertVel",maxVertVel);

	cms->endClass("ServoMobJASetAirBot","ServoMobJASet");

}


/*
*	NML/CMS Update function for ServoMobJASetGrdVeh
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJASetGrdVeh::update(CMS *cms)
{

	cms->beginClass("ServoMobJASetGrdVeh","ServoMobJASet");

	cms->beginBaseClass("ServoMobJASet");
	ServoMobJASet::update(cms);
	cms->endBaseClass("ServoMobJASet");

	cms->update_with_name("maxWheelRot",maxWheelRot);
	cms->update_with_name("maxTorque",maxTorque);
	cms->update_with_name("wheelSeparation",wheelSeparation);
	cms->update_with_name("wheelRadius",wheelRadius);
	cms->update_with_name("wheelBase",wheelBase);
	cms->update_with_name("maxSteerAngle",maxSteerAngle);
	cms->update_with_name("maxCrabAngle",maxCrabAngle);
	cms->update_with_name("minTurningRadius",minTurningRadius);
	cms->update_dla_length_with_name("fSet_length",fSet_length);
	cms->beginStructDynamicArray("fSet",fSet_length,4);
	for(int i_fSet = 0;i_fSet < fSet_length ;i_fSet++)
	{
		cms->beginStructArrayElem("fSet",i_fSet);
		nmlupdate(cms,&(fSet[i_fSet]));
		cms->endStructArrayElem("fSet",i_fSet);
	}
	cms->endStructDynamicArray("fSet",fSet_length,4);

	cms->endClass("ServoMobJASetGrdVeh","ServoMobJASet");

}


/*
*	NML/CMS Update function for ServoMobJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJAStat::update(CMS *cms)
{

	cms->beginClass("ServoMobJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("time",time);
	cms->update_with_name("error",error);
	cms->update_with_name("heartbeat",heartbeat);
	cms->update_with_name("batteryVolt",batteryVolt);
	cms->update_with_name("fuelLevel",fuelLevel);
	cms->update_with_name("headLights",headLights);

	cms->endClass("ServoMobJAStat","RCS_STAT_MSG_V2");

}


/*
*	NML/CMS Update function for ServoMobJAStatAirBot
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJAStatAirBot::update(CMS *cms)
{

	cms->beginClass("ServoMobJAStatAirBot","ServoMobJAStat");

	cms->beginBaseClass("ServoMobJAStat");
	ServoMobJAStat::update(cms);
	cms->endBaseClass("ServoMobJAStat");

	cms->update_with_name("vRotation",vRotation);
	cms->update_with_name("vLateral",vLateral);
	cms->update_with_name("vLinear",vLinear);
	cms->update_with_name("vVertical",vVertical);

	cms->endClass("ServoMobJAStatAirBot","ServoMobJAStat");

}


/*
*	NML/CMS Update function for ServoMobJAStatGrdVeh
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Dec 18 10:06:59 EST 2007
*/
void ServoMobJAStatGrdVeh::update(CMS *cms)
{

	cms->beginClass("ServoMobJAStatGrdVeh","ServoMobJAStat");

	cms->beginBaseClass("ServoMobJAStat");
	ServoMobJAStat::update(cms);
	cms->endBaseClass("ServoMobJAStat");

	cms->update_with_name("steerAngle",steerAngle);
	cms->update_with_name("crabAngle",crabAngle);
	cms->update_dla_length_with_name("fStat_length",fStat_length);
	cms->beginStructDynamicArray("fStat",fStat_length,4);
	for(int i_fStat = 0;i_fStat < fStat_length ;i_fStat++)
	{
		cms->beginStructArrayElem("fStat",i_fStat);
		nmlupdate(cms,&(fStat[i_fStat]));
		cms->endStructArrayElem("fStat",i_fStat);
	}
	cms->endStructDynamicArray("fStat",fStat_length,4);

	cms->endClass("ServoMobJAStatGrdVeh","ServoMobJAStat");

}

