/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "symbolicData.hh"

// Forward Function Prototypes
void nmlupdate(CMS *cms, HazardInfo *x);
void initialize_HazardInfo(HazardInfo *x);
void nmlupdate(CMS *cms, Location2D *x);
void initialize_Location2D(Location2D *x);
void nmlupdate(CMS *cms, IEDInfo *x);
void initialize_IEDInfo(IEDInfo *x);
void nmlupdate(CMS *cms, FeatInfo *x);
void initialize_FeatInfo(FeatInfo *x);

/*
*	Initializer for HazardInfo
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void initialize_HazardInfo(HazardInfo* x)
{
	x->parameters_length = (int) 0;
	for(int i_parameters=0; i_parameters< 8; i_parameters++)
	{
		((double*) x->parameters)[i_parameters]  = (double) 0;
	}
	x->type = (enum HazardClass) IED; /*-1*/
	x->addHazard = (bool) 0;

}

/*
*	Initializer for IEDInfo
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void initialize_IEDInfo(IEDInfo* x)
{
	x->IEDClass = (int) 0;
	x->isDetonated = (int) 0;
	x->status = (int) 0;
	x->zone = (int) 0;

}

/*
*	Initializer for FeatInfo
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void initialize_FeatInfo(FeatInfo* x)
{
	x->vertices_length = (int) 0;
	x->parameters_length = (int) 0;
	for(int i_parameters=0; i_parameters< 8; i_parameters++)
	{
		((double*) x->parameters)[i_parameters]  = (double) 0;
	}
	x->structure = (enum FeatStructure) POINT; /*0*/
	x->type = (enum FeatClass) ROAD; /*0*/
	x->addFeat = (bool) 0;

}


#ifndef MAX_SYMBOLICDATA_NAME_LENGTH
#define MAX_SYMBOLICDATA_NAME_LENGTH 20
#endif
#ifndef SYMBOLICDATA_NAME_LIST_LENGTH
#define SYMBOLICDATA_NAME_LIST_LENGTH 4
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char symbolicData_name_list[SYMBOLICDATA_NAME_LIST_LENGTH][MAX_SYMBOLICDATA_NAME_LENGTH]= {
	"SymbolicDataEntity", /* 3,14002 */
	"SymbolicDataFeature", /* 4,14001 */
	"SymbolicDataHazard", /* 5,14003 */
	""};
const NMLTYPE symbolicData_id_list[SYMBOLICDATA_NAME_LIST_LENGTH]= {
	SYMBOLIC_DATA_ENTITY_TYPE, /* 3,14002 */
	SYMBOLIC_DATA_FEATURE_TYPE, /* 4,14001 */
	SYMBOLIC_DATA_HAZARD_TYPE, /* 5,14003 */
	-1};
const size_t symbolicData_size_list[SYMBOLICDATA_NAME_LIST_LENGTH]= {
	sizeof(SymbolicDataEntity),
	sizeof(SymbolicDataFeature),
	sizeof(SymbolicDataHazard),
	0};
const char *symbolicData_symbol_lookup(long type);


// Enumerated Type Constants

// FeatStructure
#ifndef MAX_ENUM_FEATSTRUCTURE_STRING_LENGTH
#define MAX_ENUM_FEATSTRUCTURE_STRING_LENGTH 8
#endif
#ifndef ENUM_FEATSTRUCTURE_LENGTH
#define ENUM_FEATSTRUCTURE_LENGTH 4
#endif

static const char enum_FeatStructure_string_list[ENUM_FEATSTRUCTURE_LENGTH][MAX_ENUM_FEATSTRUCTURE_STRING_LENGTH]= {
	"LINE", /* 0,1 */
	"POINT", /* 1,0 */
	"POLYGON", /* 2,2 */
	""};

static const int enum_FeatStructure_int_list[ENUM_FEATSTRUCTURE_LENGTH]= {
	LINE, /* 0,1 */
	POINT, /* 1,0 */
	POLYGON, /* 2,2 */
	};

const char *symbolicData_enum_FeatStructure_symbol_lookup(long v)
{
	switch(v)
	{
		case LINE: return("LINE"); /* 1 */
		case POINT: return("POINT"); /* 0 */
		case POLYGON: return("POLYGON"); /* 2 */
		default:break;
	}
	return(NULL);
}

static const struct cms_enum_info enum_FeatStructure_info_struct={
	"FeatStructure",
	(const char **)enum_FeatStructure_string_list,
	enum_FeatStructure_int_list,
	MAX_ENUM_FEATSTRUCTURE_STRING_LENGTH,
	ENUM_FEATSTRUCTURE_LENGTH,
	(cms_symbol_lookup_function_t)symbolicData_enum_FeatStructure_symbol_lookup
	};

// HazardClass
#ifndef MAX_ENUM_HAZARDCLASS_STRING_LENGTH
#define MAX_ENUM_HAZARDCLASS_STRING_LENGTH 4
#endif
#ifndef ENUM_HAZARDCLASS_LENGTH
#define ENUM_HAZARDCLASS_LENGTH 2
#endif

static const char enum_HazardClass_string_list[ENUM_HAZARDCLASS_LENGTH][MAX_ENUM_HAZARDCLASS_STRING_LENGTH]= {
	"IED", /* 0,0 */
	""};

static const int enum_HazardClass_int_list[ENUM_HAZARDCLASS_LENGTH]= {
	IED, /* 0,0 */
	};

const char *symbolicData_enum_HazardClass_symbol_lookup(long v)
{
	switch(v)
	{
		case IED: return("IED"); /* 0 */
		default:break;
	}
	return(NULL);
}

static const struct cms_enum_info enum_HazardClass_info_struct={
	"HazardClass",
	(const char **)enum_HazardClass_string_list,
	enum_HazardClass_int_list,
	MAX_ENUM_HAZARDCLASS_STRING_LENGTH,
	ENUM_HAZARDCLASS_LENGTH,
	(cms_symbol_lookup_function_t)symbolicData_enum_HazardClass_symbol_lookup
	};

// FeatClass
#ifndef MAX_ENUM_FEATCLASS_STRING_LENGTH
#define MAX_ENUM_FEATCLASS_STRING_LENGTH 9
#endif
#ifndef ENUM_FEATCLASS_LENGTH
#define ENUM_FEATCLASS_LENGTH 6
#endif

static const char enum_FeatClass_string_list[ENUM_FEATCLASS_LENGTH][MAX_ENUM_FEATCLASS_STRING_LENGTH]= {
	"BUILDING", /* 0,4 */
	"RIVER", /* 1,2 */
	"ROAD", /* 2,0 */
	"STREAM", /* 3,1 */
	"TREE", /* 4,3 */
	""};

static const int enum_FeatClass_int_list[ENUM_FEATCLASS_LENGTH]= {
	BUILDING, /* 0,4 */
	RIVER, /* 1,2 */
	ROAD, /* 2,0 */
	STREAM, /* 3,1 */
	TREE, /* 4,3 */
	};

const char *symbolicData_enum_FeatClass_symbol_lookup(long v)
{
	switch(v)
	{
		case BUILDING: return("BUILDING"); /* 4 */
		case RIVER: return("RIVER"); /* 2 */
		case ROAD: return("ROAD"); /* 0 */
		case STREAM: return("STREAM"); /* 1 */
		case TREE: return("TREE"); /* 3 */
		default:break;
	}
	return(NULL);
}

static const struct cms_enum_info enum_FeatClass_info_struct={
	"FeatClass",
	(const char **)enum_FeatClass_string_list,
	enum_FeatClass_int_list,
	MAX_ENUM_FEATCLASS_STRING_LENGTH,
	ENUM_FEATCLASS_LENGTH,
	(cms_symbol_lookup_function_t)symbolicData_enum_FeatClass_symbol_lookup
	};

/*
*	NML/CMS Format function : symbolicData_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
int symbolicData_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"symbolicData",
		(cms_symbol_lookup_function_t) symbolicData_symbol_lookup,
		(const char **)symbolicData_name_list,
		symbolicData_id_list,symbolicData_size_list,
		SYMBOLICDATA_NAME_LIST_LENGTH,
		MAX_SYMBOLICDATA_NAME_LENGTH);

	switch(type)
	{
	case SYMBOLIC_DATA_ENTITY_TYPE:
		((SymbolicDataEntity *) buffer)->update(cms);
		break;
	case SYMBOLIC_DATA_FEATURE_TYPE:
		((SymbolicDataFeature *) buffer)->update(cms);
		break;
	case SYMBOLIC_DATA_HAZARD_TYPE:
		((SymbolicDataHazard *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *symbolicData_symbol_lookup(long type)
{
	switch(type)
	{
	case SYMBOLIC_DATA_ENTITY_TYPE:
		return "SymbolicDataEntity";
	case SYMBOLIC_DATA_FEATURE_TYPE:
		return "SymbolicDataFeature";
	case SYMBOLIC_DATA_HAZARD_TYPE:
		return "SymbolicDataHazard";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for SymbolicDataHazard
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void SymbolicDataHazard::update(CMS *cms)
{

	cms->beginClass("SymbolicDataHazard","NMLmsg");
	cms->update_dla_length_with_name("hazardArray_length",hazardArray_length);
	cms->beginStructDynamicArray("hazardArray",hazardArray_length,255);
	for(int i_hazardArray = 0;i_hazardArray < hazardArray_length ;i_hazardArray++)
	{
		cms->beginStructArrayElem("hazardArray",i_hazardArray);
		nmlupdate(cms,&(hazardArray[i_hazardArray]));
		cms->endStructArrayElem("hazardArray",i_hazardArray);
	}
	cms->endStructDynamicArray("hazardArray",hazardArray_length,255);

	cms->endClass("SymbolicDataHazard","NMLmsg");

}


/*
*	NML/CMS Update function for HazardInfo
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void nmlupdate(CMS *cms,HazardInfo *x)
{

	cms->beginClass("HazardInfo",0);
	cms->beginClassVar("loc");
	nmlupdate(cms,((Location2D *)&(x->loc)));
	cms->endClassVar("loc");
	cms->update_dla_length_with_name("parameters_length",x->parameters_length);
	cms->update_dla_with_name("parameters",x->parameters, x->parameters_length,8);
	x->type= (enum HazardClass) cms->update_enumeration_with_name("type", (int)x->type,(void*)&(x->type),&enum_HazardClass_info_struct);
	cms->update_with_name("addHazard",x->addHazard);

	cms->endClass("HazardInfo",0);

}


/*
*	NML/CMS Update function for IEDInfo
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void nmlupdate(CMS *cms,IEDInfo *x)
{

	cms->beginClass("IEDInfo",0);
	cms->update_with_name("IEDClass",x->IEDClass);
	cms->update_with_name("isDetonated",x->isDetonated);
	cms->update_with_name("status",x->status);
	cms->update_with_name("location",x->location);
	cms->update_with_name("zone",x->zone);

	cms->endClass("IEDInfo",0);

}


/*
*	NML/CMS Update function for SymbolicDataEntity
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void SymbolicDataEntity::update(CMS *cms)
{

	cms->beginClass("SymbolicDataEntity","NMLmsg");
	cms->update_dla_length_with_name("entityArray_length",entityArray_length);
	cms->update_dla_with_name("entityArray",entityArray,entityArray_length,255);

	cms->endClass("SymbolicDataEntity","NMLmsg");

}


/*
*	NML/CMS Update function for FeatInfo
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void nmlupdate(CMS *cms,FeatInfo *x)
{

	cms->beginClass("FeatInfo",0);
	cms->update_dla_length_with_name("vertices_length",x->vertices_length);
	cms->beginStructDynamicArray("vertices",x->vertices_length,100);
	for(int i_vertices = 0;i_vertices < x->vertices_length ;i_vertices++)
	{
		cms->beginStructArrayElem("vertices",i_vertices);
		nmlupdate(cms,&(x->vertices[i_vertices]));
		cms->endStructArrayElem("vertices",i_vertices);
	}
	cms->endStructDynamicArray("vertices",x->vertices_length,100);
	cms->update_dla_length_with_name("parameters_length",x->parameters_length);
	cms->update_dla_with_name("parameters",x->parameters, x->parameters_length,8);
	x->structure= (enum FeatStructure) cms->update_enumeration_with_name("structure", (int)x->structure,(void*)&(x->structure),&enum_FeatStructure_info_struct);
	x->type= (enum FeatClass) cms->update_enumeration_with_name("type", (int)x->type,(void*)&(x->type),&enum_FeatClass_info_struct);
	cms->update_with_name("addFeat",x->addFeat);

	cms->endClass("FeatInfo",0);

}


/*
*	NML/CMS Update function for SymbolicDataFeature
*	Automatically generated by NML CodeGen Java Applet.
*	on Thu Jun 23 08:52:39 EDT 2005
*/
void SymbolicDataFeature::update(CMS *cms)
{

	cms->beginClass("SymbolicDataFeature","NMLmsg");
	cms->update_dla_length_with_name("featList_length",featList_length);
	cms->beginStructDynamicArray("featList",featList_length,255);
	for(int i_featList = 0;i_featList < featList_length ;i_featList++)
	{
		cms->beginStructArrayElem("featList",i_featList);
		nmlupdate(cms,&(featList[i_featList]));
		cms->endStructArrayElem("featList",i_featList);
	}
	cms->endStructDynamicArray("featList",featList_length,255);

	cms->endClass("SymbolicDataFeature","NMLmsg");

}

