/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "vehSP.hh"

// Forward Function Prototypes


#ifndef MAX_VEHSP_NAME_LENGTH
#define MAX_VEHSP_NAME_LENGTH 18
#endif
#ifndef VEHSP_NAME_LIST_LENGTH
#define VEHSP_NAME_LIST_LENGTH 9
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char vehSP_name_list[VEHSP_NAME_LIST_LENGTH][MAX_VEHSP_NAME_LENGTH]= {
	"VehSPCfgCycleTime", /* 0,11201 */
	"VehSPCfgDebug", /* 1,11202 */
	"VehSPCmdAbort", /* 2,11002 */
	"VehSPCmdHalt", /* 3,11003 */
	"VehSPCmdInit", /* 4,11001 */
	"VehSPCmdShutdown", /* 5,11004 */
	"VehSPSet", /* 6,11301 */
	"VehSPStat", /* 7,11101 */
	""};
const NMLTYPE vehSP_id_list[VEHSP_NAME_LIST_LENGTH]= {
	VEH_SP_CFG_CYCLE_TIME_TYPE, /* 0,11201 */
	VEH_SP_CFG_DEBUG_TYPE, /* 1,11202 */
	VEH_SP_CMD_ABORT_TYPE, /* 2,11002 */
	VEH_SP_CMD_HALT_TYPE, /* 3,11003 */
	VEH_SP_CMD_INIT_TYPE, /* 4,11001 */
	VEH_SP_CMD_SHUTDOWN_TYPE, /* 5,11004 */
	VEH_SP_SET_TYPE, /* 6,11301 */
	VEH_SP_STAT_TYPE, /* 7,11101 */
	-1};
const size_t vehSP_size_list[VEHSP_NAME_LIST_LENGTH]= {
	sizeof(VehSPCfgCycleTime),
	sizeof(VehSPCfgDebug),
	sizeof(VehSPCmdAbort),
	sizeof(VehSPCmdHalt),
	sizeof(VehSPCmdInit),
	sizeof(VehSPCmdShutdown),
	sizeof(VehSPSet),
	sizeof(VehSPStat),
	0};
const char *vehSP_symbol_lookup(long type);


// Enumerated Type Constants

// anonymous_enum_______include_moastTypes_hh_288
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_288_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_288_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *vehSP_enum_anonymous_enum_______include_moastTypes_hh_288_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_288_info_struct={
	"anonymous_enum_______include_moastTypes_hh_288",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_288_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_288_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH,
	(cms_symbol_lookup_function_t)vehSP_enum_anonymous_enum_______include_moastTypes_hh_288_symbol_lookup
	};

// RCS_STATUS
#ifndef MAX_ENUM_RCS_STATUS_STRING_LENGTH
#define MAX_ENUM_RCS_STATUS_STRING_LENGTH 21
#endif
#ifndef ENUM_RCS_STATUS_LENGTH
#define ENUM_RCS_STATUS_LENGTH 5
#endif

static const char enum_RCS_STATUS_string_list[ENUM_RCS_STATUS_LENGTH][MAX_ENUM_RCS_STATUS_STRING_LENGTH]= {
	"RCS_DONE", /* 0,1 */
	"RCS_ERROR", /* 1,3 */
	"RCS_EXEC", /* 2,2 */
	"UNINITIALIZED_STATUS", /* 3,-1 */
	""};

static const int enum_RCS_STATUS_int_list[ENUM_RCS_STATUS_LENGTH]= {
	RCS_DONE, /* 0,1 */
	RCS_ERROR, /* 1,3 */
	RCS_EXEC, /* 2,2 */
	UNINITIALIZED_STATUS, /* 3,-1 */
	};

const char *vehSP_enum_RCS_STATUS_symbol_lookup(long v)
{
	switch(v)
	{
		case RCS_DONE: return("RCS_DONE"); /* 1 */
		case RCS_ERROR: return("RCS_ERROR"); /* 3 */
		case RCS_EXEC: return("RCS_EXEC"); /* 2 */
		case UNINITIALIZED_STATUS: return("UNINITIALIZED_STATUS"); /* -1 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_STATUS_info_struct={
	"RCS_STATUS",
	(const char **)enum_RCS_STATUS_string_list,
	enum_RCS_STATUS_int_list,
	MAX_ENUM_RCS_STATUS_STRING_LENGTH,
	ENUM_RCS_STATUS_LENGTH,
	(cms_symbol_lookup_function_t)vehSP_enum_RCS_STATUS_symbol_lookup
	};

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *vehSP_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)vehSP_enum_moastSteerType_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *vehSP_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)vehSP_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *vehSP_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)vehSP_enum_moastRobotType_symbol_lookup
	};

/*
Estimated_size	VehSPCfgCycleTime	32
Estimated_size	VehSPCfgDebug	32
Estimated_size	VehSPCmdAbort	24
Estimated_size	VehSPCmdHalt	24
Estimated_size	VehSPCmdInit	24
Estimated_size	VehSPCmdShutdown	24
Estimated_size	VehSPSet	144
Estimated_size	VehSPStat	136
Estimated_size	MAXIMUM	144
*/
/*
*	NML/CMS Format function : vehSP_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
int vehSP_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"vehSP",
		(cms_symbol_lookup_function_t) vehSP_symbol_lookup,
		(const char **)vehSP_name_list,
		vehSP_id_list,vehSP_size_list,
		VEHSP_NAME_LIST_LENGTH,
		MAX_VEHSP_NAME_LENGTH);

	switch(type)
	{
	case VEH_SP_CFG_CYCLE_TIME_TYPE:
		((VehSPCfgCycleTime *) buffer)->update(cms);
		break;
	case VEH_SP_CFG_DEBUG_TYPE:
		((VehSPCfgDebug *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_ABORT_TYPE:
		((VehSPCmdAbort *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_HALT_TYPE:
		((VehSPCmdHalt *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_INIT_TYPE:
		((VehSPCmdInit *) buffer)->update(cms);
		break;
	case VEH_SP_CMD_SHUTDOWN_TYPE:
		((VehSPCmdShutdown *) buffer)->update(cms);
		break;
	case VEH_SP_SET_TYPE:
		((VehSPSet *) buffer)->update(cms);
		break;
	case VEH_SP_STAT_TYPE:
		((VehSPStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *vehSP_symbol_lookup(long type)
{
	switch(type)
	{
	case VEH_SP_CFG_CYCLE_TIME_TYPE:
		return "VehSPCfgCycleTime";
	case VEH_SP_CFG_DEBUG_TYPE:
		return "VehSPCfgDebug";
	case VEH_SP_CMD_ABORT_TYPE:
		return "VehSPCmdAbort";
	case VEH_SP_CMD_HALT_TYPE:
		return "VehSPCmdHalt";
	case VEH_SP_CMD_INIT_TYPE:
		return "VehSPCmdInit";
	case VEH_SP_CMD_SHUTDOWN_TYPE:
		return "VehSPCmdShutdown";
	case VEH_SP_SET_TYPE:
		return "VehSPSet";
	case VEH_SP_STAT_TYPE:
		return "VehSPStat";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for VehSPCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("VehSPCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("VehSPCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPCfgDebug::update(CMS *cms)
{

	cms->beginClass("VehSPCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("VehSPCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPCmdAbort::update(CMS *cms)
{

	cms->beginClass("VehSPCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPCmdHalt::update(CMS *cms)
{

	cms->beginClass("VehSPCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPCmdInit::update(CMS *cms)
{

	cms->beginClass("VehSPCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPCmdShutdown::update(CMS *cms)
{

	cms->beginClass("VehSPCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("VehSPCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for VehSPSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPSet::update(CMS *cms)
{

	cms->beginClass("VehSPSet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);

	cms->endClass("VehSPSet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for VehSPStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:37 GMT-05:00 2007
*/
void VehSPStat::update(CMS *cms)
{

	cms->beginClass("VehSPStat","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("heartbeat",heartbeat);

	cms->endClass("VehSPStat","RCS_STAT_MSG");

}

