#ifndef SW_SERVO_NODE_BASE_HH
#define SW_SERVO_NODE_BASE_HH

//! C++ STL Headers
#include<string>
#include<sstream>
using namespace std;

//! SIMware Headers
#include "swKBTypes.hh"
#include "simWareKB.hh"
#include "swKBUtils.hh"

class MoastSupSkin;

//! RCS Headers
#include "rcs.hh" 

#define SERVO_NODE_CYCLE_TIME_DEFAULT 0.01

class SIMwareServoNodeBase {
protected:
  string nodeName;

  RCS_CMD_CHANNEL  * cmdBuf;
  RCS_STAT_CHANNEL * statBuf;
  RCS_CMD_CHANNEL  * cfgBuf;
  RCS_STAT_CHANNEL * setBuf;

  // May Not Need
  RCS_STAT_MSG_V2 * statMsg;
  RCS_STAT_MSG * setMsg;
  
  RCS_TIMER * timer;
  
  MoastSupSkin * mSkin;
public:
  SIMwareServoNodeBase(MoastSupSkin *);
  virtual ~SIMwareServoNodeBase();
  virtual bool openNML(string,        // cmd channel name
	       string,        // stat channel name
	       string,        // cfg channel name
	       string,        // set channel name
	       NML_FORMAT_PTR, // format function pointer
	       int = 0           // component id
	       );
  virtual void cleanUpNMLBuf();
  virtual void doSingleStep() = 0;
  virtual void publishSettings() = 0;
  virtual void sendStatus() = 0;
  void run();
  SIMwareStateType getNodeState();
  void setTimer(double);
};
#endif
