/*
*	New C++ File starts here.
*	This file should be named skel.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "skel.hh"
#include "skelCommon.hh"

// Forward Function Prototypes


#ifndef MAX_SKEL_NAME_LENGTH
#define MAX_SKEL_NAME_LENGTH 17
#endif
#ifndef SKEL_NAME_LIST_LENGTH
#define SKEL_NAME_LIST_LENGTH 14
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char skel_name_list[SKEL_NAME_LIST_LENGTH][MAX_SKEL_NAME_LENGTH]= {
	"SkelCfgCycleTime", /* 0,304 */
	"SkelCfgDebug", /* 1,303 */
	"SkelCfgLength", /* 2,301 */
	"SkelCfgNop", /* 3,305 */
	"SkelCfgWidth", /* 4,302 */
	"SkelCmdAbort", /* 5,103 */
	"SkelCmdGo", /* 6,102 */
	"SkelCmdHalt", /* 7,104 */
	"SkelCmdInit", /* 8,101 */
	"SkelCmdNop", /* 9,106 */
	"SkelCmdShutdown", /* 10,105 */
	"SkelSet", /* 11,401 */
	"SkelStat", /* 12,201 */
	""};
const NMLTYPE skel_id_list[SKEL_NAME_LIST_LENGTH]= {
	SKEL_CFG_CYCLE_TIME_TYPE, /* 0,304 */
	SKEL_CFG_DEBUG_TYPE, /* 1,303 */
	SKEL_CFG_LENGTH_TYPE, /* 2,301 */
	SKEL_CFG_NOP_TYPE, /* 3,305 */
	SKEL_CFG_WIDTH_TYPE, /* 4,302 */
	SKEL_CMD_ABORT_TYPE, /* 5,103 */
	SKEL_CMD_GO_TYPE, /* 6,102 */
	SKEL_CMD_HALT_TYPE, /* 7,104 */
	SKEL_CMD_INIT_TYPE, /* 8,101 */
	SKEL_CMD_NOP_TYPE, /* 9,106 */
	SKEL_CMD_SHUTDOWN_TYPE, /* 10,105 */
	SKEL_SET_TYPE, /* 11,401 */
	SKEL_STAT_TYPE, /* 12,201 */
	-1};
const size_t skel_size_list[SKEL_NAME_LIST_LENGTH]= {
	sizeof(SkelCfgCycleTime),
	sizeof(SkelCfgDebug),
	sizeof(SkelCfgLength),
	sizeof(SkelCfgNop),
	sizeof(SkelCfgWidth),
	sizeof(SkelCmdAbort),
	sizeof(SkelCmdGo),
	sizeof(SkelCmdHalt),
	sizeof(SkelCmdInit),
	sizeof(SkelCmdNop),
	sizeof(SkelCmdShutdown),
	sizeof(SkelSet),
	sizeof(SkelStat),
	0};
const char *skel_symbol_lookup(long type);


// Enumerated Type Constants

// RCS_STATUS
#ifndef MAX_ENUM_RCS_STATUS_STRING_LENGTH
#define MAX_ENUM_RCS_STATUS_STRING_LENGTH 21
#endif
#ifndef ENUM_RCS_STATUS_LENGTH
#define ENUM_RCS_STATUS_LENGTH 5
#endif

static const char enum_RCS_STATUS_string_list[ENUM_RCS_STATUS_LENGTH][MAX_ENUM_RCS_STATUS_STRING_LENGTH]= {
	"RCS_DONE", /* 0,1 */
	"RCS_ERROR", /* 1,3 */
	"RCS_EXEC", /* 2,2 */
	"UNINITIALIZED_STATUS", /* 3,-1 */
	""};

static const int enum_RCS_STATUS_int_list[ENUM_RCS_STATUS_LENGTH]= {
	RCS_DONE, /* 0,1 */
	RCS_ERROR, /* 1,3 */
	RCS_EXEC, /* 2,2 */
	UNINITIALIZED_STATUS, /* 3,-1 */
	};

const char *skel_enum_RCS_STATUS_symbol_lookup(long v)
{
	switch(v)
	{
		case RCS_DONE: return("RCS_DONE"); /* 1 */
		case RCS_ERROR: return("RCS_ERROR"); /* 3 */
		case RCS_EXEC: return("RCS_EXEC"); /* 2 */
		case UNINITIALIZED_STATUS: return("UNINITIALIZED_STATUS"); /* -1 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_STATUS_info_struct={
	"RCS_STATUS",
	(const char **)enum_RCS_STATUS_string_list,
	enum_RCS_STATUS_int_list,
	MAX_ENUM_RCS_STATUS_STRING_LENGTH,
	ENUM_RCS_STATUS_LENGTH,
	(cms_symbol_lookup_function_t)skel_enum_RCS_STATUS_symbol_lookup
	};

// RCS_ADMIN_STATE
#ifndef MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH
#define MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH 20
#endif
#ifndef ENUM_RCS_ADMIN_STATE_LENGTH
#define ENUM_RCS_ADMIN_STATE_LENGTH 5
#endif

static const char enum_RCS_ADMIN_STATE_string_list[ENUM_RCS_ADMIN_STATE_LENGTH][MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH]= {
	"ADMIN_INITIALIZED", /* 0,2 */
	"ADMIN_SHUT_DOWN", /* 1,3 */
	"ADMIN_UNINITIALIZED", /* 2,1 */
	"RCS_ADMIN_ZERO", /* 3,0 */
	""};

static const int enum_RCS_ADMIN_STATE_int_list[ENUM_RCS_ADMIN_STATE_LENGTH]= {
	ADMIN_INITIALIZED, /* 0,2 */
	ADMIN_SHUT_DOWN, /* 1,3 */
	ADMIN_UNINITIALIZED, /* 2,1 */
	RCS_ADMIN_ZERO, /* 3,0 */
	};

const char *skel_enum_RCS_ADMIN_STATE_symbol_lookup(long v)
{
	switch(v)
	{
		case ADMIN_INITIALIZED: return("ADMIN_INITIALIZED"); /* 2 */
		case ADMIN_SHUT_DOWN: return("ADMIN_SHUT_DOWN"); /* 3 */
		case ADMIN_UNINITIALIZED: return("ADMIN_UNINITIALIZED"); /* 1 */
		case RCS_ADMIN_ZERO: return("RCS_ADMIN_ZERO"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_RCS_ADMIN_STATE_info_struct={
	"RCS_ADMIN_STATE",
	(const char **)enum_RCS_ADMIN_STATE_string_list,
	enum_RCS_ADMIN_STATE_int_list,
	MAX_ENUM_RCS_ADMIN_STATE_STRING_LENGTH,
	ENUM_RCS_ADMIN_STATE_LENGTH,
	(cms_symbol_lookup_function_t)skel_enum_RCS_ADMIN_STATE_symbol_lookup
	};

/*
Estimated_size	SkelCfgCycleTime	32
Estimated_size	SkelCfgDebug	32
Estimated_size	SkelCfgLength	32
Estimated_size	SkelCfgNop	24
Estimated_size	SkelCfgWidth	32
Estimated_size	SkelCmdAbort	24
Estimated_size	SkelCmdGo	32
Estimated_size	SkelCmdHalt	24
Estimated_size	SkelCmdInit	24
Estimated_size	SkelCmdNop	24
Estimated_size	SkelCmdShutdown	24
Estimated_size	SkelSet	344
Estimated_size	SkelStat	312
Estimated_size	MAXIMUM	344
*/
/*
*	NML/CMS Format function : skel_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
int skel_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"skel",
		(cms_symbol_lookup_function_t) skel_symbol_lookup,
		(const char **)skel_name_list,
		skel_id_list,skel_size_list,
		SKEL_NAME_LIST_LENGTH,
		MAX_SKEL_NAME_LENGTH);

	switch(type)
	{
	case SKEL_CFG_CYCLE_TIME_TYPE:
		((SkelCfgCycleTime *) buffer)->update(cms);
		break;
	case SKEL_CFG_DEBUG_TYPE:
		((SkelCfgDebug *) buffer)->update(cms);
		break;
	case SKEL_CFG_LENGTH_TYPE:
		((SkelCfgLength *) buffer)->update(cms);
		break;
	case SKEL_CFG_NOP_TYPE:
		((SkelCfgNop *) buffer)->update(cms);
		break;
	case SKEL_CFG_WIDTH_TYPE:
		((SkelCfgWidth *) buffer)->update(cms);
		break;
	case SKEL_CMD_ABORT_TYPE:
		((SkelCmdAbort *) buffer)->update(cms);
		break;
	case SKEL_CMD_GO_TYPE:
		((SkelCmdGo *) buffer)->update(cms);
		break;
	case SKEL_CMD_HALT_TYPE:
		((SkelCmdHalt *) buffer)->update(cms);
		break;
	case SKEL_CMD_INIT_TYPE:
		((SkelCmdInit *) buffer)->update(cms);
		break;
	case SKEL_CMD_NOP_TYPE:
		((SkelCmdNop *) buffer)->update(cms);
		break;
	case SKEL_CMD_SHUTDOWN_TYPE:
		((SkelCmdShutdown *) buffer)->update(cms);
		break;
	case SKEL_SET_TYPE:
		((SkelSet *) buffer)->update(cms);
		break;
	case SKEL_STAT_TYPE:
		((SkelStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *skel_symbol_lookup(long type)
{
	switch(type)
	{
	case SKEL_CFG_CYCLE_TIME_TYPE:
		return "SkelCfgCycleTime";
	case SKEL_CFG_DEBUG_TYPE:
		return "SkelCfgDebug";
	case SKEL_CFG_LENGTH_TYPE:
		return "SkelCfgLength";
	case SKEL_CFG_NOP_TYPE:
		return "SkelCfgNop";
	case SKEL_CFG_WIDTH_TYPE:
		return "SkelCfgWidth";
	case SKEL_CMD_ABORT_TYPE:
		return "SkelCmdAbort";
	case SKEL_CMD_GO_TYPE:
		return "SkelCmdGo";
	case SKEL_CMD_HALT_TYPE:
		return "SkelCmdHalt";
	case SKEL_CMD_INIT_TYPE:
		return "SkelCmdInit";
	case SKEL_CMD_NOP_TYPE:
		return "SkelCmdNop";
	case SKEL_CMD_SHUTDOWN_TYPE:
		return "SkelCmdShutdown";
	case SKEL_SET_TYPE:
		return "SkelSet";
	case SKEL_STAT_TYPE:
		return "SkelStat";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for SkelCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("SkelCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("SkelCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCfgDebug::update(CMS *cms)
{

	cms->beginClass("SkelCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("SkelCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCfgLength
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCfgLength::update(CMS *cms)
{

	cms->beginClass("SkelCfgLength","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("length",length);

	cms->endClass("SkelCfgLength","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCfgNop::update(CMS *cms)
{

	cms->beginClass("SkelCfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SkelCfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCfgWidth
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCfgWidth::update(CMS *cms)
{

	cms->beginClass("SkelCfgWidth","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("width",width);

	cms->endClass("SkelCfgWidth","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCmdAbort::update(CMS *cms)
{

	cms->beginClass("SkelCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SkelCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCmdGo
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCmdGo::update(CMS *cms)
{

	cms->beginClass("SkelCmdGo","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("where",where);

	cms->endClass("SkelCmdGo","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCmdHalt::update(CMS *cms)
{

	cms->beginClass("SkelCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SkelCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCmdInit::update(CMS *cms)
{

	cms->beginClass("SkelCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SkelCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCmdNop::update(CMS *cms)
{

	cms->beginClass("SkelCmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SkelCmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelCmdShutdown::update(CMS *cms)
{

	cms->beginClass("SkelCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SkelCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SkelSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelSet::update(CMS *cms)
{

	cms->beginClass("SkelSet","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("length",length);
	cms->update_with_name("lengthReq",lengthReq);
	cms->update_with_name("width",width);
	cms->update_with_name("widthReq",widthReq);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);

	cms->endClass("SkelSet","RCS_STAT_MSG_V2");

}


/*
*	NML/CMS Update function for SkelStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Tue Feb 24 11:01:11 GMT-05:00 2009
*/
void SkelStat::update(CMS *cms)
{

	cms->beginClass("SkelStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("where",where);
	cms->update_with_name("here",here);

	cms->endClass("SkelStat","RCS_STAT_MSG_V2");

}

