/** \example exampleVisGraph.cc
 This is an example of how to use the visGraph functions to generate a visibility graph
*/
// sample program for generating a visibility graph
#include "posemath.h"
#include "visGraph.hh"
#include "moastGeom.hh"
int main(int argc, char *argv[])
{
  char * name = "/usr/local/src/moast/devel/src/vehicle/maps/DM-Factory";
  VisGraph *visGraph;
  int numReturned;
  Location2D point, point2;

  visGraph = new VisGraph( 20, 20 );
  //  visGraph = new VisGraph( 500, 500 );

  // build the graph
  if (argc > 1) {
    name = argv[1];
  }
  numReturned = visGraph->load(name, .7);
  visGraph->print();
  visGraph->setOutImage(.1);
  visGraph->dump("test.ppm", 0x0);
  
  //  point.north = 200;
  //  point.east = 200;
  point.north = 0;
  point.east = 0;
  visGraph->buildGraph(numReturned);
  /*
  for( int count = 0; count<numReturned; count++ )
    {
      point2 = visGraph->getStoredPt(count);
      fprintf( stdout, "L %d %d %d %d\n",
	       (int)point.north, (int)point.east,
	       (int)point2.north, (int)point2.east );
    }
  */
  /*
  RotTree rotTree;
  MoastGeom foo;

  rotTree.load();
  rotTree.sort();
  rotTree.printSort();
  rotTree.createTree(); 
  rotTree.printTree();
  */

  /*
  LineSegment l1, l2;

  l1.setStart(0, 0);
  l1.setEnd(5, 0 );
  l2.setStart(4, 1 );
  l2.setEnd(4, -2 );

  if( foo.intersect( l1, l2 ))
    fprintf( stderr, "They intersect\n" );
  else
    fprintf( stderr, "They don't intersect\n" );

  l1.setStart(0, 0);
  l1.setEnd(5, 0 );
  l2.setStart(4, 1 );
  l2.setEnd(4, 2 );

  if( foo.intersect( l1, l2 ))
    fprintf( stderr, "They intersect\n" );
  else
    fprintf( stderr, "They don't intersect\n" );
  */
}
