/*
  inb.c

  Reads and prints a value from an x86 I/O port.
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#ifdef HAVE_SYS_IO_H
#include <sys/io.h>            /* ioperm, inb */
#else
#error required header sys/io.h not found
#endif

int main(int argc, char * argv[])
{
  int port;

  if (argc < 2 ||
      1 != sscanf(argv[1], "%i", &port)) {
    fprintf(stderr, "usage: inb <port>\n");
    return 1;
  }

  if (0 != ioperm(port, 1, 1)) {
    perror("inb");
    return 1;
  }

  printf("0x%X\n", (int) inb(port));

  return 0;
}
