/*
  outb.c

  Writes a value to an x86 I/O port.
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#ifdef HAVE_SYS_IO_H
#include <sys/io.h>            /* ioperm, outb */
#else
#error required header sys/io.h not found
#endif

int main(int argc, char * argv[])
{
  int port;
  int val;

  if (argc < 3 ||
      1 != sscanf(argv[1], "%i", &port) ||
      1 != sscanf(argv[2], "%i", &val)) {
    fprintf(stderr, "usage: outb <port> <val>\n");
    return 1;
  }

  if (0 != ioperm(port, 1, 1)) {
    perror("outb");
    return 1;
  }

  (void) outb(val, port);

  return 0;
}
