#!/bin/sh

set -x;

if test "x${RCSLIB_DIR}" = "x" ; then
    RCSLIB_DIR=`grep RCSLIB_DIR ../Makefile | awk '{print $3}'`;
fi

for dir in $*; do
    if test -d $dir/navDataExt1 ; then
	cd $dir;
	echo "time,speed" > nav_speed.csv;
	map=`ls -1 *NavDataExt* | head -n 1`;
	cd navDataExt1 ;
	start_time=0;
	for n in *.NavDataExt; do
	    if test "x$n" != 'x*.NavDataExt' -a "x$n" != "x"; then
		${RCSLIB_DIR}/bin/nml_packed_file_to_csv ../$map $n -o $n.csv;
		time=`grep time $n.csv | awk '{print $4}'`;
		if test "x${start_time}" = "x0" ; then
		    start_time=${time};
		fi
		time=`echo "${time} - ${start_time}" | bc -l`;
		#x=`grep tranAbs.x $n.csv | awk '{print $3}'`;
		#y=`grep tranAbs.x $n.csv | awk '{print $3}'`;		
		speed=`grep speed $n.csv | awk '{print $4}'`;
		echo "${time},${speed}" >> ../nav_speed.csv;
	    fi
	done;
	cd ../..;
	java -jar ${RCSLIB_DIR}/bin/plotter_NB.jar $dir/nav_speed.csv --geometry 1024x768 --Function=Each --FunctionArg=time --showKey -o velocity_plot_${dir}.jpg
     fi
done
