/*****************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*****************************************************************************/
/*!
  \file   scrollMapCell.hh
  \brief  Contains the definition of the ScrollingMapCell class.
*/

#ifndef __scrollingMapCell_hh
#define __scrollingMapCell_hh

/***********************************************************************/

/*! Class ScrollingMapCell serves as the parent class for cell classes
  used in applications that use the ScrollingMap class. The only
  data in a ScrollingMapCell is a cell id, which is an integer
  that uniquely identifies a cell of a ScrollingMap. The id of
  a cell is set by the ScrollingMap constructor. There is no way
  to reset the id of a ScrollingMapCell. The getId method returns
  the id of a cell. */

class ScrollingMapCell
{
  friend class ScrollingMap;
public:
  ScrollingMapCell(){}
  ~ScrollingMapCell(){}
  int getId(){return id;}

private:
  int id;
};

#endif
