/*
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*/

/*!
  \file moastSupSkin.hh

  \brief 
  \code CVS Status:
  $Author: proctor $
  $Revision: 1.10 $
  $Date: 2009/01/13 16:13:09 $
  \endcode

  \author Chris Scrapper
*/

#ifndef MOAST_SUP_SKIN_HH
#define MOAST_SUP_SKIN_HH

#include <string>
#include <map>
#include <sstream>
using namespace std;

//! SIMware includes 
#include "swBaseSkin.hh"
#include "simWareKB.hh"
#include "swKBTypes.hh"
#include "swServoMob.hh"
#include "swServoSP.hh"
#include "swServoMis.hh"
#include "swServoEff.hh"
#include <inifile.h>


class SIMwareKB;

extern void spawnMoastThr (void *tArgs);

class MoastSupSkin : public SIMwareSupSkin {
  friend class SIMwareServoNodeBase;
  friend class SIMwareServoMob;
  friend class SIMwareServoSP;
  friend class SIMwareServoMis;
  friend class SIMwareServoEff;

private:
  
  vector <void *> thr;
  SIMwareServoMob * mob;
  SIMwareServoSP * sp;
  SIMwareServoEff * eff;
  
  vector<SIMwareServoMis *> mis;
  
  string nmlProcName;
  string nmlCfgFile;
  
  

public:
  MoastSupSkin();
  ~MoastSupSkin();
  bool configSupSkin(SIMwareKB *, SIMwareInfSkin *);
  bool openSkin();
  void closeSkin();
    
};
#endif
