#include "swKBEff.hh"



SIMwareEffOpcodeConfig::SIMwareEffOpcodeConfig(SIMwareEffOpcodeType opcodeType)
{
  type = opcodeType;
  maxVal=0.00;
  minVal=0.00;
}
SIMwareEffOpcodeConfig:: ~SIMwareEffOpcodeConfig()
{}
double SIMwareEffOpcodeConfig::getMaxValue()
{
  return maxVal;
}
void SIMwareEffOpcodeConfig::setMaxValue(double value)
{
  maxVal=value;
}
double SIMwareEffOpcodeConfig::getMinValue()
{
  return minVal;
}
void SIMwareEffOpcodeConfig::setMinValue(double value)
{
  minVal=value;
}


SIMwareEffOpcodeType SIMwareEffOpcodeConfig::getOpcodeType()
{
  return type;
}

void SIMwareEffOpcodeConfig::dump()
{
  printf("<SIMwareEffOpcodeConfig::dump> Opcode: %d \tMaxValue: %lf \tMinValue: %lf\n", 
	 (int)type,maxVal,minVal);
}

int SIMwareKBEff::effCount=0;

SIMwareKBEff::SIMwareKBEff () 
{
  effID = ++effCount;
  mount=NULL;
}
SIMwareKBEff::SIMwareKBEff (string name)
{
  setName(name);
  effID = ++effCount;
  mount=NULL;
}

SIMwareKBEff::~SIMwareKBEff ()
{
}

void
SIMwareKBEff::setName (string n)
{
  effName = n;
}

string
SIMwareKBEff::getName ()
{
  return effName;
}

void
SIMwareKBEff::setID (int id)
{
  effID = id;
}

int
SIMwareKBEff::getID ()
{
  return effID;
}

SIMwareEffOpcodeConfig * 
SIMwareKBEff::getOpcodeConfig(SIMwareEffOpcodeType type, bool insert)
{
  
  map < SIMwareEffOpcodeType, SIMwareEffOpcodeConfig *>::iterator itr;

  itr = opConfMap.find (type);

  if (itr == opConfMap.end () && insert)
    {
      switch (type)
	{
	case SW_EFF_OPCODE_ACTIVATE_TYPE:
	case SW_EFF_OPCODE_ANIMATE_TYPE:
	case SW_EFF_OPCODE_FIRE_TYPE:
	case SW_EFF_OPCODE_RELEASE_TYPE:
	case SW_EFF_OPCODE_RESET_TYPE:
	case SW_EFF_OPCODE_NOP_TYPE:
	  opConfMap[type] = new SIMwareEffOpcodeConfig(type);
	  break;
	default:
	  printf
	    ("** WARNING ** <SIMwareKBEff::getOpcodeConfig> Opcode not recognized : %d\n", type);
	  return NULL;
	}
       itr = opConfMap.find (type);
    }
  if(itr == opConfMap.end())
    return NULL;
  else
    return itr->second;
}


PM_POSE SIMwareKBEff::getEff2Mount ()
{
  return effToMount;
}
void
SIMwareKBEff::setEff2MountXYZ (double x, double y, double z)
{
  effToMount.tran.x = x;
  effToMount.tran.y = y;
  effToMount.tran.z = z;
}

void
SIMwareKBEff::setEff2MountRPY (double r, double p, double y)
{
  effToMount.rot = PM_RPY(r,p,y);
}

PM_CARTESIAN 
SIMwareKBEff::getEff2MountXYZ()
{
  return effToMount.tran;
}

PM_RPY 
SIMwareKBEff::getEff2MountRPY()
{
  return effToMount.rot;
}

void
SIMwareKBEff::setMount (SIMwareKBMount * m)
{
  mount = m;
}



SIMwareKBMount * 
SIMwareKBEff::getMount()
{
  return mount;
}
