#include "swKBMis.hh"


SIMwareKBLink::SIMwareKBLink ()
{
  parentLink=NULL;
  linkID = 0;
  jType = SW_KB_UNKNOWN_JOINT_TYPE;
  jVal=0.00;
  torque=0.00;
  maxSpeed = 0.00;
  maxTorque = 0.00;
  maxRange = 0.00;
  minRange = 0.00;
}

SIMwareKBLink::~SIMwareKBLink ()
{
}

SIMwareKBLink::SIMwareKBLink (int link_id)
{
  parentLink=NULL;
  linkID = link_id;
  jType = SW_KB_UNKNOWN_JOINT_TYPE;
  jVal=0.00;
  torque=0.00;
  maxSpeed = 0.00;
  maxTorque = 0.00;
  maxRange = 0.00;
  minRange = 0.00;
}



void
SIMwareKBLink::setLinkID (int l)
{
  linkID = l;
}

int
SIMwareKBLink::getLinkID ()
{
  return linkID;
}


void
SIMwareKBLink::setJointType (SIMwareJointType j)
{
  jType = j;
}

SIMwareJointType
SIMwareKBLink::getJointType ()
{
  return jType;
}

void
SIMwareKBLink::setMaxSpeed(double speed)
{
  maxSpeed = speed;
}

double
SIMwareKBLink::getMaxSpeed ()
{
  return maxSpeed;
}

void
SIMwareKBLink::setMaxTorque(double torque)
{
  maxTorque = torque;
}

double
SIMwareKBLink::getMaxTorque ()
{
  return maxTorque;
}


void
SIMwareKBLink::setMaxRange(double range)
{
  maxRange = range;
}

double
SIMwareKBLink::getMaxRange ()
{
  return maxRange;
}

void
SIMwareKBLink::setMinRange(double range)
{
  minRange = range;
}

double
SIMwareKBLink::getMinRange ()
{
  return minRange;
}



void 
SIMwareKBLink::setParentLink (SIMwareKBLink * parent)
{
  parentLink=parent;
}

SIMwareKBLink * SIMwareKBLink::getParentLink()
{
  return parentLink;
}

void 
SIMwareKBLink::setLocation (double x, double y, double z)
{
  loc.x=x;
  loc.y=y;
  loc.z=z;
}

void 
SIMwareKBLink::setLocation (PM_CARTESIAN xyz)
{
  loc = xyz;
}

PM_CARTESIAN
SIMwareKBLink::getLocation ()
{
  return loc;
}


void 
SIMwareKBLink::setOrientation (double r, double p, double y)
{
  rot.r=r;
  rot.p=p;
  rot.y=y;
}

void 
SIMwareKBLink::setOrientation (PM_RPY rpy)
{
  rot = rpy;
}

PM_RPY
SIMwareKBLink::getOrientation ()
{
  return rot;
}


void 
SIMwareKBLink::setJointVal (double val)
{
  jVal = val;
}

double
SIMwareKBLink::getJointVal()
{
  return jVal;
}

void 
SIMwareKBLink::setTorque (double absTorque)
{
  torque = absTorque;
}

double
SIMwareKBLink::getTorque()
{
  return torque;
}

int SIMwareKBMisPkg::misPkgCount=0;

SIMwareKBMisPkg::SIMwareKBMisPkg () 
{
  misPkgID = ++misPkgCount;
}
SIMwareKBMisPkg::SIMwareKBMisPkg (string name)
{
  setName(name);
  misPkgID = ++misPkgCount;
}

SIMwareKBMisPkg::~SIMwareKBMisPkg () 
{
  map < int, SIMwareKBLink * >::iterator itr = linkMap.begin();
  while(itr != linkMap.end ())
    {
      if(itr->second)
	{
	  delete itr->second;
	}
      itr++;
    }
  linkMap.clear();

}

void
SIMwareKBMisPkg::setName (string m)
{
  mName = m;
}

string
SIMwareKBMisPkg::getName ()
{
  return mName;
}

int
SIMwareKBMisPkg::getMisPkgID ()
{
  return misPkgID;
}

SIMwareKBLink *
SIMwareKBMisPkg::getLink(int linkID, bool insert)
{
  //map < int, SIMwareKBLink *, intCmp >::iterator itr;
  map < int, SIMwareKBLink * >::iterator itr;
  itr = linkMap.find (linkID);
  if (itr == linkMap.end () && insert)
    {
      linkMap[linkID] = new SIMwareKBLink (linkID);
      itr = linkMap.find (linkID);   
      return itr->second;
    }
  
  if (itr == linkMap.end ())
    return NULL;
  else
    return itr->second;
}

int 
SIMwareKBMisPkg::getLinkCount()
{
  return linkMap.size();
}

void 
SIMwareKBMisPkg::setTimeStamp (double secs)
{
  timeStamp=secs;
}

double
SIMwareKBMisPkg::getTimeStamp()
{
  return timeStamp;
}
