#ifndef SW_SERVO_EFF_HH
#define SW_SERVO_EFF_HH

#include <signal.h>


#include <string>
#include <map>
#include <vector>
using namespace std;

//! SIMware Headers
#include "swServoNodeBase.hh"
#include "simWareKB.hh"

// MOAST Headers
#include "servoEffJA.hh"

class SIMwareServoEff : public SIMwareServoNodeBase {
protected:

  void doEffCmdInit();
  void doEffCmdHalt();
  void doEffCmdAbort();
  void doEffCmdShutdown();
  void doEffCmdOpcode(ServoEffJACmdOpcode *);
  
  void doEffCfgCycleTime(ServoEffJACfgCycleTime *);
  void doEffCfgDebug(ServoEffJACfgDebug *);

  vector <SIMwareKBEff *> effList;

  void errorHandler(int);
public:
  SIMwareServoEff(MoastSupSkin *);
  ~SIMwareServoEff();
  void doSingleStep();
  void publishSettings();
  void sendStatus(); 
};
#endif
