#ifndef SW_SERVO_MIS_HH
#define SW_SERVO_MIS_HH

//! SIMware Headers
#include "swServoNodeBase.hh"
#include "swKBTypes.hh"
#include "simWareKB.hh"

// MOAST Headers
#include "servoMisJA.hh"

class SIMwareServoMis : public SIMwareServoNodeBase {
protected:
  SIMwareKBMisPkg * misPkg;
  void doMisCmdInit();
  void doMisCmdHalt();
  void doMisCmdAbort();
  void doMisCmdShutdown();
  void doMisCmdMove(ServoMisJACmdMove *);
  void doMisCfgDebug( ServoMisJACfgDebug *); 
  void doMisCfgCycleTime( ServoMisJACfgCycleTime *); 
  void errorHandler(int);
public:
  SIMwareServoMis(MoastSupSkin *, SIMwareKBMisPkg *);
  ~SIMwareServoMis();
  void doSingleStep();
  void publishSettings();
  void sendStatus();
};
#endif
