#include <stdio.h>
#include <stdlib.h>
#include "cluster.hh"
#include <search.h>

#define vehID 1
#define myName "vehMobPL"

int main(int argc, char **argv)
{
  Cluster cluster(3); // 3 is the spacing that is allowed between members of cluster.
  char *configNml = getenv("CONFIG_NML");
  char chanName[MOAST_NML_BUFFER_NAME_LEN];
  NML *sensorDataNml;
  int mode =1;
  FILE *fp;

  char *data[] = { "alpha", "bravo", "charlie", "delta",
		   "echo", "foxtrot", "golf", "hotel", "india", "juliet",
		   "kilo", "lima", "mike", "november", "oscar", "papa",
		   "quebec", "romeo", "sierra", "tango", "uniform",
		   "victor", "whisky", "x-ray", "yankee", "zulu"
  };
  char *dataIn;

  ENTRY e, *ep;
  int i;

  /* starting with small table, and letting it grow does not work */
  hcreate(30);
  for (i = 0; i < 24; i++) {
    dataIn = new char[strlen(data[i])+1];
    strcpy( dataIn, data[i] );
    e.key = dataIn;
    /* data is just an integer, instead of a
       pointer to something */
    e.data = (void *)i;
    ep = hsearch(e, ENTER);
    /* there should be no failures */
    if (ep == NULL) {

      fprintf(stderr, "entry failed\n");
      exit(1);
    }
  }
  for (i = 22; i < 26; i++) {
    /* print two entries from the table, and
       show that two are not in the table */
    e.key = data[i];
    ep = hsearch(e, FIND);
    printf("%9.9s -> %9.9s:%d\n", e.key,
	   ep ? ep->key : "NULL",
	   ep ? ep->data : 0);
  }
  return 0;















  /*
  cluster.test(1);
  exit(1);
  */

  if( argc == 3 ) // 1=filename, 2=mode
    {
      mode = atoi(argv[2]);
      cluster.readFile( argv[1], mode );
    }
  else
    {
      if(!configNml)
	{
	  fprintf(stderr,"Please set CONFIG_NML environment variable.\n");
	  return(false);
	}
      sprintf( chanName, "%s%d", AM_SP_MAP_NAME, vehID );
      sensorDataNml = new NML( sensorData_format, chanName,
			      myName, configNml );
      if( NULL == sensorDataNml || !sensorDataNml->valid() )
	{
	  rcs_print_error( "%s: Error - Can't open %s buffer\n", 
			   myName, chanName );
	  return(false);
	}
      cluster.readNML( sensorDataNml );
    }
  if( mode == 3 )
    {
      fp = fopen( "before.mif", "w" );
      cluster.print(fp);
      fclose(fp);
      cluster.expandPolygons(.5);
      printf( "Start of file2\n" );
      fp = fopen( "after.mif", "w" );
      cluster.print(fp);
      fclose(fp);
      printf( "Start of file3\n" );
    }
  else
    {
      fprintf(stderr, "Found %d clusters\n",  cluster.build());
      cluster.buildHulls();
      //cluster.print();
    }
}
