#include <iostream>
#include <list>
#include <FreeImagePlus.h>

using namespace std;

class SimplePoint{
  public:
  int x;
  int y;
  SimplePoint(int a,int b){x=a;y=b;};
};

class Score
{
public:
	// Class variables
	int** map;	
	int mapHeight;
	int mapWidth;

	// Constructors
	Score();
	Score(int** newMap, int height, int width);

	// Class functions
	int computeScore(list<SimplePoint*> *points, int range);
	bool worthPoint(SimplePoint* point);
};

class DeploymentPlan
{
public:
  int** voronoiMap;
  int voronoiWidth;
  int voronoiHeight;
  char* fileName;
  int loadVoronoiFromBMP(char* filePath);
  

  void printVoronoiToConsole();

  Score scoring;

  list<SimplePoint*> *searchResults;
  list<SimplePoint*> *bestPoints;
  list<SimplePoint*> *waypoints;
  int writeSolutionToBMP(list<SimplePoint*>  *points,char* path);
  int writeBestSolution();
  int maxSearchNodes;
  int searchCallCount;
  int solutionNumber;
  int solutionCount;
  int bestScore;
  int pixelRange;
  void runSearch(SimplePoint *p,int depth,int robotCount);
  bool generateWaypointsToGoal(SimplePoint *start, SimplePoint *goal);
  void setPixel(int x,int y);
  bool voronoiPointIntersect(int x,int y,bool removePointsNearRobots = true);

  DeploymentPlan(int commRangeInPixels){
    solutionNumber=0;
    maxSearchNodes = -1;
    pixelRange = commRangeInPixels;
    searchResults = new list<SimplePoint *>();
    bestPoints = new list<SimplePoint *>();
    waypoints = new list<SimplePoint *>();
  };
  ~DeploymentPlan(){
    searchResults->clear();
    bestPoints->clear();
    waypoints->clear();
    delete searchResults;
    delete bestPoints;
    delete waypoints;
  };
};
