/*****************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*****************************************************************************/
/*!
  \file   scrollingBoxVoxel.hh
  \brief  Contains the definition of the ScrollingBoxVoxel class.
*/

#ifndef __scrollingBoxVoxel_hh
#define __scrollingBoxVoxel_hh

/***********************************************************************/

/*! Class ScrollingBoxVoxel serves as the parent class for voxel classes
  used in applications that use the ScrollingBox class. The only
  data in a ScrollingBoxVoxel is a voxel id, which is an integer
  that uniquely identifies a voxel of a ScrollingBox. The id of
  a voxel is set by the ScrollingBox constructor. There is no way
  to reset the id of a ScrollingBoxVoxel. The getId method returns
  the id of a voxel. */

class ScrollingBoxVoxel
{
  friend class ScrollingBox;
public:
  ScrollingBoxVoxel(){}
  ~ScrollingBoxVoxel(){}
  int getId(){return id;}

private:
  int id;
};

#endif
