/*
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*/

/*!
  \file sockutils.h

  \brief Declarations for TCP/IP socket utilities.

  \code CVS Status:
  $Author: proctor $
  $Revision: 1.1 $
  $Date: 2008/03/07 17:45:39 $
  \endcode

  \author Fred Proctor
*/

#ifndef SOCKUTILS_H
#define SOCKUTILS_H

/* called by client to connect to server */
extern int get_server_fd(int port, char * hostname);

/* called by server to become a server on the port */
extern int get_socket_fd(int port);

/* called by server to connect to a client */
extern int get_client_fd(int socket_fd);

#endif

/*
  Modification history:

  $Log: sockutils.h,v $
  Revision 1.1  2008/03/07 17:45:39  proctor
  Added matilda code in servo, and socket, tty utils in tools

*/
