#ifndef SW_SERVO_MOB_HH
#define SW_SERVO_MOB_HH

//! SIMware Headers
#include "swServoNodeBase.hh"
#include "swKBTypes.hh"

// MOAST Headers
#include "servoMobJA.hh"

class SIMwareServoMob : public SIMwareServoNodeBase {
protected:
  void doMobCmdInit();
  void doMobCmdHalt();
  void doMobCmdAbort();
  void doMobCmdShutdown();
  
  void doMobCmdDrvAckerman(ServoMobJACmdAckerman *);
  void doMobCmdDrvSubmarine(ServoMobJACmdSubmarine *);
  void doMobCmdDrvSkid(ServoMobJACmdSkid *);
  void doMobCmdDrvFlipSkid(ServoMobJACmdFlipSkid *);
  void doMobCmdDrvOmni(ServoMobJACmdOmni *);
  void doMobCmdDrvRotaryWing(ServoMobJACmdRotaryWing *);

  
  void doMobCfgTeleport(ServoMobJACfgTeleport *);
  void doMobCfgCycleTime(ServoMobJACfgCycleTime *);
  void doMobCfgDebug(ServoMobJACfgDebug *);
  
  void errorHandler(int);
public:
  SIMwareServoMob(MoastSupSkin *);
  ~SIMwareServoMob();
  void doSingleStep();
  void publishSettings();
  void sendStatus();
};
#endif
