#ifdef HAVE_GETOPT_H
#include <getopt.h>
#else
#include "getopt.h"
#endif
#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <ctype.h> /* isspace */
#include <stdlib.h> /* atof */
#include <moastTypes.hh>

int main(int argc, char *argv[])
{
  char *fileName = NULL;
  char *fileOut = "out.dat";
  FILE *fp, *fpOut;
  char c;
  double currentError, currentSpeed;
  double oldError, oldSpeed;
  Location2D current, old;

  while((c=getopt(argc,argv,"cf:i:o:"))!=EOF)
    {
      switch(c)
	{
	case 'f':
	  fileName = optarg;
	  break;
	case 'o':
	  fileOut = optarg;
	  break;
	}
    }
  if( fileName == NULL )
    {
      printf( "must include file name\n" );
      return 1;
    }
  if (NULL == (fp = fopen(fileName, "r")))
    {
      printf( "unable to open file %s\n", fileName );
      return 1;
    }

  if (NULL == (fpOut = fopen(fileOut, "w")))
    {
      printf( "unable to open file: out.dat \n" );
      return 1;
    }
  
  fscanf(fp, "%lf %lf %lf %lf", &old.north, &old.east, &oldError, &oldSpeed );
  fprintf( fpOut, "%5.2f %5.2f %5.2f %5.2f\n", old.north, old.east, .4, oldSpeed );
  while( fscanf( fp,"%lf %lf %lf %lf", &current.north, &current.east, &currentError, &currentSpeed ) != EOF )
    {
      if( old.dist(current) > .4 )
	{
	  old = current;
	  oldError = currentError;
	  oldSpeed = currentSpeed;
	  fprintf( fpOut, "%5.2f %5.2f %5.2f %5.2f\n", old.north, old.east, .4, oldSpeed );
	}
    }
  fclose( fp );
  fclose( fpOut );
}
