#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget *globalImageWindow;
char *globalImageFile;
float globalScale;

void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_delete1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_zoom_in1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  globalScale *= 2;
  /*  printf( "Scale now at: %f\n", globalScale ); */
}


void
on_zoom_out1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  globalScale /= 2;
  /*  printf( "Scale now at: %f\n", globalScale ); */
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

static gint timeout_callback(gpointer data)
{
  GdkPixbuf *pixbuf, *pixbufOld;
  gint width, height;
  GError *error=NULL;
  /*  static int firstTime = 1; */

#if GDK_PIXBUF_MAJOR > 2 || GDK_PIXBUF_MINOR >= 6
  gdk_pixbuf_get_file_info( globalImageFile, &width, &height );
#else
  GdkPixbuf *temppixbuf = gdk_pixbuf_new_from_file(globalImageFile, &error);
  if(error) {
    printf("read file '%s' error: %s\n", globalImageFile, error->message);
    return TRUE;
  }
  width = gdk_pixbuf_get_width(temppixbuf);
  height = gdk_pixbuf_get_height(temppixbuf);
#endif
  if( width<=0 || height<=0 )
    return TRUE; /* keep  the timer going */
  width = (int)( (float)width * globalScale );
  height = (int)( (float)height * globalScale );
  /*  printf( "New image: %s is %d x %d in size\n", 
      globalImageFile, width, height ); */
  pixbufOld = gtk_image_get_pixbuf((GtkImage*)globalImageWindow);
#if GDK_PIXBUF_MAJOR > 2 || GDK_PIXBUF_MINOR >= 6
  pixbuf = gdk_pixbuf_new_from_file_at_scale( globalImageFile,
  					      width,
					      height,
  					      TRUE,
  					      &error );
#else
  pixbuf = gdk_pixbuf_scale_simple(temppixbuf, 
				   width, 
				   height, 
				   GDK_INTERP_BILINEAR);
#endif
  gtk_image_set_from_pixbuf((GtkImage*)globalImageWindow, pixbuf );
  /*  if( !firstTime ) */
  if( G_IS_OBJECT(pixbufOld) )
    g_object_unref(pixbufOld);
  /*
  else
    firstTime = 0;
  */
  /*  gtk_image_set_from_file((GtkImage*)globalImageWindow, 
      globalImageFile ); */
  return TRUE; /* FALSE means stop the timer */
}

void setupTimerCallback( GtkWidget *window1, int rate )
{
  globalImageWindow = lookup_widget(GTK_WIDGET(window1),
				    "image1");
  (void) g_timeout_add(rate, /* millisecs */
		       timeout_callback, 0 );
}
