#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <gtk/gtk.h>

#include "callbacks.hh"
#include "interface.hh"
#include "support.hh"
#include <rcs.hh>
#include <sectMobPL.hh>
#include <moastError.hh>

#define DEF_CYCLE_TIME 100

void clearFlash()
{
  char newText[100];
  GtkWidget *labelWidget;
  GdkColor bckgrndColor;
  extern GtkWidget *globalWindow;

  bckgrndColor.red = 0;
  bckgrndColor.green = 65535;
  bckgrndColor.blue = 0;

  sprintf( newText, "<span weight=\"bold\" size=\"x-large\""
	   "background=\"%s\">  %s  </span>" ,
	   "Green","" );
  labelWidget = lookup_widget(globalWindow, "textLabel");
  gtk_label_set_text(GTK_LABEL(labelWidget), _(newText));
  gtk_label_set_use_markup(GTK_LABEL(labelWidget), TRUE);
  gtk_widget_modify_bg( globalWindow, GTK_STATE_NORMAL, &bckgrndColor );
}

void flashText( char *textToFlash )
{
  extern GtkWidget *globalWindow;
  char newText[512];
  GtkWidget *labelWidget;
  char textColor[20];
  GdkColor bckgrndColor;
  static bool turnRed = true;

  if( turnRed )
    {
      strcpy( textColor, "Red" );
      bckgrndColor.red = 65535;
      bckgrndColor.green = 0;
      bckgrndColor.blue = 0;
      turnRed = false;
    }
  else
    {
      strcpy( textColor, "Green" );
      bckgrndColor.red = 0;
      bckgrndColor.green = 65535;
      bckgrndColor.blue = 0;
      turnRed = true;
    }

  //  if( strlen( textToFlash ) < 10 )
    sprintf( newText, "<span weight=\"bold\" size=\"x-large\""
	     " background=\"%s\">  %s  </span>" ,
	     textColor,textToFlash );
    //    printf( "Flashing: %s\n", newText );
    /*
  else
    sprintf( newText, "<span weight=\"bold\" size=\"large\""
	     "background=\"%s\">  %s  </span>" ,
	     textColor,textToFlash );
    */
  labelWidget = lookup_widget(globalWindow, "textLabel");
  gtk_label_set_text(GTK_LABEL(labelWidget), _(newText));
  gtk_label_set_use_markup(GTK_LABEL(labelWidget), TRUE);
  gtk_widget_modify_bg( globalWindow, GTK_STATE_NORMAL, &bckgrndColor );
}

static gint runStateMachine(gpointer data)
{
  int type;
  extern RCS_STAT_CHANNEL *statNml;
  extern NML *nmlNML;
  extern int command;
  extern int status;
  int statusRead;
  int commandRead;
  MoastError *moastError;

  if( statNml != NULL )
    type = statNml->read();
  else if( nmlNML != NULL )
    type = nmlNML->read();
  else
    return false;
  switch( type )
    {
    case 0: // no new data
      break;
    case SECT_MOB_PL_STAT_TYPE:
      commandRead = statNml->get_address()->command_type;
      statusRead = statNml->get_address()->status;
      if( commandRead==command && statusRead==status )
	flashText( "CRASH" );
      else
	clearFlash();
      //      printf( "Status: %d Cmd: %d\n", statusRead, commandRead );
      return(true);
    case MOAST_ERROR_TYPE:
      moastError = (MoastError*)nmlNML->get_address();
      //      flashText( "Hey..." ); 
      flashText( moastError->message );
      return(true);
    default:
      break;
    }
  return true;
}

void init(GtkWidget *window)
{
  (void) g_timeout_add(DEF_CYCLE_TIME, /* millisecs */
		       runStateMachine, window );
}


