/* nmlPosition.hh */
/* This file  created for the RoboCamp 06 practical integration with the SPQR robot
 */
#ifndef NML_POS_HH
#define NML_POS_HH
#include "rcs.hh"

#define NML_POS_VICTIM_NAME "PosBufVictim"
#define NML_POS_MAPPER_NAME "PosBufMapper"
/* Give the new structure a unique id number */
#define POSITION_MSG_TYPE 110
/* The id number must be unique within a CMS buffer, i.e. the number
must be different than the id of any other type that might be written to
a particular buffer. For simplicity it is recommended that the id number
also be unique within an application. */

/* Define the new message structure */
struct PositionMsg: public NMLmsg 
{
  /* The constructor needs to store the id number  */
  /* and the size of the new structure */
  /* by passing them as arguments to the base class constructor. */
  PositionMsg(): 
    NMLmsg(POSITION_MSG_TYPE, sizeof(PositionMsg)){};

  /* Each new type needs to overload the update function. */
  void update(CMS *cms); 

  /* Data in this new message format. */
  double x;
  double y;
  double theta;

};

/* Declare the NML Format function. */
int nmlPosition_format(NMLTYPE type, void *buf, CMS *cms);


#endif /* End of NML_EMC_HH */
