#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#include <string.h>
#include "ulapi.h"
#include "simware.h"
#include "skin.h"

int skin_load(skin_struct *skin, char *object_name)
{
#define ERRSTR_LEN 80
  char errstr[ERRSTR_LEN];

  skin->handle = ulapi_dl_open(object_name, errstr, ERRSTR_LEN);
  if (NULL == skin->handle) {
    fprintf(stderr, "can't load %s: %s\n", object_name, errstr);
    return 1;
  }

#define DLSYM(FUNC,NAME)						\
  *(void **) (&FUNC) = ulapi_dl_sym(skin->handle, NAME, errstr, ERRSTR_LEN); \
  if (0 != errstr[0]) {							\
    fprintf(stderr, "can't look up %s: %s", NAME, errstr);		\
    ulapi_dl_close(skin->handle);					\
    skin->handle = NULL;						\
    return -1;								\
  }

  DLSYM(skin->init, "init");
  DLSYM(skin->ask, "ask");
  DLSYM(skin->tell, "tell");
  DLSYM(skin->fini, "fini");

  return 0;
#undef DLSYM
#undef ERRSTR_LEN
}

int skin_unload(skin_struct *skin)
{
  if (NULL != skin->handle) {
    ulapi_dl_close(skin->handle);
    skin->handle = NULL;
  }

  return 0;
}
