#include "swKBUtils.hh"

double dMod(double a, double b)
{
  int result = static_cast<int>( a / b );
  return a - static_cast<double>( result ) * b;
}

double ZeroTo2PI(double rad)
{
  double nRad;
  nRad= dMod(rad,PM_2_PI);
  if( nRad < 0 )
    nRad = nRad + PM_2_PI;
  return nRad;
}

void 
Tokenize(const string& str,
	 vector<string>& tokens,
	 const string& delimiters)
{
  // Skip delimiters at beginning.
  string::size_type lastPos = str.find_first_not_of(delimiters, 0);
  // Find first "non-delimiter".
  string::size_type pos     = str.find_first_of(delimiters, lastPos);
  
  while (string::npos != pos || string::npos != lastPos)
    {
      // Found a token, add it to the vector.
      tokens.push_back(str.substr(lastPos, pos - lastPos));
      // Skip delimiters.  Note the "not_of"
      lastPos = str.find_first_not_of(delimiters, pos);
      // Find next "non-delimiter"
      pos = str.find_first_of(delimiters, lastPos);
    }
}

void
Tokenize2 (string & str, vector < string > &tokens, const string & delimiters)
{
  string subStr;
  // Clear vector if not empty
  if (!tokens.empty ())
    tokens.clear ();
  // Skip delimiters at beginning.
  string::size_type lastPos = str.find_first_not_of (delimiters, 0);
  // Find first "non-delimiter".
  string::size_type pos = str.find_first_of (delimiters, lastPos);

  while (string::npos != pos)
    {
      // Found a token, add it to the vector.
      tokens.push_back (str.substr (lastPos, pos - lastPos));
      // Skip delimiters.  Note the "not_of"
      lastPos = str.find_first_not_of (delimiters, pos);
      // Find next "non-delimiter"
      pos = str.find_first_of (delimiters, lastPos);
    }
  // if characters remain and are not delimited that put in string 
  if (lastPos != string::npos)
    str = str.substr (lastPos);
  // else clear string 
  else
    str.clear ();
}

int
nocase_cmp (const string & s1, const string & s2)
{
  string::const_iterator it1 = s1.begin ();
  string::const_iterator it2 = s2.begin ();

  //has the end of at least one of the strings been reached?
  while ((it1 != s1.end ()) && (it2 != s2.end ()))
    {
      if (::toupper (*it1) !=::toupper (*it2))	//letters differ?
	// return -1 to indicate 'smaller than', 1 otherwise
	return (::toupper (*it1) < ::toupper (*it2)) ? -1 : 1;
      //proceed to the next character in each string
      ++it1;
      ++it2;
    }
  size_t size1 = s1.size (), size2 = s2.size ();	// cache lengths
  //return -1,0 or 1 according to strings' lengths
  if (size1 == size2)
    return 0;
  return (size1 < size2) ? -1 : 1;
}

void
dumpTokens (const vector < string > &toks)
{
  printf ("Dump Tokens : size : %d | cap : %d\n",
	  (int) toks.size (), (int) toks.capacity ());
  for (unsigned i = 0; i < toks.size (); i++)
    printf ("\t%s\n", toks[i].c_str ());
}


int findToken(const vector <string> &toks, string str, unsigned int i)
{
  int rVal = -1;
  //for(unsigned int i=0;i<toks.size();i++)
  for(;i<toks.size();i++)
    {
      if ( ! nocase_cmp (toks[i], str) )
	rVal = i;
    }
  return rVal;
}
