#ifndef SIMWARE_KB_WORLD_HH
#define SIMWARE_KB_WORLD_HH


//! C++ STL Headers
//#include <iostream>
#include <string>
//#include <sstream>
//#include <vector>
#include <map>
using namespace std;

//! C Headers
#include <stdlib.h>

//! RCS Headers
#include <posemath.h>
#include <inifile.h>
#include "swKBUtils.hh"


class SIMwareKBWorld {
private:
  string wName;
  string sPoseName;
  map<string, PM_POSE> sPoseMap;
  PM_POSE sPoseOffset;
  PM_POSE startPose;

public:
  //! Constructor
  SIMwareKBWorld();
  ~SIMwareKBWorld();
  
  void dumpWorldInfo();
  
  void setWorldName(string);
  string getWorldName();
  int insertStartPose(string, PM_POSE);
  string getStartPoseName(int=0);
  void setStartPoseOffset(PM_POSE);
  int setStartPose(string="default");
  PM_POSE getStartPose();  
};

#endif
