/*****************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*****************************************************************************/
/*!
  \file   exampleScrollBox.hh
  \brief  Contains a header file for an example of using ScrollingBox
*/

/*

Applications should use the #define VOXEL_NAME line and the two
#include lines shown below in the order shown, with exampleVoxel and
exampleVoxel.hh changed to the name of a voxel class and the name of a
header file defining the voxel class.

Also see documentation in exampleScrollBox.cc, scrollingBox.hh, and
scrollingBox.cc

 */

#ifndef __exampleScrollBox_hh
#define __exampleScrollBox_hh

#define VOXEL_NAME exampleVoxel
#include "exampleVoxel.hh"
#include "scrollingBox.hh"

#endif
