/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.hh"
#include "support.hh"
#include <stdio.h>		// fprintf
#include <unistd.h> // getopt
#include <stdlib.h> // atoi
#include <rcs.hh>
#include "sectMobPL.hh"
#include "moastError.hh"

// forward decs
void init(GtkWidget *window);

// globals
RCS_STAT_CHANNEL *statNml;
NML *nmlNML;
int command;
int status;
GtkWidget *globalWindow;

int
main (int argc, char *argv[])
{
  char c;
  GdkColor greenColor;
  char *buffer = "sectMobPLStat1";
  char *configNml = getenv("CONFIG_NML");
  char *myName = "notifier";
  GtkWidget *window1;

  command = SECT_MOB_PL_CMD_CRASH_TYPE;
  status = RCS_DONE;

  greenColor.red = 0;
  greenColor.green = 65535;
  greenColor.blue = 0;

  if(!configNml)
    {
      fprintf(stderr,"Please set CONFIG_NML environment variable.\n");
      return(false);
    }
  while((c=getopt(argc,argv,"b:c:s:"))!=EOF) 
    {
      switch(c) 
	{
	case 'b':
	  buffer = optarg;
	  break;
	case 'c':
	  command = atoi(optarg);
	  break;
	case 's':
	  status = atoi(optarg);
	  break;
	}
    }

  if( strncmp("sectMobPLStat", buffer, 13) == 0 )
    {
      nmlNML = NULL;
      statNml = new RCS_STAT_CHANNEL( sectMobPL_format, buffer,
					       myName,
					       configNml );
      if( NULL == statNml || !statNml->valid() )
	{
	  rcs_print_error( "%s: Error - Can't open %s buffer\n",
			   myName, buffer );
	  return(false);
	}
    }
  else if( strncmp("moastError", buffer, 10) == 0 )
    {
      statNml = NULL;
      nmlNML = new NML( moastError_format, buffer,
			myName,
			configNml );
      if( NULL == nmlNML || !nmlNML->valid() )
	{
	  rcs_print_error( "%s: Error - Can't open %s buffer\n",
			   myName, buffer );
	  return(false);
	}
    }
  else
    {
      printf( "unknown buffer type: %s\n", buffer );
      return(false);
    }

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  //  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  globalWindow = window1;
  gtk_widget_modify_bg( window1, GTK_STATE_NORMAL, &greenColor );
  gtk_widget_show (window1);

  init(window1);
  gtk_main ();
  return 0;
}

