/* test program for polygon intersection
 */
#include "sweep.hh"

typedef struct
{
  vector<LineSegment>segments;
  Location2D lowerLeft;
  Location2D upperRight;
  int polygonID;
}ObsPolygon;

int main(int argc, char **argv)
{
  LineSegment l1;
  Location2D point;
  Sweep sweep;
  list<LinePoint>::iterator i;
  list<int>::iterator j;
  vector<LineSegment>::iterator k;
  list<Location2D>::iterator jj;
  LabelSeq labelseq;
  int polygonNumber, fileNo;
  int linePtSize, sizeRead;
  double xOffset, yOffset, zOffset;
  double xData, yData, xDataOld, yDataOld;
  bool dataSet;
  double amResolution = .1;
  char *linePt = NULL;
  FILE *fp;
  list<ObsPolygon> fileA, fileB;
  ObsPolygon newPoly;
  //  LineSegment *myLine;
  //  int myInt;

  if( argc != 3 )
    {
      printf( "usage: %s <file1> <file2>\n", argv[0] );
      return(0);
    }
  
  polygonNumber = 0;
  // needed to get rid of getline
  linePtSize = 300;
  linePt = new char[linePtSize];
  if(linePt == NULL )
    {
      printf( "unable to allocate string storage\n");
      return(-1);
    }
  // end of getline stuff

  for( fileNo=0; fileNo<2; fileNo++ )
    {
      polygonNumber++;
      newPoly.polygonID = polygonNumber;
      newPoly.segments.clear();
      printf( "Opening file %d\n", fileNo );
      //      printf( "Polygon %d\n", polygonNumber );
      fp = fopen( argv[fileNo+1], "r" );
      if( fp==NULL )
	{
	  printf( "Unable to open input file\n" );
	  return -1;
	}
      //      getline(&linePt, (size_t*)&linePtSize, fp);
      fgets(linePt, linePtSize, fp);
      sscanf( linePt, "%lf %lf %lf", &xOffset, &yOffset, &zOffset );
      xOffset /= amResolution;
      yOffset /= amResolution;
      dataSet = false;
      //      while( (sizeRead=getline(&linePt, (size_t *)&linePtSize, fp)) != -1 )
      while( (fgets(linePt, linePtSize, fp)) != NULL )
	{
	  sizeRead = strlen(linePt);
	  if( sizeRead == 1 )
	    {
	      fprintf( stdout, "\n" );
	      dataSet = false;
	      polygonNumber++;
	      if( fileNo == 0 )
		fileA.push_back(newPoly);
	      else
		fileB.push_back(newPoly);
	      newPoly.segments.clear();
	      newPoly.polygonID = polygonNumber;
	      //	      printf( "Polygon %d\n", polygonNumber );
	    }
	  else
	    {
	      sscanf( linePt, "%lf %lf", &xData, &yData );
	      xData += yOffset;
	      yData += xOffset;
	      fprintf( stdout, "%.2f %.2f\n", xData, yData );
	      if( dataSet )
		{
		  if( xDataOld < xData )
		    l1 = LineSegment( xDataOld, yDataOld, xData, yData );
		  else if( xDataOld == xData )
		    if( yDataOld > yData )
		      l1 = LineSegment( xDataOld, yDataOld, xData, yData );
		    else
		      l1 = LineSegment( xData, yData, xDataOld, yDataOld );
		  else
		    l1 = LineSegment( xData, yData, xDataOld, yDataOld );

		  l1.properties = polygonNumber;
		  newPoly.segments.push_back(l1);
		  //		  sweep.segments.push_back(l1);
		}
	      else
		dataSet = true;
	      xDataOld = xData;
	      yDataOld = yData;
	    }
	}
      fclose( fp );
    }

  printf( "read %d in file 0 and %d in file 1\n", (int)fileA.size(), (int)fileB.size() );
  return 0;

  // insert lines
  /*
  l1 = LineSegment( .5, 1, 3, 2 );
  l1.properties = 1;
  sweep.segments.push_back(l1);

  l1 = LineSegment( .75, 2, 1.75, 0 );
  l1.properties = 2;
  sweep.segments.push_back(l1);

  l1 = LineSegment( 1, 3, 1.5, 0 );
  l1.properties = 3;
  sweep.segments.push_back(l1);

  l1 = LineSegment( 2, 3, 3.5, 0 );
  l1.properties = 4;
  sweep.segments.push_back(l1);
  */
  for( k=sweep.segments.begin(); k!=sweep.segments.end(); k++ )
    {
      point = (*k).start;
      sweep.pointList.push_back(point);
      point = (*k).end;
      sweep.pointList.push_back(point);
    }

  /*
  printf( "points from main program\n" );
  for( i=sweep.pointList.begin(); i!=sweep.pointList.end(); i++ )
    {
      myLine = (LineSegment*)((*i).myLine);
      if( i->isStart )
	{
	  printf( "0x%x: <%d>\n", (int)myLine, (int)myLine );
	  printf( "\tstart x: %f y: %f\n", myLine->start.north, myLine->start.east );
	}
      else
	printf( "\tend   x: %f y: %f\n", myLine->end.north, myLine->end.east );
    }

  if( sweep.intersect( &sweep.segments[0], &sweep.segments[1] ) )
    printf( "lines intersect, correct answer!\n" );
  else
    printf( "lines do not intersect, incorrect answer :(\n" );

  if( sweep.intersect( &sweep.segments[0], &sweep.segments[2] ) )
    printf( "lines intersect, incorrect answer :(\n" );
  else
    printf( "lines do not intersect, correct answer!\n" );
  */

  printf( "Lines into intersect algorithm:\n" );
  for( k=sweep.segments.begin(); k!=sweep.segments.end(); k++ )
    {
      (*k).print();
    }

  /*
  printf( "points:\n" );
  for( jj=sweep.pointList.begin(); jj!=sweep.pointList.end(); jj++ )
    {
      printf( "%f %f\n", (*jj).north, (*jj).east);
    }
  */
  sweep.anyIntersections();
  /*
  for( i=sweep.pointList.begin(); i!=sweep.pointList.end(); i++ )
    if( i->isStart )
      printf( "start x: %f y: %f\n", i->myLine->start.north, i->myLine->start.east );
    else
      printf( "end   x: %f y: %f\n", i->myLine->end.north, i->myLine->end.east );

  printf( "Sort...\n" );
  sweep.pointList.sort();
  for( i=sweep.pointList.begin(); i!=sweep.pointList.end(); i++ )
    if( i->isStart )
      printf( "start x: %f y: %f\n", i->myLine->start.north, i->myLine->start.east );
    else
      printf( "end   x: %f y: %f\n", i->myLine->end.north, i->myLine->end.east );

  */



  // test label sequence
  /*
  myInt = (int)((LinePoint*)(sweep.pointList.begin())->myLine);
  labelseq.seqInsert(labelseq.labels.begin(), myInt );

  myInt = (int)((LinePoint*)(sweep.pointList.end())->myLine);
  labelseq.seqInsert(labelseq.labels.begin(), myInt );

  printf( "Label seq should be:\n" );
  printf( "0x%x,  0x%x\n",
	  (int)((LinePoint*)(sweep.pointList.end())->myLine),
	  (int)((LinePoint*)(sweep.pointList.begin())->myLine));
  printf( "Actual seq is:\n" );
  for( j=labelseq.labels.begin(); j!=labelseq.labels.end(); j++ )
    printf( "0x%x, ", (int)(*j) );
  printf( "\n" );
  */
}
